-- hds header_start
--
-- VHDL Entity CERC_be_fed.APV_frame_gen.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:36:16 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


entity APV_frame_gen is
   port( 
      clk       : in     std_logic;
      en        : in     std_logic;
      rst       : in     std_logic;
      APV_frame : out    std_logic;
      ana_dat   : out    std_logic
   );

-- Declarations

end APV_frame_gen ;


-- hds interface_end

--
-- VHDL Architecture CERC_be_fed.APV_frame_gen.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:36:16 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY exemplar;
USE exemplar.exemplar_1164.all;

-- synopsys translate_off
-- LIBRARY unisim;
-- USE unisim.all;
-- synopsys translate_on

architecture fsm of APV_frame_gen is

   -- Architecture Declarations
   signal cnt: std_logic_vector (7 downto 0);

   type state_type is (
      s0,
      s2,
      s3,
      s5,
      s6,
      s8,
      s9,
      s11,
      s12,
      s14,
      s15,
      s17,
      s18,
      s19,
      s20,
      s21,
      s22,
      s24,
      s25,
      s26
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal APV_frame_int : std_logic  ;
   signal ana_dat_int : std_logic  ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk,
      rst
   )
   ----------------------------------------------------------------------------
   begin
      if (rst = '1') then
         current_state <= s0;
         -- Reset Values
         APV_frame <= '0';
         ana_dat <= '0';
         cnt <= "00000000";
      elsif (clk'event and clk = '1') then
         if (en = '1') then
            current_state <= next_state;
            -- Registered output assignments
            APV_frame <= APV_frame_int;
            ana_dat <= ana_dat_int;

            -- Default Assignment To Internals

            -- Transition Actions for internal signals only
            case current_state is
            when s0 =>
               if (rst = '0') then
                  cnt <= "00000000";
               end if;
            when s2 =>
               if (cnt = "01000100") then
               else
                  cnt <= cnt + "1";
               end if;
            when s3 =>
               cnt <= "00000000";
            when s5 =>
               if (cnt = "01000100") then
               else
                  cnt <= cnt + "1";
               end if;
            when s6 =>
               cnt <= "00000000";
            when s8 =>
               if (cnt = "01000100") then
               else
                  cnt <= cnt + "1";
               end if;
            when s9 =>
               cnt <= "00000000";
            when s11 =>
               if (cnt = "01000100") then
               else
                  cnt <= cnt + "1";
               end if;
            when s12 =>
               cnt <= "00000000";
            when s14 =>
               if (cnt = "01000100") then
               else
                  cnt <= cnt + "1";
               end if;
            when s15 =>
               cnt <= "00000000";
            when s17 =>
               if (cnt = "00000011") then
               else
                  cnt <= cnt + "1";
               end if;
            when s18 =>
               if (cnt = "00000110") then
               else
                  cnt <= cnt + "1";
               end if;
            when s19 =>
               if (cnt = "00001001") then
               else
                  cnt <= cnt + "1";
               end if;
            when s20 =>
               if (cnt = "00010000") then
               else
                  cnt <= cnt + "1";
               end if;
            when s21 =>
               cnt <= "00000000";
            when s22 =>
               cnt <= "00000000";
            when s24 =>
               if (cnt = "11111111") then
               else
                  cnt <= cnt + "1";
               end if;
            when s26 =>
               cnt <= "00000000";
            when others =>
               null;
            end case;

         end if;
      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      cnt,
      current_state,
      rst
   )
   ----------------------------------------------------------------------------
   begin
      if current_state = s0 and (rst = '0') then
         next_state <= s2;
      elsif current_state = s0 then
         next_state <= s0;
      elsif current_state = s2 and (cnt = "01000100") then
         next_state <= s3;
      elsif current_state = s2 then
         next_state <= s2;
      elsif current_state = s3 then
         next_state <= s5;
      elsif current_state = s5 and (cnt = "01000100") then
         next_state <= s6;
      elsif current_state = s5 then
         next_state <= s5;
      elsif current_state = s6 then
         next_state <= s8;
      elsif current_state = s8 and (cnt = "01000100") then
         next_state <= s9;
      elsif current_state = s8 then
         next_state <= s8;
      elsif current_state = s9 then
         next_state <= s11;
      elsif current_state = s11 and (cnt = "01000100") then
         next_state <= s12;
      elsif current_state = s11 then
         next_state <= s11;
      elsif current_state = s12 then
         next_state <= s14;
      elsif current_state = s14 and (cnt = "01000100") then
         next_state <= s15;
      elsif current_state = s14 then
         next_state <= s14;
      elsif current_state = s15 then
         next_state <= s17;
      elsif current_state = s17 and (cnt = "00000011") then
         next_state <= s18;
      elsif current_state = s17 then
         next_state <= s17;
      elsif current_state = s18 and (cnt = "00000110") then
         next_state <= s19;
      elsif current_state = s18 then
         next_state <= s18;
      elsif current_state = s19 and (cnt = "00001001") then
         next_state <= s20;
      elsif current_state = s19 then
         next_state <= s19;
      elsif current_state = s20 and (cnt = "00010000") then
         next_state <= s21;
      elsif current_state = s20 then
         next_state <= s20;
      elsif current_state = s21 then
         next_state <= s22;
      elsif current_state = s22 then
         next_state <= s24;
      elsif current_state = s24 and (cnt = "11111111") then
         next_state <= s25;
      elsif current_state = s24 then
         next_state <= s24;
      elsif current_state = s25 then
         next_state <= s26;
      elsif current_state = s26 then
         next_state <= s2;
      else
         next_state <= s0;
      end if;

   end process nextstate;

   ----------------------------------------------------------------------------
   output : process (
      cnt,
      current_state
   )
   ----------------------------------------------------------------------------
   begin
      -- Default Assignment
      APV_frame_int <= '0';
      ana_dat_int <= '0';
      -- Default Assignment To Internals

      -- State Actions
      case current_state is

      when s2 =>

         APV_frame_int <= '0';
      when s3 =>

         APV_frame_int <= '1';
      when s5 =>

         APV_frame_int <= '0';
      when s6 =>

         APV_frame_int <= '1';
      when s8 =>

         APV_frame_int <= '0';
      when s9 =>

         APV_frame_int <= '1';
      when s11 =>

         APV_frame_int <= '0';
      when s12 =>

         APV_frame_int <= '1';
      when s14 =>

         APV_frame_int <= '0';
      when s15 =>

         APV_frame_int <= '1';
      when s17 =>

         APV_frame_int <= '1';
      when s18 =>

         APV_frame_int <= '0';
      when s19 =>

         APV_frame_int <= '1';

      when s21 =>

         APV_frame_int <= '1';


      when s25 =>

         APV_frame_int <= '1';
      when s26 =>

         APV_frame_int <= '1';
      when others =>
         null;
      end case;

      -- State Actions Clocked On Next State
      -- Transition Actions
      case current_state is
      when s2 =>
         if (cnt = "01000100") then
            APV_frame_int <= '1';
         end if;
      when s5 =>
         if (cnt = "01000100") then
            APV_frame_int <= '1';
         end if;
      when s8 =>
         if (cnt = "01000100") then
            APV_frame_int <= '1';
         end if;
      when s11 =>
         if (cnt = "01000100") then
            APV_frame_int <= '1';
         end if;
      when s14 =>
         if (cnt = "01000100") then
            APV_frame_int <= '1';
         end if;
      when s17 =>
         if (cnt = "00000011") then
            APV_frame_int <= '1';
         end if;
      when s18 =>
         if (cnt = "00000110") then
            APV_frame_int <= '0';
         end if;
      when s19 =>
         if (cnt = "00001001") then
            APV_frame_int <= '1';
         end if;
      when s20 =>
         if (cnt = "00010000") then
            APV_frame_int <= '0';
         end if;
      when s21 =>
         APV_frame_int <= '1';
      when s22 =>
         APV_frame_int <= '1';
      when s24 =>
         if (cnt = "11111111") then
            ana_dat_int <= '1';
         else
            ana_dat_int <= '1';
         end if;
      when others =>
         null;
      end case;

   end process output;

   -- Concurrent Statements

end fsm;
