-- hds header_start
--
-- VHDL Entity CERC_be_fed.clk_generation.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:34:17 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;
use ieee.std_logic_unsigned.ALL;

entity clk_generation is
   port( 
      clk_lvds_vme      : in     std_logic;
      clk_lvds_vme_b    : in     std_logic;
      rst               : in     std_logic;
      sw_reset          : in     std_logic;
      ttc_clk40         : in     std_logic;
      ttc_clk40_des1    : in     std_logic;
      ttc_clk40_des2    : in     std_logic;
      FE_lvds_clk       : out    std_logic_vector (8 downto 1);
      FE_lvds_clk_B     : out    std_logic_vector (8 downto 1);
      FE_reset          : out    std_logic;
      clk1x             : out    std_logic;
      clk1x_n           : out    STD_ULOGIC;
      clk2x             : out    std_logic;
      clk2x_n           : out    STD_ULOGIC;
      clk_lvds_ttc      : out    std_logic;
      clk_lvds_ttc_b    : out    std_logic;
      ext_qdr_clk_c     : out    std_logic;
      ext_qdr_clk_c_bar : out    std_logic;
      locked_all_clks   : out    std_logic;
      qdr_clk_k         : out    std_logic;
      qdr_clk_k_bar     : out    std_logic;
      reset             : out    std_logic;
      vme_link_clk      : out    std_logic;
      vme_link_clk_n    : out    std_logic
   );

-- Declarations

end clk_generation ;


-- hds interface_end

--
-- VHDL Architecture CERC_be_fed.clk_generation.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:35:03 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;

library unisim;

architecture struct of clk_generation is

   -- Architecture declarations
   attribute CLK_FEEDBACK : string;
      attribute CLKDV_DIVIDE : real;
      attribute CLKFX_DIVIDE : integer;
      attribute CLKFX_MULTIPLY : integer;
      attribute CLKIN_DIVIDE_BY_2 : boolean;
      attribute CLKIN_PERIOD : real;
      attribute CLKOUT_PHASE_SHIFT : string;
      attribute DESKEW_ADJUST : string;
      attribute DFS_FREQUENCY_MODE : string;
      attribute DLL_FREQUENCY_MODE : string;
      attribute DUTY_CYCLE_CORRECTION : boolean;
      attribute PHASE_SHIFT : integer;
      attribute STARTUP_WAIT : boolean;

   -- Internal signal declarations
   signal CLK_1X           : std_logic  := '0';
   signal CLK_1X180        : std_ulogic := '0';
   signal CLK_2X           : std_logic  := '0';
   signal CLK_2X180        : std_ulogic := '0';
   signal CLK_2X_90        : std_logic  := '0';
   signal LOCKED_qdr_clk_c : std_ulogic := '0';
   signal LOCKED_vlink_clk : std_ulogic := '0';
   signal clk1x_temp       : std_logic_vector(8 downto 1);
   signal clk1x_to_FE      : std_logic_vector(8 downto 1);
   signal clk2x_90         : std_logic;
   signal clk_lvds_vme1    : std_logic;
-- Template for Synopsys DC constraints
-- pragma dc_script_begin
--
-- pragma dc_script_end
--
-- VHDL Attribute Template
--attribute <name> of <object> : <class> is <value>;


   signal dcm_x2_fb        : std_logic;
   signal dcm_x2_int       : std_ulogic := '0';
   signal high             : std_logic  := '0';
   signal inv_fb_c_clk_1   : std_logic;
   signal inv_fb_c_clk_2   : std_logic;
   signal inv_fb_k_clk_1   : std_logic;
   signal inv_fb_k_clk_2   : std_logic;
   signal locked_1_b       : std_logic;
   signal locked_clk2x     : std_logic  := '0';
   signal locked_clk4x     : std_logic;
   signal locked_clk4x_n   : std_logic;
   signal low              : std_logic  := '0';
   signal qdr_clk_c        : std_logic;
   signal qdr_clk_c_int    : std_logic;
   signal vlink_clk_int    : std_logic;
   signal vme_clk_int_n    : std_ulogic := '0';

   -- Implicit buffer signal declarations
   signal clk1x_internal           : std_logic;
   signal clk2x_internal           : std_logic;
   signal locked_all_clks_internal : std_logic;
   signal reset_internal           : std_logic;
   signal clk2x_n_internal         : STD_ULOGIC;


   -- Component Declarations
   component AND2
   port (
      I0 : in     STD_ULOGIC;
      I1 : in     STD_ULOGIC;
      O  : out    STD_ULOGIC
   );
   end component;
   component DCM
   generic (
      DFS_FREQUENCY_MODE    : string;
      DLL_FREQUENCY_MODE    : string;
      DUTY_CYCLE_CORRECTION : boolean;
      CLKIN_DIVIDE_BY_2     : boolean;
      CLK_FEEDBACK          : string;
      CLKOUT_PHASE_SHIFT    : string;
      DSS_MODE              : string;
      PHASE_SHIFT           : integer;
      CLKFX_MULTIPLY        : integer;
      CLKFX_DIVIDE          : integer;
      CLKDV_DIVIDE          : real;
      CLKIN_PERIOD          : real;
      DESKEW_ADJUST         : string
   );
   port (
      CLKFB    : in     std_ulogic                    := '0';
      CLKIN    : in     std_ulogic                    := '0';
      DSSEN    : in     std_ulogic                    := '0';
      PSCLK    : in     std_ulogic                    := '0';
      PSEN     : in     std_ulogic                    := '0';
      PSINCDEC : in     std_ulogic                    := '0';
      RST      : in     std_ulogic                    := '0';
      CLK0     : out    std_ulogic                    := '0';
      CLK180   : out    std_ulogic                    := '0';
      CLK270   : out    std_ulogic                    := '0';
      CLK2X    : out    std_ulogic                    := '0';
      CLK2X180 : out    std_ulogic                    := '0';
      CLK90    : out    std_ulogic                    := '0';
      CLKDV    : out    std_ulogic                    := '0';
      CLKFX    : out    std_ulogic                    := '0';
      CLKFX180 : out    std_ulogic                    := '0';
      LOCKED   : out    std_ulogic                    := '0';
      PSDONE   : out    std_ulogic                    := '0';
      STATUS   : out    std_logic_vector (7 downto 0) := "00000000"
   );
   end component;
-- Template for Synopsys DC constraints
-- pragma dc_script_begin
--
-- pragma dc_script_end
--
-- VHDL Attribute Template
--attribute <name> of <object> : <class> is <value>;

   attribute CLK_FEEDBACK of dcm_vlink: label is "1X";
   attribute CLKDV_DIVIDE of dcm_vlink: label is 2.0;
   attribute CLKFX_DIVIDE of dcm_vlink: label is 1;
   attribute CLKFX_MULTIPLY of dcm_vlink: label is 4;
   attribute CLKIN_DIVIDE_BY_2 of dcm_vlink: label is FALSE;
   attribute CLKIN_PERIOD of dcm_vlink: label is 24.0;
   attribute CLKOUT_PHASE_SHIFT of dcm_vlink: label is "FIXED";
   attribute DESKEW_ADJUST of dcm_vlink: label is "SYSTEM_SYNCHRONOUS";
   attribute DFS_FREQUENCY_MODE of dcm_vlink: label is "LOW";
   attribute DLL_FREQUENCY_MODE of dcm_vlink: label is "LOW";
   attribute DUTY_CYCLE_CORRECTION of dcm_vlink: label is TRUE;
   attribute PHASE_SHIFT of dcm_vlink: label is -22;
   attribute STARTUP_WAIT of dcm_vlink: label is FALSE;


   -- Template for Synopsys DC constraints
-- pragma dc_script_begin
--
-- pragma dc_script_end
--
-- VHDL Attribute Template
--attribute <name> of <object> : <class> is <value>;

   attribute CLK_FEEDBACK of dcm_x1_x2 : label is "1X";
   attribute CLKDV_DIVIDE of dcm_x1_x2 : label is 2.0;
   attribute CLKFX_DIVIDE of dcm_x1_x2 : label is 1;
   attribute CLKFX_MULTIPLY of dcm_x1_x2 : label is 4;
   attribute CLKIN_DIVIDE_BY_2 of dcm_x1_x2 : label is FALSE;
   attribute CLKIN_PERIOD of dcm_x1_x2 : label is 24.0;
   attribute CLKOUT_PHASE_SHIFT of dcm_x1_x2 : label is "NONE";
   attribute DESKEW_ADJUST of dcm_x1_x2 : label is "SYSTEM_SYNCHRONOUS";
   attribute DFS_FREQUENCY_MODE of dcm_x1_x2 : label is "LOW";
   attribute DLL_FREQUENCY_MODE of dcm_x1_x2 : label is "LOW";
   attribute DUTY_CYCLE_CORRECTION of dcm_x1_x2 : label is TRUE;
   attribute PHASE_SHIFT of dcm_x1_x2 : label is 0;
   attribute STARTUP_WAIT of dcm_x1_x2 : label is FALSE;

   -- Template for Synopsys DC constraints
-- pragma dc_script_begin
--
-- pragma dc_script_end
--
-- VHDL Attribute Template
--attribute <name> of <object> : <class> is <value>;

   attribute CLK_FEEDBACK of dcm_x4 : label is "1X";
   attribute CLKDV_DIVIDE of dcm_x4 : label is 2.0;
   attribute CLKFX_DIVIDE of dcm_x4 : label is 1;
   attribute CLKFX_MULTIPLY of dcm_x4 : label is 4;
   attribute CLKIN_DIVIDE_BY_2 of dcm_x4 : label is FALSE;
   attribute CLKIN_PERIOD of dcm_x4 : label is 12.0;
   attribute CLKOUT_PHASE_SHIFT of dcm_x4 : label is "NONE";
   attribute DESKEW_ADJUST of dcm_x4 : label is "SYSTEM_SYNCHRONOUS";
   attribute DFS_FREQUENCY_MODE of dcm_x4 : label is "LOW";
   attribute DLL_FREQUENCY_MODE of dcm_x4 : label is "LOW";
   attribute DUTY_CYCLE_CORRECTION of dcm_x4 : label is TRUE;
   attribute PHASE_SHIFT of dcm_x4 : label is 0;
   attribute STARTUP_WAIT of dcm_x4 : label is FALSE;


   -- Template for Synopsys DC constraints
-- pragma dc_script_begin
--
-- pragma dc_script_end
--
-- VHDL Attribute Template
--attribute <name> of <object> : <class> is <value>;

   attribute CLK_FEEDBACK of dcm_qdr_rd : label is "1X";
   attribute CLKDV_DIVIDE of dcm_qdr_rd : label is 2.0;
   attribute CLKFX_DIVIDE of dcm_qdr_rd : label is 1;
   attribute CLKFX_MULTIPLY of dcm_qdr_rd : label is 4;
   attribute CLKIN_DIVIDE_BY_2 of dcm_qdr_rd : label is FALSE;
   attribute CLKIN_PERIOD of dcm_qdr_rd : label is 24.0;
   attribute CLKOUT_PHASE_SHIFT of dcm_qdr_rd : label is "FIXED";
   attribute DESKEW_ADJUST of dcm_qdr_rd : label is "SYSTEM_SYNCHRONOUS";
   attribute DFS_FREQUENCY_MODE of dcm_qdr_rd : label is "LOW";
   attribute DLL_FREQUENCY_MODE of dcm_qdr_rd : label is "LOW";
   attribute DUTY_CYCLE_CORRECTION of dcm_qdr_rd : label is TRUE;
   attribute PHASE_SHIFT of dcm_qdr_rd : label is 22;
   attribute STARTUP_WAIT of dcm_qdr_rd : label is FALSE;


   component IBUFGDS_LVDS_33
   port (
      I  : in     STD_ULOGIC;
      IB : in     STD_ULOGIC;
      O  : out    STD_ULOGIC
   );
   end component;
   component OBUFDS_LVDS_33
   port (
      I  : in     STD_ULOGIC;
      O  : out    STD_ULOGIC;
      OB : out    STD_ULOGIC
   );
   end component;
   component bufg
   port (
      I : in     STD_ULOGIC;
      O : out    STD_ULOGIC
   );
   end component;
   component fddrcpe
   port (
      C0  : in     STD_ULOGIC;
      C1  : in     STD_ULOGIC;
      CE  : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D0  : in     STD_ULOGIC;
      D1  : in     STD_ULOGIC;
      PRE : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component inv
   port (
      I : in     STD_ULOGIC;
      O : out    STD_ULOGIC
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : AND2 use entity unisim.AND2;
   for all : DCM use entity unisim.DCM;
   for all : IBUFGDS_LVDS_33 use entity unisim.IBUFGDS_LVDS_33;
   for all : OBUFDS_LVDS_33 use entity unisim.OBUFDS_LVDS_33;
   for all : bufg use entity unisim.bufg;
   for all : fddrcpe use entity unisim.fddrcpe;
   for all : inv use entity unisim.inv;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   reset_internal <= (NOT (locked_all_clks_internal) 
   OR sw_reset)  after 2 ns;

   -- HDL Embedded Text Block 3 eb3
   FE_reset <= NOT (locked_all_clks_internal) after 2 ns;


   -- ModuleWare code for instance 'I28' of 'inv'
      inv_fb_c_clk_1 <= not(qdr_clk_c);

   -- ModuleWare code for instance 'I29' of 'inv'
      inv_fb_c_clk_2 <= not(qdr_clk_c);

   -- ModuleWare code for instance 'I10' of 'inv'
      locked_1_b <= not(locked_clk2x);

   -- ModuleWare code for instance 'I19' of 'inv'
      inv_fb_k_clk_1 <= not(clk2x_90);

   -- ModuleWare code for instance 'I27' of 'inv'
      inv_fb_k_clk_2 <= not(clk2x_90);

   -- ModuleWare code for instance 'I13' of 'buff'
   vme_link_clk <= clk2x_internal;

   -- ModuleWare code for instance 'I15' of 'buff'
   vme_link_clk_n <= clk2x_n_internal;

   -- ModuleWare code for instance 'I17' of 'inv'
      locked_clk4x_n <= not(locked_clk4x);

   -- ModuleWare code for instance 'I25' of 'gnd'
      low <= '0';

   -- ModuleWare code for instance 'I11' of 'vdd'
      high <= '1';
   -- Instance port mappings.
   I5 : AND2
      port map (
         O  => locked_all_clks_internal,
         I0 => locked_clk4x,
         I1 => LOCKED_qdr_clk_c
      );
   dcm_vlink : DCM
      generic map (
         DFS_FREQUENCY_MODE    => "LOW",
         DLL_FREQUENCY_MODE    => "LOW",
         DUTY_CYCLE_CORRECTION => TRUE,
         CLKIN_DIVIDE_BY_2     => FALSE,
         CLK_FEEDBACK          => "1X",
         CLKOUT_PHASE_SHIFT    => "FIXED",
         DSS_MODE              => "NONE",
         PHASE_SHIFT           => -22,
         CLKFX_MULTIPLY        => 4,
         CLKFX_DIVIDE          => 1,
         CLKDV_DIVIDE          => 2.0,
         CLKIN_PERIOD          => 24.0,
         DESKEW_ADJUST         => "SYSTEM_SYNCHRONOUS"
      )
      port map (
         CLK0     => vlink_clk_int,
         CLK180   => open,
         CLK270   => open,
         CLK2X    => open,
         CLK2X180 => vme_clk_int_n,
         CLK90    => open,
         CLKDV    => open,
         CLKFX    => open,
         CLKFX180 => open,
         LOCKED   => LOCKED_vlink_clk,
         PSDONE   => open,
         STATUS   => open,
         CLKFB    => open,
         CLKIN    => clk2x_internal,
         DSSEN    => low,
         PSCLK    => low,
         PSEN     => low,
         PSINCDEC => low,
         RST      => locked_1_b
      );
   dcm_x1_x2 : DCM
      generic map (
         DFS_FREQUENCY_MODE    => "LOW",
         DLL_FREQUENCY_MODE    => "LOW",
         DUTY_CYCLE_CORRECTION => TRUE,
         CLKIN_DIVIDE_BY_2     => FALSE,
         CLK_FEEDBACK          => "1X",
         CLKOUT_PHASE_SHIFT    => "NONE",
         DSS_MODE              => "NONE",
         PHASE_SHIFT           => 0,
         CLKFX_MULTIPLY        => 4,
         CLKFX_DIVIDE          => 1,
         CLKDV_DIVIDE          => 2.0,
         CLKIN_PERIOD          => 0.0,
         DESKEW_ADJUST         => "SYSTEM_SYNCHRONOUS"
      )
      port map (
         CLK0     => CLK_1X,
         CLK180   => CLK_1X180,
         CLK270   => open,
         CLK2X    => CLK_2X,
         CLK2X180 => CLK_2X180,
         CLK90    => open,
         CLKDV    => open,
         CLKFX    => open,
         CLKFX180 => open,
         LOCKED   => locked_clk2x,
         PSDONE   => open,
         STATUS   => open,
         CLKFB    => clk1x_internal,
         CLKIN    => clk_lvds_vme1,
         DSSEN    => low,
         PSCLK    => low,
         PSEN     => low,
         PSINCDEC => low,
         RST      => rst
      );
   dcm_x4 : DCM
      generic map (
         DFS_FREQUENCY_MODE    => "LOW",
         DLL_FREQUENCY_MODE    => "LOW",
         DUTY_CYCLE_CORRECTION => TRUE,
         CLKIN_DIVIDE_BY_2     => FALSE,
         CLK_FEEDBACK          => "1X",
         CLKOUT_PHASE_SHIFT    => "NONE",
         DSS_MODE              => "NONE",
         PHASE_SHIFT           => 0,
         CLKFX_MULTIPLY        => 4,
         CLKFX_DIVIDE          => 1,
         CLKDV_DIVIDE          => 2.0,
         CLKIN_PERIOD          => 0.0,
         DESKEW_ADJUST         => "SYSTEM_SYNCHRONOUS"
      )
      port map (
         CLK0     => dcm_x2_int,
         CLK180   => open,
         CLK270   => open,
         CLK2X    => open,
         CLK2X180 => open,
         CLK90    => CLK_2X_90,
         CLKDV    => open,
         CLKFX    => open,
         CLKFX180 => open,
         LOCKED   => locked_clk4x,
         PSDONE   => open,
         STATUS   => open,
         CLKFB    => dcm_x2_fb,
         CLKIN    => clk2x_internal,
         DSSEN    => low,
         PSCLK    => low,
         PSEN     => low,
         PSINCDEC => low,
         RST      => locked_1_b
      );
   dcm_qdr_rd : DCM
      generic map (
         DFS_FREQUENCY_MODE    => "LOW",
         DLL_FREQUENCY_MODE    => "LOW",
         DUTY_CYCLE_CORRECTION => TRUE,
         CLKIN_DIVIDE_BY_2     => FALSE,
         CLK_FEEDBACK          => "1X",
         CLKOUT_PHASE_SHIFT    => "FIXED",
         DSS_MODE              => "NONE",
         PHASE_SHIFT           => 22,
         CLKFX_MULTIPLY        => 4,
         CLKFX_DIVIDE          => 1,
         CLKDV_DIVIDE          => 2.0,
         CLKIN_PERIOD          => 24.0,
         DESKEW_ADJUST         => "SYSTEM_SYNCHRONOUS"
      )
      port map (
         CLK0     => qdr_clk_c_int,
         CLK180   => open,
         CLK270   => open,
         CLK2X    => open,
         CLK2X180 => open,
         CLK90    => open,
         CLKDV    => open,
         CLKFX    => open,
         CLKFX180 => open,
         LOCKED   => LOCKED_qdr_clk_c,
         PSDONE   => open,
         STATUS   => open,
         CLKFB    => qdr_clk_c,
         CLKIN    => clk2x_90,
         DSSEN    => low,
         PSCLK    => low,
         PSEN     => low,
         PSINCDEC => low,
         RST      => locked_clk4x_n
      );
   I6 : IBUFGDS_LVDS_33
      port map (
         O  => clk_lvds_vme1,
         I  => clk_lvds_vme,
         IB => clk_lvds_vme_b
      );
   I4 : OBUFDS_LVDS_33
      port map (
         O  => clk_lvds_ttc,
         OB => clk_lvds_ttc_b,
         I  => ttc_clk40_des1
      );
   I7 : bufg
      port map (
         O => open,
         I => vlink_clk_int
      );
   I9 : bufg
      port map (
         O => open,
         I => vme_clk_int_n
      );
   I0 : bufg
      port map (
         O => qdr_clk_c,
         I => qdr_clk_c_int
      );
   I2 : bufg
      port map (
         O => dcm_x2_fb,
         I => dcm_x2_int
      );
   I14 : bufg
      port map (
         O => clk2x_n_internal,
         I => CLK_2X180
      );
   I1 : bufg
      port map (
         O => clk2x_90,
         I => CLK_2X_90
      );
   I8 : bufg
      port map (
         O => clk2x_internal,
         I => CLK_2X
      );
   I16 : bufg
      port map (
         O => clk1x_n,
         I => CLK_1X180
      );
   I3 : bufg
      port map (
         O => clk1x_internal,
         I => CLK_1X
      );
   I20 : fddrcpe
      port map (
         Q   => qdr_clk_k,
         C0  => clk2x_90,
         C1  => inv_fb_k_clk_2,
         CE  => locked_all_clks_internal,
         D0  => low,
         D1  => high,
         CLR => reset_internal,
         PRE => low
      );
   I26 : fddrcpe
      port map (
         Q   => ext_qdr_clk_c_bar,
         C0  => qdr_clk_c,
         C1  => inv_fb_c_clk_1,
         CE  => locked_all_clks_internal,
         D0  => high,
         D1  => low,
         CLR => reset_internal,
         PRE => low
      );
   I30 : fddrcpe
      port map (
         Q   => ext_qdr_clk_c,
         C0  => qdr_clk_c,
         C1  => inv_fb_c_clk_2,
         CE  => locked_all_clks_internal,
         D0  => low,
         D1  => high,
         CLR => reset_internal,
         PRE => low
      );
   I18 : fddrcpe
      port map (
         Q   => qdr_clk_k_bar,
         C0  => clk2x_90,
         C1  => inv_fb_k_clk_1,
         CE  => locked_all_clks_internal,
         D0  => high,
         D1  => low,
         CLR => reset_internal,
         PRE => low
      );

   g0: FOR i IN 1 TO 8 GENERATE
      I24 : OBUFDS_LVDS_33
         port map (
            O  => FE_lvds_clk(i),
            OB => FE_lvds_clk_B(i),
            I  => clk1x_to_FE(i)
         );
      I21 : fddrcpe
         port map (
            Q   => clk1x_to_FE(i),
            C0  => clk1x_internal,
            C1  => clk1x_temp(i),
            CE  => locked_all_clks_internal,
            D0  => high,
            D1  => low,
            CLR => reset_internal,
            PRE => low
         );
      I12 : inv
         port map (
            O => clk1x_temp(i),
            I => clk1x_internal
         );
   end generate g0;

   -- Implicit buffered output assignments
   clk1x           <= clk1x_internal;
   clk2x           <= clk2x_internal;
   locked_all_clks <= locked_all_clks_internal;
   reset           <= reset_internal;
   clk2x_n         <= clk2x_n_internal;

end struct;
