-- hds header_start
--
-- VHDL Entity CERC_be_fed.deserialiser_15.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:31:47 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity deserialiser_15 is
   port( 
      clk   : in     std_logic;
      data  : in     std_logic;
      en    : in     std_logic;
      reset : in     std_logic;
      Q     : out    std_logic_vector (14 downto 0);
      done  : out    std_logic
   );

-- Declarations

end deserialiser_15 ;


-- hds interface_end

--
-- VHDL Architecture CERC_be_fed.deserialiser_15.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:31:47 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

architecture fsm of deserialiser_15 is

   -- Architecture Declarations
   signal data_count : integer range 0 to 17;
   signal tmp_q : std_logic_vector(16 downto 0);

   type state_type is (
      ser_0,
      ser_2,
      ser_3,
      ser_4,
      ser_1
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal Q_cld : std_logic_vector (14 downto 0) ;
   signal done_cld : std_logic  ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      if (reset = '1') then
         current_state <= ser_0;
         -- Reset Values
         Q_cld <= (others => '0');
         done_cld <= '0';
         data_count <= 0;
         tmp_q <= (others => '0');
      elsif (clk'event and clk = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals

         -- Combined Actions for internal signals only
         case current_state is
         when ser_0 =>
            data_count <= 16;
            done_cld <= '0' ;
            tmp_q <= (others => '0') ;
            -- Q_cld <= (others => '0') ;
         when ser_2 =>
            tmp_q(data_count) <= data;
            data_count <= data_count  - 1;
         when ser_3 =>
            Q_cld <= tmp_q (16 downto 2) ;
            done_cld <= '1' ;
         when ser_4 =>
            done_cld <= '0' ;
            data_count <= 0 ;
         when ser_1 =>
            data_count <= 16;
            done_cld <= '0' ;
            tmp_q <= (others => '0') ;
            -- Q_cld <= (others => '0') ;
         when others =>
            null;
         end case;

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      current_state,
      data,
      data_count,
      en
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when ser_0 =>
         if (en = '1') then
            next_state <= ser_1;
         else
            next_state <= ser_0;
         end if;
      when ser_2 =>
         if (data_count = 2) then
            next_state <= ser_3;
         else
            next_state <= ser_2;
         end if;
      when ser_3 =>
            next_state <= ser_4;
      when ser_4 =>
            next_state <= ser_0;
      when ser_1 =>
         if (data = '1' AND  en = '1') then
            next_state <= ser_2;
         elsif (en = '0') then
            next_state <= ser_0;
         else
            next_state <= ser_1;
         end if;
      when others =>
         next_state <= ser_0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   Q <= Q_cld;
   done <= done_cld;


end fsm;
