-- hds header_start
--
-- VHDL Entity CERC_be_fed.gen_sw_rst.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:35:04 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;

entity gen_sw_rst is
   port( 
      clk1x      : in     std_logic;
      data_valid : in     std_logic;
      rst        : in     std_logic;
      sw_reset1  : in     std_logic;
      sw_reset   : out    std_logic
   );

-- Declarations

end gen_sw_rst ;


-- hds interface_end

--
-- VHDL Architecture CERC_be_fed.gen_sw_rst.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:35:04 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

architecture fsm of gen_sw_rst is

   -- Architecture Declarations
   type state_type is (
      sw_rst0,
      sw_rst1,
      sw_rst2,
      sw_rst3
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal sw_reset_cld : std_logic  ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk1x,
      rst
   )
   ----------------------------------------------------------------------------
   begin
      if (rst = '1') then
         current_state <= sw_rst0;
         -- Reset Values
         sw_reset_cld <= '0';
      elsif (clk1x'event and clk1x = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals
         sw_reset_cld <= '0';

         -- Combined Actions for internal signals only
         case current_state is
         when sw_rst0 =>
            sw_reset_cld <= '0' ;
         when sw_rst1 =>
            sw_reset_cld <= '1' ;
         when sw_rst2 =>
            sw_reset_cld <= '1' ;
         when sw_rst3 =>
            sw_reset_cld <= '1' ;
         when others =>
            null;
         end case;

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      current_state,
      sw_reset1
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when sw_rst0 =>
         if (sw_reset1 = '1') then
            next_state <= sw_rst1;
         else
            next_state <= sw_rst0;
         end if;
      when sw_rst1 =>
            next_state <= sw_rst2;
      when sw_rst2 =>
            next_state <= sw_rst3;
      when sw_rst3 =>
            next_state <= sw_rst0;
      when others =>
         next_state <= sw_rst0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   sw_reset <= sw_reset_cld;


end fsm;
