-- hds header_start
--
-- VHDL Entity CERC_be_fed.gen_tts_lvds.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:35:57 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity gen_tts_lvds is
   port( 
      TTC_reset                : in     std_logic;
      all_flags_empty          : in     std_logic;
      all_full_flags           : in     std_logic;
      all_half_full_flags      : in     std_logic;
      all_partial_empty_flags  : in     std_logic;
      all_partial_full_flags   : in     std_logic;
      clk1x                    : in     std_logic;
      reset                    : in     std_logic;
      tts_j0_busy_out          : out    std_logic;
      tts_j0_out_of_sync_out   : out    std_logic;
      tts_j0_ready_out         : out    std_logic;
      tts_j0_warn_overflow_out : out    std_logic
   );

-- Declarations

end gen_tts_lvds ;


-- hds interface_end

--
-- VHDL Architecture CERC_be_fed.gen_tts_lvds.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:35:57 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

architecture fsm of gen_tts_lvds is

   -- Architecture Declarations
   type state_type is (
      tts_0,
      tts_1,
      tts_2,
      tts_3,
      tts_4,
      tts_5,
      tts_6
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal tts_j0_busy_out_cld : std_logic  ;
   signal tts_j0_out_of_sync_out_cld : std_logic  ;
   signal tts_j0_ready_out_cld : std_logic  ;
   signal tts_j0_warn_overflow_out_cld : std_logic  ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk1x,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      if (reset = '1') then
         current_state <= tts_0;
         -- Reset Values
         tts_j0_busy_out_cld <= '0';
         tts_j0_out_of_sync_out_cld <= '0';
         tts_j0_ready_out_cld <= '0';
         tts_j0_warn_overflow_out_cld <= '0';
      elsif (clk1x'event and clk1x = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals
         tts_j0_busy_out_cld <= '0';
         tts_j0_out_of_sync_out_cld <= '0';
         tts_j0_ready_out_cld <= '0';
         tts_j0_warn_overflow_out_cld <= '0';

         -- Combined Actions for internal signals only
         case current_state is
         when tts_0 =>
            tts_j0_ready_out_cld <= '1' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '0'  after 1 ns;
            tts_j0_busy_out_cld <= '0'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '0'  after 1 ns;
         when tts_1 =>
            tts_j0_ready_out_cld <= '0' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '1'  after 1 ns;
            tts_j0_busy_out_cld <= '0'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '0'  after 1 ns;
         when tts_2 =>
            tts_j0_ready_out_cld <= '0' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '0'  after 1 ns;
            tts_j0_busy_out_cld <= '1'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '0'  after 1 ns;
         when tts_3 =>
            tts_j0_ready_out_cld <= '0' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '0'  after 1 ns;
            tts_j0_busy_out_cld <= '0'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '1'  after 1 ns;
         when tts_4 =>
            tts_j0_ready_out_cld <= '0' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '0'  after 1 ns;
            tts_j0_busy_out_cld <= '1'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '0'  after 1 ns;
         when tts_5 =>
            tts_j0_ready_out_cld <= '0' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '0'  after 1 ns;
            tts_j0_busy_out_cld <= '1'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '0'  after 1 ns;
         when tts_6 =>
            tts_j0_ready_out_cld <= '0' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '0'  after 1 ns;
            tts_j0_busy_out_cld <= '1'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '0'  after 1 ns;
         when others =>
            null;
         end case;

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      TTC_reset,
      all_full_flags,
      all_half_full_flags,
      all_partial_empty_flags,
      all_partial_full_flags,
      current_state,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when tts_0 =>
         if (all_half_full_flags = '1') then
            next_state <= tts_1;
         elsif (TTC_reset = '1') then
            next_state <= tts_4;
         else
            next_state <= tts_0;
         end if;
      when tts_1 =>
         if (all_partial_empty_flags = '0') then
            next_state <= tts_0;
         elsif (all_partial_full_flags = '1') then
            next_state <= tts_2;
         elsif (TTC_reset = '1') then
            next_state <= tts_4;
         else
            next_state <= tts_1;
         end if;
      when tts_2 =>
         if (all_half_full_flags = '0') then
            next_state <= tts_1;
         elsif (all_full_flags /= '0') then
            next_state <= tts_3;
         elsif (TTC_reset = '1') then
            next_state <= tts_4;
         else
            next_state <= tts_2;
         end if;
      when tts_3 =>
         if (reset = '1') then
            next_state <= tts_0;
         elsif (TTC_reset = '1') then
            next_state <= tts_4;
         else
            next_state <= tts_3;
         end if;
      when tts_4 =>
            next_state <= tts_5;
      when tts_5 =>
            next_state <= tts_6;
      when tts_6 =>
            next_state <= tts_0;
      when others =>
         next_state <= tts_0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   tts_j0_busy_out <= tts_j0_busy_out_cld;
   tts_j0_out_of_sync_out <= tts_j0_out_of_sync_out_cld;
   tts_j0_ready_out <= tts_j0_ready_out_cld;
   tts_j0_warn_overflow_out <= tts_j0_warn_overflow_out_cld;


end fsm;
