-- hds header_start
--
-- VHDL Entity CERC_be_fed.length_in_header.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:33:47 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity length_in_header is
   port( 
      clk2x          : in     std_logic;
      rd_fe_lengths1 : in     std_logic_vector (15 downto 0);
      read_hdr_en2   : in     std_logic;
      reset          : in     std_logic;
      temp_trkr_hdr  : in     std_logic_vector (63 downto 0);
      int_trkr_hdr1  : out    std_logic_vector (63 downto 0)
   );

-- Declarations

end length_in_header ;


-- hds interface_end

--
-- VHDL Architecture CERC_be_fed.length_in_header.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:33:47 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

architecture fsm of length_in_header is

   -- Architecture Declarations
   type state_type is (
      L_hdr_0,
      L_hdr_1,
      L_hdr_2,
      L_hdr_3,
      L_hdr_4,
      L_hdr_5,
      L_hdr_6,
      L_hdr_7,
      L_hdr_8,
      L_hdr_9,
      L_hdr_10,
      L_hdr_12,
      L_hdr_11,
      L_hdr_14,
      L_hdr_13,
      L_hdr_15,
      L_hdr_16,
      L_hdr_17,
      L_hdr_18
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal int_trkr_hdr1_cld : std_logic_vector (63 downto 0) ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk2x,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      if (reset = '1') then
         current_state <= L_hdr_0;
         -- Reset Values
         int_trkr_hdr1_cld <= (others => '0');
      elsif (clk2x'event and clk2x = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals
         int_trkr_hdr1_cld <= (others => '0');

         -- Combined Actions for internal signals only
         case current_state is
         when L_hdr_0 =>
            int_trkr_hdr1_cld <= (others => '0') ;
         when L_hdr_1 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         when L_hdr_2 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         when L_hdr_3 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         when L_hdr_4 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         when L_hdr_5 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         when L_hdr_6 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         when L_hdr_7 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         when L_hdr_8 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         when L_hdr_9 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         when L_hdr_10 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         when L_hdr_12 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         when L_hdr_11 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         when L_hdr_14 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         when L_hdr_13 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         when L_hdr_15 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         when L_hdr_16 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         when others =>
            null;
         end case;

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      current_state,
      read_hdr_en2
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when L_hdr_0 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_1;
         else
            next_state <= L_hdr_0;
         end if;
      when L_hdr_1 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_2;
         else
            next_state <= L_hdr_1;
         end if;
      when L_hdr_2 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_3;
         else
            next_state <= L_hdr_2;
         end if;
      when L_hdr_3 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_4;
         else
            next_state <= L_hdr_3;
         end if;
      when L_hdr_4 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_5;
         else
            next_state <= L_hdr_4;
         end if;
      when L_hdr_5 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_6;
         else
            next_state <= L_hdr_5;
         end if;
      when L_hdr_6 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_7;
         else
            next_state <= L_hdr_6;
         end if;
      when L_hdr_7 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_8;
         else
            next_state <= L_hdr_7;
         end if;
      when L_hdr_8 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_9;
         else
            next_state <= L_hdr_8;
         end if;
      when L_hdr_9 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_10;
         else
            next_state <= L_hdr_9;
         end if;
      when L_hdr_10 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_11;
         else
            next_state <= L_hdr_10;
         end if;
      when L_hdr_12 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_13;
         else
            next_state <= L_hdr_12;
         end if;
      when L_hdr_11 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_12;
         else
            next_state <= L_hdr_11;
         end if;
      when L_hdr_14 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_15;
         else
            next_state <= L_hdr_14;
         end if;
      when L_hdr_13 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_14;
         else
            next_state <= L_hdr_13;
         end if;
      when L_hdr_15 =>
         if (read_hdr_en2 = '1') then
            next_state <= L_hdr_16;
         else
            next_state <= L_hdr_15;
         end if;
      when L_hdr_16 =>
            next_state <= L_hdr_17;
      when L_hdr_17 =>
            next_state <= L_hdr_18;
      when L_hdr_18 =>
            next_state <= L_hdr_0;
      when others =>
         next_state <= L_hdr_0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   int_trkr_hdr1 <= int_trkr_hdr1_cld;


end fsm;
