-- hds header_start
--
-- VHDL Entity CERC_be_fed.serial_router.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:35:04 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


entity serial_router is
   port( 
      clk          : in     std_logic;
      cmnd_in_a    : in     std_logic;
      cmnd_in_b    : in     std_logic;
      cmnd_in_c    : in     std_logic;
      cmnd_in_d    : in     std_logic;
      cmnd_in_e    : in     std_logic;
      cmnd_in_f    : in     std_logic;
      cmnd_in_g    : in     std_logic;
      cmnd_in_h    : in     std_logic;
      cmnd_in_i    : in     std_logic;
      cmnd_in_j    : in     std_logic;
      comnd_in     : in     std_logic;
      rst          : in     std_logic;
      cmnd_out_a   : out    std_logic;
      cmnd_out_b   : out    std_logic;
      cmnd_out_c   : out    std_logic;
      cmnd_out_d   : out    std_logic;
      cmnd_out_e   : out    std_logic;
      cmnd_out_f   : out    std_logic;
      cmnd_out_g   : out    std_logic;
      cmnd_out_h   : out    std_logic;
      cmnd_out_i   : out    std_logic;
      cmnd_out_j   : out    std_logic;
      data_from_FE : out    std_logic
   );

-- Declarations

end serial_router ;


-- hds interface_end

--
-- VHDL Architecture CERC_be_fed.serial_router.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:35:04 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


library CERC_be_fed;

architecture struct of serial_router is

   -- Architecture declarations

   -- Internal signal declarations
   signal command_in_int : std_logic;
   signal command_to_FE  : std_logic;
   signal data_from_FE1  : std_logic;
   signal en_mux         : std_logic;
   signal en_mux_in      : std_logic;
   signal selt           : std_logic_vector(4 downto 0);
   signal selt_1         : std_logic_vector(4 downto 0);


   -- Component Declarations
   component delay_24
   port (
      clk        : in     std_logic ;
      en_mux_in  : in     std_logic ;
      rst        : in     std_logic ;
      en_mux_out : out    std_logic 
   );
   end component;
   component edd_ff
   port (
      CLK          : in     std_logic ;
      en_write_out : in     std_logic ;
      rst          : in     std_logic ;
      write_out    : out    std_logic 
   );
   end component;
   component make_longer
   port (
      clk       : in     std_logic ;
      en_mux    : in     std_logic ;
      rst       : in     std_logic ;
      en_mux_in : out    std_logic 
   );
   end component;
   component mux_1to9_and_back
   port (
      clk           : in     std_logic ;
      cmnd_in_a     : in     std_logic ;
      cmnd_in_b     : in     std_logic ;
      cmnd_in_c     : in     std_logic ;
      cmnd_in_d     : in     std_logic ;
      cmnd_in_e     : in     std_logic ;
      cmnd_in_f     : in     std_logic ;
      cmnd_in_g     : in     std_logic ;
      cmnd_in_h     : in     std_logic ;
      cmnd_in_i     : in     std_logic ;
      cmnd_in_j     : in     std_logic ;
      command_to_FE : in     std_logic ;
      en_mux_in     : in     std_logic ;
      rst           : in     std_logic ;
      selt          : in     std_logic_vector (4 downto 0);
      cmnd_out_a    : out    std_logic ;
      cmnd_out_b    : out    std_logic ;
      cmnd_out_c    : out    std_logic ;
      cmnd_out_d    : out    std_logic ;
      cmnd_out_e    : out    std_logic ;
      cmnd_out_f    : out    std_logic ;
      cmnd_out_g    : out    std_logic ;
      cmnd_out_h    : out    std_logic ;
      cmnd_out_i    : out    std_logic ;
      cmnd_out_j    : out    std_logic ;
      data_from_FE1 : out    std_logic 
   );
   end component;
   component sel_decoder
   port (
      clk            : in     std_logic ;
      command_in_int : in     std_logic ;
      rst            : in     std_logic ;
      en_mux         : out    std_logic ;
      selt_1         : out    std_logic_vector (4 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : delay_24 use entity CERC_be_fed.delay_24;
   for all : edd_ff use entity CERC_be_fed.edd_ff;
   for all : make_longer use entity CERC_be_fed.make_longer;
   for all : mux_1to9_and_back use entity CERC_be_fed.mux_1to9_and_back;
   for all : sel_decoder use entity CERC_be_fed.sel_decoder;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   data_from_FE <= data_from_FE1 ;

   -- HDL Embedded Text Block 2 eb2
   selt <= selt_1 after 1 ns;

   -- Instance port mappings.
   I2 : delay_24
      port map (
         clk        => clk,
         en_mux_in  => command_in_int,
         rst        => rst,
         en_mux_out => command_to_FE
      );
   I7 : edd_ff
      port map (
         CLK          => clk,
         en_write_out => comnd_in,
         rst          => rst,
         write_out    => command_in_int
      );
   I3 : make_longer
      port map (
         clk       => clk,
         en_mux    => en_mux,
         rst       => rst,
         en_mux_in => en_mux_in
      );
   I0 : mux_1to9_and_back
      port map (
         clk           => clk,
         cmnd_in_a     => cmnd_in_a,
         cmnd_in_b     => cmnd_in_b,
         cmnd_in_c     => cmnd_in_c,
         cmnd_in_d     => cmnd_in_d,
         cmnd_in_e     => cmnd_in_e,
         cmnd_in_f     => cmnd_in_f,
         cmnd_in_g     => cmnd_in_g,
         cmnd_in_h     => cmnd_in_h,
         cmnd_in_i     => cmnd_in_i,
         cmnd_in_j     => cmnd_in_j,
         command_to_FE => command_to_FE,
         en_mux_in     => en_mux_in,
         rst           => rst,
         selt          => selt,
         cmnd_out_a    => cmnd_out_a,
         cmnd_out_b    => cmnd_out_b,
         cmnd_out_c    => cmnd_out_c,
         cmnd_out_d    => cmnd_out_d,
         cmnd_out_e    => cmnd_out_e,
         cmnd_out_f    => cmnd_out_f,
         cmnd_out_g    => cmnd_out_g,
         cmnd_out_h    => cmnd_out_h,
         cmnd_out_i    => cmnd_out_i,
         cmnd_out_j    => cmnd_out_j,
         data_from_FE1 => data_from_FE1
      );
   I1 : sel_decoder
      port map (
         clk            => clk,
         command_in_int => command_in_int,
         rst            => rst,
         en_mux         => en_mux,
         selt_1         => selt_1
      );

end struct;
