-- hds header_start
--
-- VHDL Architecture back_end_fpga.tracker_mux.rtl_trkr_mux
--
-- Created:
--          by - st79.UNKNOWN (TE2MALDIVES)
--          at - 14:17:51 03/02/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY tracker_mux IS
   PORT( 
      clk2x            : IN     std_logic;
      int_trkr_hdr     : IN     std_logic_vector (63 DOWNTO 0);
      qdr_data_in      : IN     std_logic_vector (71 DOWNTO 0);
      qdr_data_mux_en  : IN     std_logic;
      reset            : IN     std_logic;
      trckr_hdr_mux_en : IN     std_logic;
      data_in_en       : OUT    std_logic;
      ttc_trkr_hdr     : OUT    std_logic_vector (63 DOWNTO 0)
   );

-- Declarations

END tracker_mux ;

-- hds interface_end
ARCHITECTURE rtl_trkr_mux OF tracker_mux IS
BEGIN

process (clk2x,reset)
begin
   if reset = '1' then
      data_in_en <= '0';
      ttc_trkr_hdr <= (others => '0');
   elsif (clk2x'event AND clk2x = '1') then
         if trckr_hdr_mux_en = '1' then
            data_in_en <= '1' after 1 ns;
            ttc_trkr_hdr <= int_trkr_hdr after 1 ns;
         elsif qdr_data_mux_en = '1' then
            data_in_en <= '1' after 1 ns;
            -- *** matt mod
            -- ttc_trkr_hdr <= qdr_data_in(63 downto 0) after 1 ns;
            
            ttc_trkr_hdr(31 downto 0)  <= qdr_data_in(31 downto 0) after 1 ns;
            ttc_trkr_hdr(63 downto 32) <= qdr_data_in(67 downto 36) after 1 ns;
            
         else
            data_in_en <= '0' after 1 ns;
			ttc_trkr_hdr <= (others => '0') after 1 ns;
         end if;         
   end if;
end process;
END rtl_trkr_mux;
