-- hds header_start
--
-- VHDL Entity CERC_be_fed.TTC_block.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:35:43 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;
use ieee.std_logic_unsigned.ALL;

entity TTC_block is
   port( 
      clk1x                   : in     std_logic;
      clk2x                   : in     std_logic;
      en_trigger              : in     std_logic;
      internal_freeze_bar     : in     std_logic;
      rd_total_length_fifo_en : in     std_logic;
      reset                   : in     std_logic;
      sel_trig_source         : in     std_logic_vector (2 downto 0);
      test_trig               : in     std_logic;
      test_trig_B             : in     std_logic;
      trigger_i               : in     std_logic;
      ttc_L1_accept           : in     std_logic;
      ttc_bcnt_rst            : in     std_logic;
      ttc_brdcst              : in     std_logic_vector (7 downto 2);
      ttc_brdcst_str          : in     std_logic_vector (2 downto 1);
      ttc_clkL1accept         : in     std_logic;
      ttc_db_err_str          : in     std_logic;
      ttc_evt_cnt_rst         : in     std_logic;
      ttc_serial_b            : in     std_logic;
      ttc_sin_err_str         : in     std_logic;
      FE_trigger              : out    std_logic;
      L1A_bx_25_flag          : out    std_logic;
      L1A_bx_50_flag          : out    std_logic;
      L1A_bx_87_flag          : out    std_logic;
      L1A_bx_count_data       : out    std_logic_vector (35 downto 0);
      L1A_bx_fifo_empty       : out    std_logic;
      L1A_bx_fifo_full        : out    std_logic;
      L1A_count               : out    std_logic_vector (23 downto 0);
      TTC_reset               : out    std_logic;
      bx_count                : out    std_logic_vector (11 downto 0);
      ttc_broadcast_command   : out    std_logic_vector (12 downto 0);
      ttc_single_command      : out    std_logic_vector (38 downto 0)
   );

-- Declarations

end TTC_block ;


-- hds interface_end

--
-- VHDL Architecture CERC_be_fed.TTC_block.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:35:56 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.ALL;
USE ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.ALL;

library CERC_be_fed;
library unisim;

architecture struct of TTC_block is

   -- Architecture declarations

   -- Internal signal declarations
   signal FE_trigger0          : std_logic;
   signal L1A_bx_count         : std_logic_vector(35 downto 0);
   signal L1A_bx_count1        : std_logic_vector(35 downto 0);
   signal L1A_bx_flags         : std_logic_vector(2 downto 0);
   signal L1_accept_decode     : std_logic_vector(4 downto 0);
   signal L1_accept_int        : std_logic;
   signal brdcst_cmnd_valid    : std_logic;
   signal high                 : std_logic;
   signal low                  : std_logic;
   signal rst_bx_cntr          : std_logic;
   signal rst_evnt_cntr        : std_logic;
   signal single_cmnd_valid    : std_logic;
   signal test_trig_sig        : std_logic;
   signal ttc_brdcst_cmnd_data : std_logic_vector(12 downto 0);
   signal ttc_single_cmnd_data : std_logic_vector(38 downto 0);
   signal wr_en_fifo_bx_L1A    : std_logic;

   -- Implicit buffer signal declarations
   signal L1A_count_internal  : std_logic_vector (23 downto 0);
   signal bx_count_internal   : std_logic_vector (11 downto 0);
   signal FE_trigger_internal : std_logic;
   signal TTC_reset_internal  : std_logic;


   -- Component Declarations
   component AND2
   port (
      I0 : in     STD_ULOGIC;
      I1 : in     STD_ULOGIC;
      O  : out    STD_ULOGIC
   );
   end component;
   component FDCE
   port (
      C   : in     STD_ULOGIC;
      CE  : in     STD_ULOGIC;
      CLR : in     STD_ULOGIC;
      D   : in     STD_ULOGIC;
      Q   : out    STD_ULOGIC
   );
   end component;
   component IBUFDS_LVDS_33
   port (
      I  : in     STD_ULOGIC;
      IB : in     STD_ULOGIC;
      O  : out    STD_ULOGIC
   );
   end component;
   component L1A_bx_flag_gen
   port (
      L1A_bx_flags   : in     std_logic_vector (2 downto 0);
      clk2x          : in     std_logic ;
      reset          : in     std_logic ;
      L1A_bx_25_flag : out    std_logic ;
      L1A_bx_50_flag : out    std_logic ;
      L1A_bx_87_flag : out    std_logic 
   );
   end component;
   component L1A_decoder
   port (
      L1_accept_decode : in     std_logic_vector (4 downto 0);
      clk1x            : in     std_logic ;
      reset            : in     std_logic ;
      FE_trigger0      : out    std_logic ;
      TTC_reset        : out    std_logic 
   );
   end component;
   component OR3
   port (
      I0 : in     STD_ULOGIC;
      I1 : in     STD_ULOGIC;
      I2 : in     STD_ULOGIC;
      O  : out    STD_ULOGIC
   );
   end component;
   component TTC_ser_B_decode
   port (
      clk1x                : in     std_logic ;
      reset                : in     std_logic ;
      ttc_serial_b         : in     std_logic ;
      brdcst_cmnd_valid    : out    std_logic ;
      single_cmnd_valid    : out    std_logic ;
      ttc_brdcst_cmnd_data : out    std_logic_vector (12 downto 0);
      ttc_single_cmnd_data : out    std_logic_vector (38 downto 0)
   );
   end component;
   component cntr_12bits
   port (
      Q    : out    std_logic_VECTOR (11 downto 0);
      CLK  : in     std_logic ;
      CE   : in     std_logic ;
      ACLR : in     std_logic 
   );
   end component;
   component cntr_24bits
   port (
      Q    : out    std_logic_VECTOR (23 downto 0);
      CLK  : in     std_logic ;
      CE   : in     std_logic ;
      ACLR : in     std_logic 
   );
   end component;
   component fifo_512_36bits
   port (
      din      : in     std_logic_VECTOR (35 downto 0);
      wr_en    : in     std_logic ;
      wr_clk   : in     std_logic ;
      rd_en    : in     std_logic ;
      rd_clk   : in     std_logic ;
      ainit    : in     std_logic ;
      dout     : out    std_logic_VECTOR (35 downto 0);
      full     : out    std_logic ;
      empty    : out    std_logic ;
      wr_count : out    std_logic_VECTOR (2 downto 0)
   );
   end component;
   component sel_FE_trig_cntl
   port (
      clk1x           : in     std_logic ;
      en_trigger      : in     std_logic ;
      reset           : in     std_logic ;
      sel_trig_source : in     std_logic_vector (2 downto 0);
      test_trig_sig   : in     std_logic ;
      trigger_i       : in     std_logic ;
      ttc_L1_accept   : in     std_logic ;
      L1_accept_int   : out    std_logic 
   );
   end component;

   -- ModuleWare Component Declarations
   component shiftsp_11DE95AB
   port (
      clk   : in     std_logic;
      din   : in     std_logic;
      reset : in     std_logic;
      rl    : in     std_logic;
      dout  : out    std_logic_vector (4 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : AND2 use entity unisim.AND2;
   for all : FDCE use entity unisim.FDCE;
   for all : IBUFDS_LVDS_33 use entity unisim.IBUFDS_LVDS_33;
   for all : L1A_bx_flag_gen use entity CERC_be_fed.L1A_bx_flag_gen;
   for all : L1A_decoder use entity CERC_be_fed.L1A_decoder;
   for all : OR3 use entity unisim.OR3;
   for all : TTC_ser_B_decode use entity CERC_be_fed.TTC_ser_B_decode;
   for all : cntr_12bits use entity CERC_be_fed.cntr_12bits;
   for all : cntr_24bits use entity CERC_be_fed.cntr_24bits;
   for all : fifo_512_36bits use entity CERC_be_fed.fifo_512_36bits;
   for all : sel_FE_trig_cntl use entity CERC_be_fed.sel_FE_trig_cntl;
   -- pragma synthesis_on

   -- ModuleWare embedded configurations
   -- pragma synthesis_off
   for all : shiftsp_11DE95AB use entity CERC_be_fed.shiftsp_11DE95AB;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 2 eb2
   L1A_bx_count <=
   L1A_bx_count1
   after 1 ns;


   -- ModuleWare code for instance 'I1' of 'vdd'
      high <= '1';

   -- ModuleWare code for instance 'I2' of 'gnd'
      low <= '0';

   -- ModuleWare code for instance 'I0' of 'merge'
   L1A_bx_count1 <= L1A_count_internal & bx_count_internal;

   -- ModuleWare code for instance 'I12' of 'buff'
   FE_trigger_internal <= trigger_i;
   -- Instance port mappings.
   I8 : AND2
      port map (
         O  => wr_en_fifo_bx_L1A,
         I0 => internal_freeze_bar,
         I1 => FE_trigger_internal
      );
   I13 : IBUFDS_LVDS_33
      port map (
         O  => test_trig_sig,
         I  => test_trig,
         IB => test_trig_B
      );
   I11 : L1A_bx_flag_gen
      port map (
         L1A_bx_flags   => L1A_bx_flags,
         clk2x          => clk2x,
         reset          => reset,
         L1A_bx_25_flag => L1A_bx_25_flag,
         L1A_bx_50_flag => L1A_bx_50_flag,
         L1A_bx_87_flag => L1A_bx_87_flag
      );
   I7 : L1A_decoder
      port map (
         L1_accept_decode => L1_accept_decode,
         clk1x            => clk1x,
         reset            => reset,
         FE_trigger0      => FE_trigger0,
         TTC_reset        => TTC_reset_internal
      );
   I3 : OR3
      port map (
         O  => rst_bx_cntr,
         I0 => ttc_bcnt_rst,
         I1 => reset,
         I2 => TTC_reset_internal
      );
   I4 : OR3
      port map (
         O  => rst_evnt_cntr,
         I0 => reset,
         I1 => reset,
         I2 => TTC_reset_internal
      );
   I5 : TTC_ser_B_decode
      port map (
         clk1x                => clk1x,
         reset                => reset,
         ttc_serial_b         => ttc_serial_b,
         brdcst_cmnd_valid    => brdcst_cmnd_valid,
         single_cmnd_valid    => single_cmnd_valid,
         ttc_brdcst_cmnd_data => ttc_brdcst_cmnd_data,
         ttc_single_cmnd_data => ttc_single_cmnd_data
      );
   bx_counter : cntr_12bits
      port map (
         Q    => bx_count_internal,
         CLK  => clk1x,
         CE   => high,
         ACLR => rst_bx_cntr
      );
   L1A_counter : cntr_24bits
      port map (
         Q    => L1A_count_internal,
         CLK  => clk1x,
         CE   => FE_trigger_internal,
         ACLR => rst_evnt_cntr
      );
   L1A_bx_count_fifo : fifo_512_36bits
      port map (
         din      => L1A_bx_count,
         wr_en    => wr_en_fifo_bx_L1A,
         wr_clk   => clk1x,
         rd_en    => rd_total_length_fifo_en,
         rd_clk   => clk2x,
         ainit    => reset,
         dout     => L1A_bx_count_data,
         full     => L1A_bx_fifo_full,
         empty    => L1A_bx_fifo_empty,
         wr_count => L1A_bx_flags
      );
   I14 : sel_FE_trig_cntl
      port map (
         clk1x           => clk1x,
         en_trigger      => en_trigger,
         reset           => reset,
         sel_trig_source => sel_trig_source,
         test_trig_sig   => test_trig_sig,
         trigger_i       => trigger_i,
         ttc_L1_accept   => ttc_L1_accept,
         L1_accept_int   => L1_accept_int
      );

   -- ModuleWare instance port mappings.
   I6 : shiftsp_11DE95AB
      port map (
         clk   => clk1x,
         din   => L1_accept_int,
         reset => reset,
         rl    => low,
         dout  => L1_accept_decode
      );


   g0: FOR i IN 0 TO 38 GENERATE
      I9 : FDCE
         port map (
            Q   => ttc_single_command(i),
            C   => clk1x,
            CE  => single_cmnd_valid,
            CLR => reset,
            D   => ttc_single_cmnd_data(i)
         );
   end generate g0;

   g1: FOR i IN 0 TO 12 GENERATE
      I10 : FDCE
         port map (
            Q   => ttc_broadcast_command(i),
            C   => clk1x,
            CE  => brdcst_cmnd_valid,
            CLR => reset,
            D   => ttc_brdcst_cmnd_data(i)
         );
   end generate g1;

   -- Implicit buffered output assignments
   L1A_count  <= L1A_count_internal;
   bx_count   <= bx_count_internal;
   FE_trigger <= FE_trigger_internal;
   TTC_reset  <= TTC_reset_internal;

end struct;
