-- hds header_start
--
-- VHDL Entity CERC_be_fed.TTC_ser_B_decode.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:35:43 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.ALL;
USE ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.ALL;

entity TTC_ser_B_decode is
   port( 
      clk1x                : in     std_logic;
      reset                : in     std_logic;
      ttc_serial_b         : in     std_logic;
      brdcst_cmnd_valid    : out    std_logic;
      single_cmnd_valid    : out    std_logic;
      ttc_brdcst_cmnd_data : out    std_logic_vector (12 downto 0);
      ttc_single_cmnd_data : out    std_logic_vector (38 downto 0)
   );

-- Declarations

end TTC_ser_B_decode ;


-- hds interface_end

--
-- VHDL Architecture CERC_be_fed.TTC_ser_B_decode.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:35:43 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.ALL;

architecture fsm of TTC_ser_B_decode is

   -- Architecture Declarations
   signal count : integer range 0 to 44 := 0;
   signal tmp_single : std_logic_vector(40 downto 0);
   signal tmp_brdcst : std_logic_vector(14 downto 0);

   type state_type is (
      ttc_cmnd0,
      ttc_cmnd2,
      ttc_cmnd3,
      ttc_cmnd4,
      ttc_cmnd5,
      ttc_cmnd6,
      ttc_cmnd1
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal brdcst_cmnd_valid_cld : std_logic  ;
   signal single_cmnd_valid_cld : std_logic  ;
   signal ttc_brdcst_cmnd_data_cld : std_logic_vector (12 downto 0) ;
   signal ttc_single_cmnd_data_cld : std_logic_vector (38 downto 0) ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk1x,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      if (reset = '1') then
         current_state <= ttc_cmnd0;
         -- Reset Values
         brdcst_cmnd_valid_cld <= '0';
         single_cmnd_valid_cld <= '0';
         ttc_brdcst_cmnd_data_cld <= (others => '0');
         ttc_single_cmnd_data_cld <= (others => '0');
         count <= 0;
         tmp_brdcst <= (others => '0');
         tmp_single <= (others => '0');
      elsif (clk1x'event and clk1x = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals

         -- Combined Actions for internal signals only
         case current_state is
         when ttc_cmnd0 =>
            brdcst_cmnd_valid_cld <= '0' after 1 ns;
            single_cmnd_valid_cld <= '0'  after 1 ns;
            count <= 0 after 1 ns;
            tmp_brdcst <= (others => '0')   after 1 ns;
            tmp_single <= (others => '0')   after 1 ns;
            ttc_brdcst_cmnd_data_cld <= (others => '0')   after 1 ns;
            ttc_single_cmnd_data_cld <= (others => '0')   after 1 ns;
         when ttc_cmnd2 =>
            if (ttc_serial_b = '1') then
               count <= 40 after 1 ns;
            elsif (ttc_serial_b = '0') then
               count <= 14 after 1 ns;
            end if;
         when ttc_cmnd3 =>
            tmp_single(count) <= ttc_serial_b after 1 ns;
            count <= count -1 after 1 ns;
         when ttc_cmnd4 =>
            ttc_single_cmnd_data_cld <= 
            tmp_single ( 40 downto 2 ) after 1 ns;
            count <= 0 after 1 ns;
            single_cmnd_valid_cld 
            <= '1' after 1 ns;
         when ttc_cmnd5 =>
            tmp_brdcst (count) <= ttc_serial_b after 1 ns;
            count <= count -1 after 1 ns;
         when ttc_cmnd6 =>
            ttc_brdcst_cmnd_data_cld <= 
            tmp_brdcst ( 14 downto 2) after 1 ns;
            brdcst_cmnd_valid_cld 
            <= '1' after 1 ns;
            count <= 0 after 1 ns;
         when others =>
            null;
         end case;

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      count,
      current_state,
      ttc_serial_b
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when ttc_cmnd0 =>
         if (ttc_serial_b = '1') then
            next_state <= ttc_cmnd1;
         else
            next_state <= ttc_cmnd0;
         end if;
      when ttc_cmnd2 =>
         if (ttc_serial_b = '1') then
            next_state <= ttc_cmnd3;
         elsif (ttc_serial_b = '0') then
            next_state <= ttc_cmnd5;
         else
            next_state <= ttc_cmnd2;
         end if;
      when ttc_cmnd3 =>
         if (count = 2) then
            next_state <= ttc_cmnd4;
         else
            next_state <= ttc_cmnd3;
         end if;
      when ttc_cmnd4 =>
            next_state <= ttc_cmnd0;
      when ttc_cmnd5 =>
         if (count = 2) then
            next_state <= ttc_cmnd6;
         else
            next_state <= ttc_cmnd5;
         end if;
      when ttc_cmnd6 =>
            next_state <= ttc_cmnd0;
      when ttc_cmnd1 =>
         if (ttc_serial_b = '0') then
            next_state <= ttc_cmnd2;
         else
            next_state <= ttc_cmnd1;
         end if;
      when others =>
         next_state <= ttc_cmnd0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   brdcst_cmnd_valid <= brdcst_cmnd_valid_cld;
   single_cmnd_valid <= single_cmnd_valid_cld;
   ttc_brdcst_cmnd_data <= ttc_brdcst_cmnd_data_cld;
   ttc_single_cmnd_data <= ttc_single_cmnd_data_cld;


end fsm;
