-- hds header_start
--
-- VHDL Entity CERC_be_fed.TTS_block.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:35:57 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;
use ieee.std_logic_unsigned.ALL;

entity TTS_block is
   port( 
      TTC_reset                : in     std_logic;
      clk1x                    : in     std_logic;
      empty_flags              : in     std_logic_vector (7 downto 0);
      full_flags               : in     std_logic_vector (7 downto 0);
      half_full_flags          : in     std_logic_vector (7 downto 0);
      partial_empty_flags      : in     std_logic_vector (7 downto 0);
      partial_full_flags       : in     std_logic_vector (7 downto 0);
      reset                    : in     std_logic;
      tts_j0_busy              : out    std_logic;
      tts_j0_busy_b            : out    std_logic;
      tts_j0_busy_out          : out    std_logic;
      tts_j0_out_of_sync       : out    std_logic;
      tts_j0_out_of_sync_b     : out    std_logic;
      tts_j0_out_of_sync_out   : out    std_logic;
      tts_j0_ready             : out    std_logic;
      tts_j0_ready_b           : out    std_logic;
      tts_j0_ready_out         : out    std_logic;
      tts_j0_warn_overflow     : out    std_logic;
      tts_j0_warn_overflow_b   : out    std_logic;
      tts_j0_warn_overflow_out : out    std_logic
   );

-- Declarations

end TTS_block ;


-- hds interface_end

--
-- VHDL Architecture CERC_be_fed.TTS_block.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:36:15 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

LIBRARY ieee;
USE ieee.std_logic_1164.all;

library CERC_be_fed;
library unisim;

architecture struct of TTS_block is

   -- Architecture declarations

   -- Internal signal declarations
   signal all_flags_empty         : std_logic;
   signal all_full_flags          : std_logic;
   signal all_half_full_flags     : std_logic;
   signal all_partial_empty_flags : std_logic;
   signal all_partial_full_flags  : std_logic;

   -- Implicit buffer signal declarations
   signal tts_j0_busy_out_internal          : std_logic;
   signal tts_j0_warn_overflow_out_internal : std_logic;
   signal tts_j0_ready_out_internal         : std_logic;
   signal tts_j0_out_of_sync_out_internal   : std_logic;


   -- Component Declarations
   component OBUFDS_LVDS_33
   port (
      I  : in     STD_ULOGIC;
      O  : out    STD_ULOGIC;
      OB : out    STD_ULOGIC
   );
   end component;
   component OR8
   port (
      I0 : in     STD_ULOGIC;
      I1 : in     STD_ULOGIC;
      I2 : in     STD_ULOGIC;
      I3 : in     STD_ULOGIC;
      I4 : in     STD_ULOGIC;
      I5 : in     STD_ULOGIC;
      I6 : in     STD_ULOGIC;
      I7 : in     STD_ULOGIC;
      O  : out    STD_ULOGIC
   );
   end component;
   component gen_tts_lvds
   port (
      TTC_reset                : in     std_logic ;
      all_flags_empty          : in     std_logic ;
      all_full_flags           : in     std_logic ;
      all_half_full_flags      : in     std_logic ;
      all_partial_empty_flags  : in     std_logic ;
      all_partial_full_flags   : in     std_logic ;
      clk1x                    : in     std_logic ;
      reset                    : in     std_logic ;
      tts_j0_busy_out          : out    std_logic ;
      tts_j0_out_of_sync_out   : out    std_logic ;
      tts_j0_ready_out         : out    std_logic ;
      tts_j0_warn_overflow_out : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : OBUFDS_LVDS_33 use entity unisim.OBUFDS_LVDS_33;
   for all : OR8 use entity unisim.OR8;
   for all : gen_tts_lvds use entity CERC_be_fed.gen_tts_lvds;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   I5 : OBUFDS_LVDS_33
      port map (
         O  => tts_j0_ready,
         OB => tts_j0_ready_b,
         I  => tts_j0_ready_out_internal
      );
   I6 : OBUFDS_LVDS_33
      port map (
         O  => tts_j0_busy,
         OB => tts_j0_busy_b,
         I  => tts_j0_busy_out_internal
      );
   I7 : OBUFDS_LVDS_33
      port map (
         O  => tts_j0_out_of_sync,
         OB => tts_j0_out_of_sync_b,
         I  => tts_j0_out_of_sync_out_internal
      );
   I8 : OBUFDS_LVDS_33
      port map (
         O  => tts_j0_warn_overflow,
         OB => tts_j0_warn_overflow_b,
         I  => tts_j0_warn_overflow_out_internal
      );
   I9 : OR8
      port map (
         O  => all_full_flags,
         I0 => full_flags(0),
         I1 => full_flags(1),
         I2 => full_flags(2),
         I3 => full_flags(3),
         I4 => full_flags(4),
         I5 => full_flags(5),
         I6 => full_flags(6),
         I7 => full_flags(7)
      );
   I10 : OR8
      port map (
         O  => all_partial_full_flags,
         I0 => partial_full_flags(0),
         I1 => partial_full_flags(1),
         I2 => partial_full_flags(2),
         I3 => partial_full_flags(3),
         I4 => partial_full_flags(4),
         I5 => partial_full_flags(5),
         I6 => partial_full_flags(6),
         I7 => partial_full_flags(7)
      );
   I11 : OR8
      port map (
         O  => all_partial_empty_flags,
         I0 => partial_empty_flags(0),
         I1 => partial_empty_flags(1),
         I2 => partial_empty_flags(2),
         I3 => partial_empty_flags(3),
         I4 => partial_empty_flags(4),
         I5 => partial_empty_flags(5),
         I6 => partial_empty_flags(6),
         I7 => partial_empty_flags(7)
      );
   I12 : OR8
      port map (
         O  => all_half_full_flags,
         I0 => half_full_flags(0),
         I1 => half_full_flags(1),
         I2 => half_full_flags(2),
         I3 => half_full_flags(3),
         I4 => half_full_flags(4),
         I5 => half_full_flags(5),
         I6 => half_full_flags(6),
         I7 => half_full_flags(7)
      );
   I15 : OR8
      port map (
         O  => all_flags_empty,
         I0 => empty_flags(0),
         I1 => empty_flags(1),
         I2 => empty_flags(2),
         I3 => empty_flags(3),
         I4 => empty_flags(4),
         I5 => empty_flags(5),
         I6 => empty_flags(6),
         I7 => empty_flags(7)
      );
   I0 : gen_tts_lvds
      port map (
         TTC_reset                => TTC_reset,
         all_flags_empty          => all_flags_empty,
         all_full_flags           => all_full_flags,
         all_half_full_flags      => all_half_full_flags,
         all_partial_empty_flags  => all_partial_empty_flags,
         all_partial_full_flags   => all_partial_full_flags,
         clk1x                    => clk1x,
         reset                    => reset,
         tts_j0_busy_out          => tts_j0_busy_out_internal,
         tts_j0_out_of_sync_out   => tts_j0_out_of_sync_out_internal,
         tts_j0_ready_out         => tts_j0_ready_out_internal,
         tts_j0_warn_overflow_out => tts_j0_warn_overflow_out_internal
      );

   -- Implicit buffered output assignments
   tts_j0_busy_out          <= tts_j0_busy_out_internal;
   tts_j0_warn_overflow_out <= tts_j0_warn_overflow_out_internal;
   tts_j0_ready_out         <= tts_j0_ready_out_internal;
   tts_j0_out_of_sync_out   <= tts_j0_out_of_sync_out_internal;

end struct;
