-- hds header_start
--
-- VHDL Entity CERC_be_fed.wr_all_lengths.interface
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:31:50 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

entity wr_all_lengths is
   port( 
      byte_length1       : in     std_logic_vector (14 downto 0);
      byte_length2       : in     std_logic_vector (14 downto 0);
      byte_length3       : in     std_logic_vector (14 downto 0);
      byte_length4       : in     std_logic_vector (14 downto 0);
      byte_length5       : in     std_logic_vector (14 downto 0);
      byte_length6       : in     std_logic_vector (14 downto 0);
      byte_length7       : in     std_logic_vector (14 downto 0);
      byte_length8       : in     std_logic_vector (14 downto 0);
      clk1x              : in     std_logic;
      done               : in     std_logic;
      en_fe_data_capture : in     std_logic;
      reset              : in     std_logic;
      wr_fe_lenghts_en   : out    std_logic;
      wr_fe_lengths      : out    std_logic_vector (17 downto 0)
   );

-- Declarations

end wr_all_lengths ;


-- hds interface_end

--
-- VHDL Architecture CERC_be_fed.wr_all_lengths.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:31:51 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

architecture fsm of wr_all_lengths is

   -- Architecture Declarations
   type state_type is (
      wr_fe_L_0,
      wr_fe_L_1,
      wr_fe_L_2,
      wr_fe_L_3,
      wr_fe_L_4,
      wr_fe_L_5,
      wr_fe_L_6,
      wr_fe_L_7,
      wr_fe_L_8,
      wr_fe_L_9
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal wr_fe_lenghts_en_cld : std_logic  ;
   signal wr_fe_lengths_cld : std_logic_vector (17 downto 0) ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk1x,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      if (reset = '1') then
         current_state <= wr_fe_L_0;
         -- Reset Values
         wr_fe_lenghts_en_cld <= '0';
         wr_fe_lengths_cld <= (others => '0') ;
      elsif (clk1x'event and clk1x = '1') then
         if (en_fe_data_capture = '1') then
            current_state <= next_state;
            -- Default Assignment To Internals
            wr_fe_lenghts_en_cld <= '0';
            wr_fe_lengths_cld <= (others => '0') ;

            -- Combined Actions for internal signals only
            case current_state is
            when wr_fe_L_0 =>
               wr_fe_lengths_cld <= (others => '0') after 1 ns;
               wr_fe_lenghts_en_cld <= '0' after 1 ns;
            when wr_fe_L_1 =>
               wr_fe_lengths_cld <=( "000" & byte_length1(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            when wr_fe_L_2 =>
               wr_fe_lengths_cld <= ("000" & byte_length2(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            when wr_fe_L_3 =>
               wr_fe_lengths_cld <= ("000" & byte_length3(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            when wr_fe_L_4 =>
               wr_fe_lengths_cld <= ("000" & byte_length4(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            when wr_fe_L_5 =>
               wr_fe_lengths_cld <=( "000" & byte_length5(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            when wr_fe_L_6 =>
               wr_fe_lengths_cld <= ("000" & byte_length6(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            when wr_fe_L_7 =>
               wr_fe_lengths_cld <=( "000" & byte_length7(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            when wr_fe_L_8 =>
               wr_fe_lengths_cld <= ("000" & byte_length8(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            when wr_fe_L_9 =>
               wr_fe_lengths_cld <= (others => '0') after 1 ns;
               wr_fe_lenghts_en_cld <= '0' after 1 ns;
            when others =>
               null;
            end case;

         end if;
      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      current_state,
      done,
      en_fe_data_capture
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when wr_fe_L_0 =>
         if (done = '1' AND 
         en_fe_data_capture = '1') then
            next_state <= wr_fe_L_1;
         else
            next_state <= wr_fe_L_0;
         end if;
      when wr_fe_L_1 =>
            next_state <= wr_fe_L_2;
      when wr_fe_L_2 =>
            next_state <= wr_fe_L_3;
      when wr_fe_L_3 =>
            next_state <= wr_fe_L_4;
      when wr_fe_L_4 =>
            next_state <= wr_fe_L_5;
      when wr_fe_L_5 =>
            next_state <= wr_fe_L_6;
      when wr_fe_L_6 =>
            next_state <= wr_fe_L_7;
      when wr_fe_L_7 =>
            next_state <= wr_fe_L_8;
      when wr_fe_L_8 =>
            next_state <= wr_fe_L_9;
      when wr_fe_L_9 =>
            next_state <= wr_fe_L_0;
      when others =>
         next_state <= wr_fe_L_0;
      end case;

   end process nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   wr_fe_lenghts_en <= wr_fe_lenghts_en_cld;
   wr_fe_lengths <= wr_fe_lengths_cld;


end fsm;
