-- hds header_start
--
-- VHDL Architecture CALICE_lib.register32.untitled
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 11:33:54 11/30/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity serialiser is
   generic( 
      WIDTH : integer := 8
   );
   port( 
      rst     : in     std_logic;
      clk     : in     std_logic;
      en_i    : in     std_logic;
      start_i : in     std_logic;
      ser_o   : out    std_logic;
      done_o  : out    std_logic;
      data_i  : in     std_logic_vector ((WIDTH-1) downto 0)
   );

-- Declarations

end serialiser ;


-- hds interface_end
architecture rtl of serialiser is
	
	signal counter : integer range 0 to (WIDTH+1);
	signal start_q : std_logic;
	signal data 	:  std_logic_vector((WIDTH+1) downto 0);
	

begin

	data <= ('1' & data_i & '0');

	ser_count : process (clk)
	begin
		if rising_edge(clk) then
			if (rst = '1') then 
			
				start_q 	<= '0';
				counter 	<= 0;
				
			else
				start_q <= start_i;
				done_o    <= '0';
			
				if (en_i = '1') then
			
					if ((start_i = '1') and (start_q = '0')) then
						counter <= (WIDTH + 1);
						
					elsif (counter = 0) then
						counter <= 0;
						
					else
						counter <= counter - 1;
						
					end if;
					
					if (counter = 1) then
						done_o <= '1';

					end if;
				end if;
			end if;
		end if;
	end process;
	
	ser_o <= data(conv_integer(counter));

end rtl;
