-- hds header_start
--
-- VHDL Architecture CALICE_lib.addr_decoder.rtl2
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:52:36 11/30/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity addr_bank_decoder is
   port( 
      rst             : in     std_logic;
      clk             : in     std_logic;
      addr_i          : in     std_logic_vector (15 downto 0);
      bank_32k_64k_en : out    std_logic;
      bank_0k_en      : out    std_logic;
      bank_1k_en      : out    std_logic;
      bank_2k_en      : out    std_logic;
      bank_3k_en      : out    std_logic
   );

-- Declarations

end addr_bank_decoder ;

-- hds interface_end
architecture rtl of addr_bank_decoder is
	
	signal top_half_en 	: std_logic;
	signal bank_en			: std_logic_vector(3 downto 0);


	
-------------------------------------------------------------------------------
-- MAIN CODE
-------------------------------------------------------------------------------
begin

	process (clk)
  	begin
  	
  		if rising_edge(clk) then
  		
	  		if (rst = '1') then
  				top_half_en <= '0';
  		      bank_en 		<= (others => '0');
  		
	    	else
	    		-- defaults
  				top_half_en <= '0';
  		      bank_en 		<= (others => '0');
   		
	    		if (addr_i(15) = '1') then
	    			top_half_en <= '1';
	    		
	    		else
	      		case addr_i(14 downto 8) is
	      																										  --No  Addr
		        		when "0000000" =>  bank_en <= "0001"; --bank 0  0x000-0x0FF
						when "0000001" =>  bank_en <= "0010"; --bank 1  0x100-0x1FF
						when "0000010" =>  bank_en <= "0100"; --bank 2  0x200-0x2FF
						when "0000011" =>  bank_en <= "1000"; --bank 3  0x300-0x3FF
	        
		        		when others =>     bank_en <= (others => '0');					      
		      	end case;
		      end if;
	     	end if;
		end if;
  	end process;

	
	-- Output Mapping
	-----------------------------------------------------------------
	
	bank_32k_64k_en <= top_half_en;	

	bank_0k_en <= bank_en(0);
	bank_1k_en <= bank_en(1);
	bank_2k_en <= bank_en(2);
	bank_3k_en <= bank_en(3);
	
end rtl;
