-- hds header_start
--
-- VHDL Architecture CALICE_lib.shiftreg_reg32.rtl
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 17:06:02 09/23/03
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


entity shiftreg_reg32 is
   port( 
      clk     : in     std_logic;
      reset   : in     std_logic;
      ser_in  : in     std_logic;
      store   : in     std_logic;
      reg_out : out    std_logic_vector (31 downto 0)
   );

-- Declarations

end shiftreg_reg32 ;

-- hds interface_end
architecture rtl of shiftreg_reg32 is

	signal sr32 : std_logic_vector(31 downto 0);
	signal ro		 : std_logic_vector(31 downto 0);
	
begin

	reg_out <= ro;

	shiftreg_with_side_storage : process (clk)
	begin
	
		if rising_edge(clk) then
		
			if (reset = '1') then 
			-- note: no reset shift register - uses CLB RAM resources we hope
				sr32 <= (others => '0');
				
			else
				sr32(31) <= ser_in;
				sr32(30 downto 0) <= sr32(31 downto 1);
			end if;
			
			
			if (reset <= '1') then
				ro <= (others => '0');
				
			elsif (store = '1') then
				ro <= sr32;
				
			else
				ro <= "10101010101010101010101010101010";
								
			end if;
			
		end if;
	end process;
		
end rtl;
