-- hds header_start
--
-- VHDL Entity CERC_trig.bt_top.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 15:01:57 12/05/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity bt_top is
   port( 
      be_reset_i            : in     std_logic;
      clk2x                 : in     std_logic;
      clk_in                : in     std_logic;
      readout_sync_in       : in     std_logic;
      rst_in                : in     std_logic;
      sinkdata_fe0_i        : in     std_logic_vector (31 downto 0);
      tqdr_en_i             : in     std_logic;
      trig_ext_i            : in     std_logic_vector (15 downto 0);
      vmeser_in             : in     std_logic;
      busy_crate_trig_o     : out    std_logic;
      crate_trig_out        : out    std_logic;
      crate_trig_raw_o      : out    std_logic;
      crate_trig_raw_sync_o : out    std_logic;
      crate_trig_sync_o     : out    std_logic;
      fanout_en_o           : out    std_logic;
      frame_sync_out        : out    STD_ULOGIC;
      readout_data_out      : out    std_logic_vector (7 downto 0);
      readout_sync_out      : out    STD_ULOGIC;
      trig_cand0_o          : out    std_logic;
      vmeser_out            : out    std_logic
   );

-- Declarations

end bt_top ;


-- hds interface_end

--
-- VHDL Architecture CERC_trig.bt_top.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 15:01:57 12/05/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library CERC_lib;
library CERC_trig;

architecture struct of bt_top is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE            : std_logic;
   signal ZERO           : std_logic;
   signal addr           : std_logic_vector(15 downto 0);
   signal clk            : std_logic;
   signal clk180         : std_logic;
   signal clk270         : std_logic;
   signal clk90          : std_logic;
   signal db             : std_logic_vector(31 downto 0);
   signal db_rd          : std_logic;
   signal db_rd0         : std_logic;
   signal db_wr          : std_logic;
   signal ren            : std_logic_vector(31 downto 0);
   signal rst            : std_logic;
   signal rst_cmd        : std_logic;
   signal squirt_disable : std_logic;
   signal squirt_en      : std_logic;

   -- Implicit buffer signal declarations
   signal busy_crate_trig_o_internal : std_logic;


   -- Component Declarations
   component addr_reg
   port (
      clk      : in     std_logic ;
      en_i     : in     std_logic ;
      en_inc_i : in     std_logic ;
      rd_i     : in     std_logic ;
      rst      : in     std_logic ;
      wr_i     : in     std_logic ;
      addr_o   : out    std_logic_vector (15 downto 0);
      db_io    : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component bt_main
   generic (
      FIRMWARE_VER : integer := 0
   );
   port (
      addr              : in     std_logic_vector (15 downto 0);
      be_reset_i        : in     std_logic ;
      clk               : in     std_logic ;
      clk180            : in     std_logic ;
      clk270            : in     std_logic ;
      clk2x             : in     std_logic ;
      clk90             : in     std_logic ;
      db_rd             : in     std_logic ;
      db_rd0            : in     std_logic ;
      db_wr             : in     std_logic ;
      readout_sync_in   : in     std_logic ;
      ren               : in     std_logic_vector (31 downto 0);
      rst               : in     std_logic ;
      sinkdata_fe0_i    : in     std_logic_vector (31 downto 0);
      squirt_en_i       : in     std_logic ;
      tqdr_en_i         : in     std_logic ;
      trig_ext_i        : in     std_logic_vector (15 downto 0);
      busy_crate_trig_o : out    std_logic ;
      fanout_en_o       : out    std_logic ;
      frame_sync_out    : out    STD_ULOGIC ;
      readout_data_out  : out    std_logic_vector (7 downto 0);
      readout_sync_out  : out    STD_ULOGIC ;
      rst_cmd           : out    std_logic ;
      squirt_disable_o  : out    std_logic ;
      trig_cand0_o      : out    std_logic ;
      trig_out_o        : out    std_logic ;
      trig_raw_o        : out    std_logic ;
      trig_raw_sync_o   : out    std_logic ;
      trig_sync_o       : out    std_logic ;
      db                : inout  std_logic_vector (31 downto 0)
   );
   end component;
   component m_buff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_or2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;
   component vmeser_decode
   port (
      clk               : in     std_logic ;
      rst               : in     std_logic ;
      ser_i             : in     std_logic ;
      ser_o             : out    std_logic ;
      squirt_disable_i  : in     std_logic ;
      db_rd0_o          : out    std_logic ;                     -- 1 clk early read - for FIFOs mainly
      squirt_en_o       : out    std_logic ;                     --
      busy_crate_trig_i : in     std_logic ;
      db_rd_o           : out    std_logic ;
      db_wr_o           : out    std_logic ;
      ren_o             : out    std_logic_vector (31 downto 0); -- reg enable lines (like reg_en)
      db_io             : inout  std_logic_vector (31 downto 0)
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : addr_reg use entity CERC_trig.addr_reg;
   for all : bt_main use entity CERC_trig.bt_main;
   for all : m_buff use entity CERC_lib.m_buff;
   for all : m_or2 use entity CERC_lib.m_or2;
   for all : m_power use entity CERC_lib.m_power;
   for all : vmeser_decode use entity CERC_trig.vmeser_decode;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   addr_reg_1 : addr_reg
      port map (
         clk      => clk,
         en_i     => ren(31),
         en_inc_i => ren(30),
         rd_i     => db_rd,
         rst      => rst,
         wr_i     => db_wr,
         addr_o   => addr,
         db_io    => db
      );
   bt_main_1 : bt_main
      generic map (
         FIRMWARE_VER => 18
      )
      port map (
         addr              => addr,
         be_reset_i        => be_reset_i,
         clk               => clk,
         clk180            => clk180,
         clk270            => clk270,
         clk2x             => clk2x,
         clk90             => clk90,
         db_rd             => db_rd,
         db_rd0            => db_rd0,
         db_wr             => db_wr,
         readout_sync_in   => readout_sync_in,
         ren               => ren,
         rst               => rst,
         sinkdata_fe0_i    => sinkdata_fe0_i,
         squirt_en_i       => squirt_en,
         tqdr_en_i         => tqdr_en_i,
         trig_ext_i        => trig_ext_i,
         busy_crate_trig_o => busy_crate_trig_o_internal,
         fanout_en_o       => fanout_en_o,
         frame_sync_out    => frame_sync_out,
         readout_data_out  => readout_data_out,
         readout_sync_out  => readout_sync_out,
         rst_cmd           => rst_cmd,
         squirt_disable_o  => squirt_disable,
         trig_cand0_o      => trig_cand0_o,
         trig_out_o        => crate_trig_out,
         trig_raw_o        => crate_trig_raw_o,
         trig_raw_sync_o   => crate_trig_raw_sync_o,
         trig_sync_o       => crate_trig_sync_o,
         db                => db
      );
   I0 : m_buff
      port map (
         I => clk_in,
         O => clk
      );
   I8 : m_or2
      port map (
         I1 => rst_cmd,
         I2 => rst_in,
         O  => rst
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );
   vmeser_decode_1 : vmeser_decode
      port map (
         clk               => clk,
         rst               => rst_in,
         ser_i             => vmeser_in,
         ser_o             => vmeser_out,
         squirt_disable_i  => squirt_disable,
         db_rd0_o          => db_rd0,
         squirt_en_o       => squirt_en,
         busy_crate_trig_i => busy_crate_trig_o_internal,
         db_rd_o           => db_rd,
         db_wr_o           => db_wr,
         ren_o             => ren,
         db_io             => db
      );

   -- Implicit buffered output assignments
   busy_crate_trig_o <= busy_crate_trig_o_internal;

end struct;
