-- hds header_start
--
-- VHDL Entity CERC_trig.enable_inputDDR.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:36:35 12/05/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;

entity enable_inputDDR is
   port( 
      FE_enable_reg        : in     std_logic_vector (8 downto 1);
      clk2x                : in     std_logic;
      frm_addr_fifo_empty  : in     std_logic;
      rdout_sync_out_sig1  : in     std_logic;
      reset                : in     std_logic;
      store_frame_data_bus : in     std_logic_VECTOR (7 downto 0);
      inputDDR_en          : out    std_logic
   );

-- Declarations

end enable_inputDDR ;


-- hds interface_end

--
-- VHDL Architecture CERC_trig.enable_inputDDR.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 09:36:35 12/05/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

architecture fsm of enable_inputDDR is

   -- Architecture Declarations
   signal count : integer range 0 to 8;

   type state_type is (
      in_ddr_0,
      in_ddr_1,
      in_ddr_2,
      in_ddr_3,
      in_ddr_4,
      in_ddr_5,
      in_ddr_6,
      in_ddr_7,
      in_ddr_8
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal inputDDR_en_cld : std_logic  ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk2x,
      reset
   )
   ----------------------------------------------------------------------------
   begin
      if (reset = '1') then
         current_state <= in_ddr_0;
         -- Reset Values
         inputDDR_en_cld <= '0';
         count <= 0;
      elsif (clk2x'event and clk2x = '1') then
         current_state <= next_state;
         -- Default Assignment To Internals
         count <= 0;

         -- Combined Actions for internal signals only
         case current_state is
         when in_ddr_0 =>
            inputDDR_en_cld <= '0' ;
            count <= 0 ;
         when in_ddr_2 =>
            count <= count + 1;
         when in_ddr_3 =>
            inputDDR_en_cld <= '1' after 1 ns;
         when in_ddr_4 =>
            if (store_frame_data_bus = "00000000") then
               inputDDR_en_cld <= '0' after 1 ns;
            end if;
         when others =>
            null;
         end case;

      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      FE_enable_reg,
      count,
      current_state,
      frm_addr_fifo_empty,
      rdout_sync_out_sig1,
      store_frame_data_bus
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when in_ddr_0 =>
         if (frm_addr_fifo_empty = '0') then
            next_state <= in_ddr_1;
         elsif (FE_enable_reg = "00000000") then
            next_state <= in_ddr_0;
         else
            next_state <= in_ddr_0;
         end if;
      when in_ddr_1 =>
         if (rdout_sync_out_sig1 = '1') then
            next_state <= in_ddr_2;
         else
            next_state <= in_ddr_1;
         end if;
      when in_ddr_2 =>
         if (count = 4) then
            next_state <= in_ddr_3;
         else
            next_state <= in_ddr_2;
         end if;
      when in_ddr_3 =>
         if (store_frame_data_bus /= "00000000") then
            next_state <= in_ddr_4;
         else
            next_state <= in_ddr_3;
         end if;
      when in_ddr_4 =>
         if (store_frame_data_bus = "00000000") then
            next_state <= in_ddr_5;
         else
            next_state <= in_ddr_4;
         end if;
      when in_ddr_5 =>
            next_state <= in_ddr_6;
      when in_ddr_6 =>
         if (frm_addr_fifo_empty = '0') then
            next_state <= in_ddr_1;
         elsif (frm_addr_fifo_empty = '1') then
            next_state <= in_ddr_7;
         else
            next_state <= in_ddr_6;
         end if;
      when in_ddr_7 =>
            next_state <= in_ddr_8;
      when in_ddr_8 =>
            next_state <= in_ddr_0;
      when others =>
         next_state <= in_ddr_0;
      end case;

   end process nextstate;

   ----------------------------------------------------------------------------
   output : process (
      current_state
   )
   ----------------------------------------------------------------------------
   begin
      -- Default Assignment
      -- Default Assignment To Internals

      -- Combined Actions
      case current_state is
      when in_ddr_5 =>
         -- inputDDR_en_cld <= '0' ;
      when others =>
         null;
      end case;

   end process output;

   -- Concurrent Statements
   -- Clocked output assignments
   inputDDR_en <= inputDDR_en_cld;


end fsm;
