-- hds header_start
--
-- VHDL Entity CERC_trig.fe_mux16_to_8.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:31:40 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_textio.all;
USE ieee.std_logic_unsigned.ALL;

entity fe_mux16_to_8 is
   port( 
      clk80            : in     STD_ULOGIC;
      data_muxd        : in     std_logic_vector (15 downto 0);
      fifo_empty1      : in     std_logic;
      rst              : in     std_logic;
      readout_data_out : out    std_logic_vector (7 downto 0)
   );

-- Declarations

end fe_mux16_to_8 ;


-- hds interface_end

--
-- VHDL Architecture CERC_trig.fe_mux16_to_8.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:31:40 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_textio.all;
USE ieee.std_logic_unsigned.ALL;

architecture fsm of fe_mux16_to_8 is

   -- Architecture Declarations
   type state_type is (
      s0,
      s1,
      s2,
      s3
   );


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

   -- Declare any pre-registered internal signals
   signal readout_data_out_int : std_logic_vector (7 downto 0) ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk80
   )
   ----------------------------------------------------------------------------
   begin
      if (clk80'event and clk80 = '1') then
         if (rst = '1') then
            current_state <= s0;
            -- Reset Values
            readout_data_out <= "00000000";
         else
            current_state <= next_state;
            -- Registered output assignments
            readout_data_out <= readout_data_out_int;

            -- Default Assignment To Internals

         end if;
      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      current_state,
      fifo_empty1
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when s0 =>
         if (fifo_empty1 ='0') then
            next_state <= s1;
         else
            next_state <= s0;
         end if;
      when s1 =>
            next_state <= s2;
      when s2 =>
         if (fifo_empty1 ='1') then
            next_state <= s0;
         else
            next_state <= s1;
         end if;
      when s3 =>
         next_state <= s3;
      when others =>
         next_state <= s0;
      end case;

   end process nextstate;

   ----------------------------------------------------------------------------
   output : process (
      current_state,
      data_muxd
   )
   ----------------------------------------------------------------------------
   begin
      -- Default Assignment
      readout_data_out_int <= "00000000";
      -- Default Assignment To Internals

      -- Combined Actions
      case current_state is
      when s1 =>
         readout_data_out_int <= data_muxd (7 downto 0) after 1 ns;
      when s2 =>
         readout_data_out_int <= data_muxd (15 downto 8) after 1 ns;
      when others =>
         null;
      end case;

   end process output;

   -- Concurrent Statements

end fsm;
