-- hds header_start
--
-- VHDL Entity CERC_trig.fe_readout_sync_mc.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:31:41 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.std_logic_unsigned.ALL;

entity fe_readout_sync_mc is
   port( 
      clk40            : in     std_logic;
      fifo_data_count  : in     std_logic_VECTOR (9 downto 0);
      fifo_full_i      : in     std_logic;
      rst              : in     std_logic;
      readout_sync_out : out    STD_ULOGIC
   );

-- Declarations

end fe_readout_sync_mc ;


-- hds interface_end

--
-- VHDL Architecture CERC_trig.fe_readout_sync_mc.fsm
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:31:41 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;
USE ieee.numeric_std.all;
USE ieee.std_logic_textio.all;
USE ieee.std_logic_unsigned.ALL;

architecture fsm of fe_readout_sync_mc is

   -- Architecture Declarations
   signal shift_data_reg : std_logic_vector(15 downto 0);
   signal count_int : std_logic_vector(4 downto 0);
   signal count_int2 : std_logic_vector(7 downto 0);
   signal count_int3 : std_logic_vector(7 downto 0);

   type state_type is (
      s0,
      s2,
      s4,
      s1,
      s5,
      s3
   );

   -- State vector declaration
   attribute state_vector : string;
   attribute state_vector of fsm : architecture is "current_state" ;


   -- Declare current and next state signals
   signal current_state : state_type ;
   signal next_state : state_type ;

begin

   ----------------------------------------------------------------------------
   clocked : process(
      clk40
   )
   ----------------------------------------------------------------------------
   begin
      if (clk40'event and clk40 = '1') then
         if (rst = '1') then
            current_state <= s0;
            -- Reset Values
            count_int <= "10000";
            count_int2 <= "00000000";
            count_int3 <= "00000000";
            shift_data_reg <= "0000000000000000";
         else
            current_state <= next_state;
            -- Default Assignment To Internals
            count_int <= "10000";
            count_int2 <= "00000000";
            count_int3 <= "00000000";
            shift_data_reg <= "0000000000000000";

            -- Combined Actions for internal signals only
            case current_state is
            when s0 =>
               shift_data_reg <= "0000000000000000";
               count_int <= "10000";
               count_int3 <= "00000000";
               count_int2 <= "00000000";
            when s2 =>
               count_int3 <= count_int3 +1;
            when s4 =>
               shift_data_reg <= shift_data_reg (14 downto 0) & '0';
               count_int <= count_int -1;
            when s1 =>
               shift_data_reg <= "0000000000000000";
               count_int <= "10000";
            when s5 =>
               count_int2 <= count_int2 +1;
            when s3 =>
               shift_data_reg <= "1000" & fifo_data_count &"00"; --32 bit=4 x 8 bit
               count_int <= "10000";
            when others =>
               null;
            end case;

         end if;
      end if;

   end process clocked;

   ----------------------------------------------------------------------------
   nextstate : process (
      count_int,
      count_int2,
      count_int3,
      current_state,
      fifo_full_i
   )
   ----------------------------------------------------------------------------
   begin
      case current_state is
      when s0 =>
         if (fifo_full_i ='0') then
            next_state <= s0;
         elsif (fifo_full_i ='1') then
            next_state <= s1;
         else
            next_state <= s0;
         end if;
      when s2 =>
         if (count_int3="00000010") then
            next_state <= s3;
         else
            next_state <= s2;
         end if;
      when s4 =>
         if (count_int ="00000") then
            next_state <= s5;
         elsif (count_int >"00000") then
            next_state <= s4;
         else
            next_state <= s4;
         end if;
      when s1 =>
            next_state <= s2;
      when s5 =>
         if (count_int2 ="01010010") then
            next_state <= s0;
         else
            next_state <= s5;
         end if;
      when s3 =>
         if (count_int > "00000") then
            next_state <= s4;
         else
            next_state <= s3;
         end if;
      when others =>
         next_state <= s0;
      end case;

   end process nextstate;

   ----------------------------------------------------------------------------
   output : process (
      current_state,
      shift_data_reg
   )
   ----------------------------------------------------------------------------
   begin
      -- Default Assignment
      readout_sync_out <= '0';
      -- Default Assignment To Internals

      -- Combined Actions
      case current_state is
      when s0 =>
         readout_sync_out <='0';
      when s4 =>
         readout_sync_out <= shift_data_reg (15);
      when s1 =>
         readout_sync_out <='0';
      when s3 =>
         readout_sync_out <=  shift_data_reg(15);
      when others =>
         null;
      end case;

   end process output;

   -- Concurrent Statements

end fsm;
