-- hds header_start
--
-- VHDL Entity CERC_trig.fe_trig_shape.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:31:35 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity fe_trig_shape is
   port( 
      clk_in         : in     std_logic;
      crate_trig_i   : in     std_logic;
      fe_trig_en_i   : in     std_logic_vector (7 downto 0);
      rst_in         : in     std_logic;
      trig_be_i      : in     std_logic;
      fe_trig_o      : out    std_logic_vector (7 downto 0);
      fe_trig_sync_o : out    std_logic
   );

-- Declarations

end fe_trig_shape ;


-- hds interface_end

--
-- VHDL Architecture CERC_trig.fe_trig_shape.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 19:31:35 12/04/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;
use IEEE.numeric_std.ALL;
library unisim;
use unisim.VPKG.ALL;

library CERC_lib;

architecture struct of fe_trig_shape is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE           : std_logic;
   signal ZERO          : std_logic;
   signal clk           : std_logic;
   signal clk0          : std_logic;
   signal clk180        : std_logic;
   signal clk270        : std_logic;
   signal clk90         : std_logic;
   signal clk_trigfall  : std_logic;
   signal clr_ce        : std_logic;
   signal rst           : std_logic;
   signal trig_async_fe : std_logic_vector(7 downto 0);
   signal trig_latch_q  : std_logic;
   signal trigin        : STD_LOGIC;


   -- Component Declarations
   component aw_dcm_4phase
   port (
      clk_in    : in     std_logic ;
      rst_in    : in     std_logic ;
      locked_o  : out    std_logic ;
      locked_on : out    std_logic ;
      clk90_o   : out    std_logic ;
      clk180_o  : out    std_logic ;
      clk270_o  : out    std_logic ;
      clk0_o    : out    std_logic 
   );
   end component;
   component edgedet
   port (
      clk     : in     std_logic ;
      rst     : in     std_logic ;
      sig     : in     std_logic ;
      rising  : out    std_logic ;
      falling : out    std_logic 
   );
   end component;
   component fan_en8
   port (
      i  : in     std_logic ;
      en : in     std_logic_vector (7 downto 0);
      o  : out    std_logic_vector (7 downto 0)
   );
   end component;
   component fdcpe_clkz
   port (
      set     : in     std_logic ;
      clr_ce  : in     std_logic ;
      o       : out    std_logic ;
      clr_clk : in     std_logic ;
      rst     : in     std_logic 
   );
   end component;
   component m_buff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_dff
   port (
      D  : in     std_logic ;
      c  : in     std_logic ;
      r  : in     std_logic ;
      Q  : out    std_logic ;
      Qn : out    std_logic 
   );
   end component;
   component m_or2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : aw_dcm_4phase use entity CERC_lib.aw_dcm_4phase;
   for all : edgedet use entity CERC_lib.edgedet;
   for all : fan_en8 use entity CERC_lib.fan_en8;
   for all : fdcpe_clkz use entity CERC_lib.fdcpe_clkz;
   for all : m_buff use entity CERC_lib.m_buff;
   for all : m_dff use entity CERC_lib.m_dff;
   for all : m_or2 use entity CERC_lib.m_or2;
   for all : m_power use entity CERC_lib.m_power;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   I1 : aw_dcm_4phase
      port map (
         clk_in    => clk_in,
         rst_in    => rst_in,
         locked_o  => open,
         locked_on => open,
         clk90_o   => clk90,
         clk180_o  => clk180,
         clk270_o  => clk270,
         clk0_o    => clk0
      );
   edgedet_1 : edgedet
      port map (
         clk     => clk,
         rst     => rst,
         sig     => clr_ce,
         rising  => fe_trig_sync_o,
         falling => open
      );
   fan_en8_1 : fan_en8
      port map (
         i  => trigin,
         en => fe_trig_en_i,
         o  => trig_async_fe
      );
   I2 : m_buff
      port map (
         I => clk_in,
         O => clk_trigfall
      );
   I3 : m_buff
      port map (
         I => clk_in,
         O => clk
      );
   I4 : m_buff
      port map (
         I => rst_in,
         O => rst
      );
   m_dff_2 : m_dff
      port map (
         D  => trigin,
         c  => clk_trigfall,
         r  => rst,
         Q  => trig_latch_q,
         Qn => open
      );
   m_dff_1 : m_dff
      port map (
         D  => trig_latch_q,
         c  => clk_trigfall,
         r  => rst,
         Q  => clr_ce,
         Qn => open
      );
   I0 : m_or2
      port map (
         I1 => trig_be_i,
         I2 => crate_trig_i,
         O  => trigin
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );

   g0: FOR n IN 0 TO 7 GENERATE
      fdcpe_clkz_2 : fdcpe_clkz
         port map (
            set     => trig_async_fe(n),
            clr_ce  => clr_ce,
            o       => fe_trig_o(n),
            clr_clk => clk_trigfall,
            rst     => rst
         );
   end generate g0;

end struct;
