-- hds header_start
--
-- VHDL Entity CERC_trig.sequencer.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 13:40:37 12/06/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity sequencer is
   port( 
      addr_i          : in     std_logic_vector (9 downto 0);
      busy_trig_i     : in     std_logic;
      clk             : in     std_logic;
      db_rd           : in     std_logic;
      db_wr           : in     std_logic;
      reg_sequencer_i : in     std_logic_vector (31 downto 0);
      ren_ram_i       : in     std_logic;
      rst             : in     std_logic;
      seq_busy_o      : out    std_logic;
      trig_seq_o      : out    std_logic_vector (15 downto 0);
      db              : inout  std_logic_vector (31 downto 0)
   );

-- Declarations

end sequencer ;


-- hds interface_end

--
-- VHDL Architecture CERC_trig.sequencer.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 13:40:37 12/06/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library CERC_lib;
library CERC_trig;

architecture struct of sequencer is

   -- Architecture declarations

   -- Internal signal declarations
   signal ram_addr   : std_logic_vector(9 downto 0);
   signal ram_data_i : std_logic_vector(31 downto 0);
   signal ram_data_o : std_logic_vector(31 downto 0);
   signal ram_en     : std_logic;
   signal ram_wr     : std_logic;


   -- Component Declarations
   component cg_ram1kx32
   port (
      addr : in     std_logic_VECTOR (9 downto 0);
      clk  : in     std_logic ;
      din  : in     std_logic_VECTOR (31 downto 0);
      dout : out    std_logic_VECTOR (31 downto 0);
      en   : in     std_logic ;
      we   : in     std_logic 
   );
   end component;
   component seq_control
   generic (
      L : integer := 10
   );
   port (
      rst             : in     std_logic ;
      clk             : in     std_logic ;
      db              : inout  std_logic_vector (31 downto 0);
      db_wr           : in     std_logic ;
      db_rd           : in     std_logic ;
      reg_sequencer_i : in     std_logic_vector (31 downto 0);
      ren_ram_i       : in     std_logic ;
      addr_i          : in     std_logic_vector ((L-1) downto 0);
      ram_data_o      : out    std_logic_vector (31 downto 0);
      ram_data_i      : in     std_logic_vector (31 downto 0);
      ram_addr_o      : out    std_logic_vector ((L-1) downto 0);
      ram_wr_o        : out    std_logic ;
      ram_en_o        : out    std_logic ;
      seq_busy_o      : out    std_logic ;
      trig_seq_o      : out    std_logic_vector (15 downto 0);
      busy_trig_i     : in     std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : cg_ram1kx32 use entity CERC_lib.cg_ram1kx32;
   for all : seq_control use entity CERC_trig.seq_control;
   -- pragma synthesis_on


begin
   -- Instance port mappings.
   cg_ram1kx32_1 : cg_ram1kx32
      port map (
         addr => ram_addr,
         clk  => clk,
         din  => ram_data_o,
         dout => ram_data_i,
         en   => ram_en,
         we   => ram_wr
      );
   seq_control_1 : seq_control
      generic map (
         L => 10
      )
      port map (
         rst             => rst,
         clk             => clk,
         db              => db,
         db_wr           => db_wr,
         db_rd           => db_rd,
         reg_sequencer_i => reg_sequencer_i,
         ren_ram_i       => ren_ram_i,
         addr_i          => addr_i,
         ram_data_o      => ram_data_o,
         ram_data_i      => ram_data_i,
         ram_addr_o      => ram_addr,
         ram_wr_o        => ram_wr,
         ram_en_o        => ram_en,
         seq_busy_o      => seq_busy_o,
         trig_seq_o      => trig_seq_o,
         busy_trig_i     => busy_trig_i
      );

end struct;
