-- hds header_start
--
-- VHDL Entity CERC_trig.trig_en_matrix.symbol
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 13:40:38 12/06/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity trig_en_matrix is
   port( 
      coinc_en_i        : in     std_logic;
      reg_cand0_en_i    : in     std_logic_vector (31 downto 0);
      reg_cand1_en_i    : in     std_logic_vector (31 downto 0);
      reg_cand2_en_i    : in     std_logic_vector (31 downto 0);
      reg_cand3_en_i    : in     std_logic_vector (31 downto 0);
      reg_input_en      : in     std_logic_vector (31 downto 0);
      reg_invert_trig   : in     std_logic_vector (31 downto 0);
      seq_mode_en_i     : in     std_logic;
      trig_cmd_i        : in     std_logic;
      trig_ext_i        : in     std_logic_vector (15 downto 0);
      trig_osc_raw_i    : in     std_logic;
      trig_seq_i        : in     std_logic_vector (15 downto 0);
      trig_cand0_o      : out    std_logic;
      trig_cand0_raw_o  : out    std_logic;
      trig_cand1_o      : out    std_logic;
      trig_cand1_raw_o  : out    std_logic;
      trig_cand2_o      : out    std_logic;
      trig_cand2_raw_o  : out    std_logic;
      trig_cand3_o      : out    std_logic;
      trig_cand3_raw_o  : out    std_logic;
      trig_extall_o     : out    std_logic;
      trig_extall_raw_o : out    std_logic;
      trig_osc_o        : out    std_logic;
      trig_raw_o        : out    std_logic
   );

-- Declarations

end trig_en_matrix ;


-- hds interface_end

--
-- VHDL Architecture CERC_trig.trig_en_matrix.struct
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 13:40:38 12/06/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library CERC_lib;
library CERC_trig;

architecture struct of trig_en_matrix is

   -- Architecture declarations

   -- Internal signal declarations
   signal ONE             : std_logic;
   signal ZERO            : std_logic;
   signal coinc_en_n      : std_logic;
   signal trig_cand0      : std_logic;
   signal trig_cand1      : std_logic;
   signal trig_cand2      : std_logic;
   signal trig_cand3      : std_logic;
   signal trig_ext        : std_logic_vector(15 downto 0);
   signal trig_extall     : std_logic;
   signal trig_extall_raw : std_logic;
   signal trig_osc        : std_logic;


   -- Component Declarations
   component coinc_and
   port (
      cand_en_i  : in     std_logic ;
      coinc_en_i : in     std_logic ;
      en_i       : in     std_logic_vector (15 downto 0);
      inv_in_i   : in     std_logic_vector (15 downto 0);
      inv_out_i  : in     std_logic ;
      trig_i     : in     std_logic_vector (15 downto 0);
      cand_o     : out    std_logic ;
      cand_raw_o : out    std_logic 
   );
   end component;
   component en_orinvn
   generic (
      N : integer := 8
   );
   port (
      en  : in     std_logic_vector (N-1 downto 0);
      I   : in     std_logic_vector (N-1 downto 0);
      O   : out    std_logic ;
      inv : in     std_logic_vector (N-1 downto 0)
   );
   end component;
   component m_and2
   port (
      I1 : in     std_logic ;
      I2 : in     std_logic ;
      O  : out    std_logic 
   );
   end component;
   component m_buff
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_mininv
   port (
      I : in     std_logic ;
      O : out    std_logic 
   );
   end component;
   component m_mux2n
   generic (
      N : integer := 8
   );
   port (
      i0  : in     std_logic_vector (N-1 downto 0);
      sel : in     std_logic ;
      o   : out    std_logic_vector (N-1 downto 0);
      i1  : in     std_logic_vector (N-1 downto 0)
   );
   end component;
   component m_power
   port (
      ONE  : out    std_logic ;
      ZERO : out    std_logic 
   );
   end component;

   -- Optional embedded configurations
   -- pragma synthesis_off
   for all : coinc_and use entity CERC_trig.coinc_and;
   for all : en_orinvn use entity CERC_lib.en_orinvn;
   for all : m_and2 use entity CERC_lib.m_and2;
   for all : m_buff use entity CERC_lib.m_buff;
   for all : m_mininv use entity CERC_lib.m_mininv;
   for all : m_mux2n use entity CERC_lib.m_mux2n;
   for all : m_power use entity CERC_lib.m_power;
   -- pragma synthesis_on


begin
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb_or
   trig_raw_o <=  trig_osc    or
                  trig_cmd_i  or
                  trig_extall or
                  trig_cand0 or
                  trig_cand1 or
                  trig_cand2 or
                  trig_cand3;

   -- Instance port mappings.
   coinc_and_3 : coinc_and
      port map (
         cand_en_i  => reg_input_en(28),
         coinc_en_i => coinc_en_i,
         en_i       => reg_cand3_en_i(15 DOWNTO 0),
         inv_in_i   => reg_cand3_en_i(31 DOWNTO 16),
         inv_out_i  => reg_invert_trig(28),
         trig_i     => trig_ext,
         cand_o     => trig_cand3,
         cand_raw_o => trig_cand3_raw_o
      );
   coinc_and_0 : coinc_and
      port map (
         cand_en_i  => reg_input_en(25),
         coinc_en_i => coinc_en_i,
         en_i       => reg_cand0_en_i(15 DOWNTO 0),
         inv_in_i   => reg_cand0_en_i(31 DOWNTO 16),
         inv_out_i  => reg_invert_trig(25),
         trig_i     => trig_ext,
         cand_o     => trig_cand0,
         cand_raw_o => trig_cand0_raw_o
      );
   coinc_and_1 : coinc_and
      port map (
         cand_en_i  => reg_input_en(26),
         coinc_en_i => coinc_en_i,
         en_i       => reg_cand1_en_i(15 DOWNTO 0),
         inv_in_i   => reg_cand1_en_i(31 DOWNTO 16),
         inv_out_i  => reg_invert_trig(26),
         trig_i     => trig_ext,
         cand_o     => trig_cand1,
         cand_raw_o => trig_cand1_raw_o
      );
   coinc_and_2 : coinc_and
      port map (
         cand_en_i  => reg_input_en(27),
         coinc_en_i => coinc_en_i,
         en_i       => reg_cand2_en_i(15 DOWNTO 0),
         inv_in_i   => reg_cand2_en_i(31 DOWNTO 16),
         inv_out_i  => reg_invert_trig(27),
         trig_i     => trig_ext,
         cand_o     => trig_cand2,
         cand_raw_o => trig_cand2_raw_o
      );
   I1 : en_orinvn
      generic map (
         N => 16
      )
      port map (
         en  => reg_input_en(15 DOWNTO 0),
         I   => trig_ext,
         O   => trig_extall_raw,
         inv => reg_invert_trig(15 DOWNTO 0)
      );
   m_and_1 : m_and2
      port map (
         I1 => trig_osc_raw_i,
         I2 => reg_input_en(24),
         O  => trig_osc
      );
   m_and_2 : m_and2
      port map (
         I1 => trig_extall_raw,
         I2 => coinc_en_n,
         O  => trig_extall
      );
   I19 : m_buff
      port map (
         I => trig_cand3,
         O => trig_cand3_o
      );
   I18 : m_buff
      port map (
         I => trig_cand2,
         O => trig_cand2_o
      );
   I17 : m_buff
      port map (
         I => trig_cand1,
         O => trig_cand1_o
      );
   I15 : m_buff
      port map (
         I => trig_cand0,
         O => trig_cand0_o
      );
   I16 : m_buff
      port map (
         I => trig_osc,
         O => trig_osc_o
      );
   I14 : m_buff
      port map (
         I => trig_extall_raw,
         O => trig_extall_raw_o
      );
   I13 : m_buff
      port map (
         I => trig_extall,
         O => trig_extall_o
      );
   I0 : m_mininv
      port map (
         I => coinc_en_i,
         O => coinc_en_n
      );
   I2 : m_mux2n
      generic map (
         N => 16
      )
      port map (
         i0  => trig_ext_i,
         sel => seq_mode_en_i,
         o   => trig_ext,
         i1  => trig_seq_i
      );
   m_power_1 : m_power
      port map (
         ONE  => ONE,
         ZERO => ZERO
      );

end struct;
