-- hds header_start
--
-- VHDL Architecture CERC_be_fpga.be_trig_top_tester.sim
--
-- Created:
--          by - warren.UNKNOWN (ELECTRON)
--          at - 10:48:52 09/22/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;


entity bt_top_tester is
   port( 
      fe_trig            : in     std_logic_vector (7 downto 0);
      vmeser_rx          : in     std_logic;
      clk_in             : out    std_logic;
      rst_in             : out    std_logic;
      vmeser_tx          : out    std_logic;
      trig_ext           : out    std_logic_vector (15 downto 0);
      fe_trig_enable     : out    std_logic_vector (7 downto 0);
      trig_be            : out    std_logic;
      sink_test_data_fe0 : out    std_logic_vector (31 downto 0);
      clk2x              : out    std_logic;
      readout_sync_in    : out    std_logic;
      readout_sync_out   : in     std_logic;
      tqdr_en            : out    std_logic
   );

-- Declarations

end bt_top_tester ;


-- hds interface_end

architecture test of bt_top_tester is

	constant CLKPERIOD 		: time := 25 ns;

	signal 	clk_osc 			: std_logic := '1';
	signal 	clk_osc2x		: std_logic := '1';
	signal 	clk	 			: std_logic := '1';
	signal 	rst	 			: std_logic := '1';

	signal 	ser_tx 			: std_logic := '0';
	signal 	ser_rx			: std_logic := '0';
	
	signal 	rx_data			: std_logic_vector(31 downto 0) := "00000000000000000000000000000000";
	
	signal   sink_test_data	: std_logic_vector(31 downto 0) := "00000000000000000000010000000000";
	
	
	constant	SREAD				: std_logic := '1';
	constant	SWRITE			: std_logic := '0';
	constant SLENGTH			: std_logic_vector(15 downto 0) := "0000000000100000"; -- 32
	
	
	
	constant TRIG_ENABLE    	: integer :=  1;
	constant TRIG_STATUS     	: integer :=  2;
	constant TRIG_CATCH            	: integer :=  3; 
	constant ENABLE      		: integer :=  4;
	constant TRIG_COUNT     	: integer :=  5;
	constant TRIG_OSC  			: integer :=  6;
	constant BURST_COUNT			: integer :=  7;
	constant PB_TRIG_COUNT  	: integer :=  8;
	constant FW_VERSION       	: integer :=  9;
	constant FW_DATE          	: integer := 10;
	constant CONTROL     		: integer := 11;
	constant COMMAND         	: integer := 12;
	constant FIFO_DATA        	: integer := 13;
	constant FIFO_STATUS      	: integer := 14;
	constant CONFIG 				: integer := 15;
	constant BUSY_TIMEOUT	  	: integer := 16;
	constant BURST_TIMEOUT	  	: integer := 17;
	constant PB_CATCH	  			: integer := 18;
	constant CAND0	  				: integer := 19;
	constant CAND1	  				: integer := 20;
	constant CAND2	  				: integer := 21;
	constant CAND3	  				: integer := 22;
	constant BEAM_MODE	  		: integer := 23;
	constant INVERT	  			: integer := 24;
	constant TRIG_QDR				: integer := 25;
--	constant 						: integer := 26;
	constant SIGS_CATCH			: integer := 27;
	constant SEQUENCER	  	  	: integer := 28;
	constant SQUIRT				: integer := 29;
	constant RAM_DATA         	: integer := 30;
	constant RAM_ADDRESS      	: integer := 31;
	
begin
	
	-- clock generator
	------------------
	clk_osc   <= not clk_osc   after CLKPERIOD / 2;
	clk_osc2x <= not clk_osc2x after CLKPERIOD / 4;
	
	
	clk_in <= clk_osc;
	clk 	 <= clk_osc;
	
	clk2x  <= clk_osc2x;
	
	rst_in <= rst;
	
	-- IO Assignments
	-----------------
   vmeser_tx <= ser_tx;
	ser_rx <= vmeser_rx;
	
	
	-- test data generator
	sink_test_data <= sink_test_data + '1' after CLKPERIOD;
	sink_test_data_fe0 <= sink_test_data;
	
	-- this does not work - why???
	--readout_sync_in <= readout_sync_out after 200 ns;
	
	-----------------------------------------------------------------------
	main_sim: process

		-- Procedures
		----------------------------------------------------------------
		procedure Serial_Read(iss_desig, iss_addr : in integer ) is
			variable	ss_desig : std_logic_vector(4 downto 0);
			variable	ss_addr	: std_logic_vector(15 downto 0);
			variable	srn	   : integer;
			--variable SLENGTH_PLUS1 : std_logic_vector(15 downto 0);
		begin
			ss_desig := CONV_STD_LOGIC_VECTOR(iss_desig, 5);
			ss_addr  := CONV_STD_LOGIC_VECTOR(iss_addr, 16);
			--SLENGTH_PLUS1 := SLENGTH + '1';
			wait until rising_edge(clk); wait for 1 ns;
			ser_tx <= '1'; 					-- start bit
			wait until rising_edge(clk); wait for 1 ns;
			ser_tx <= SREAD; 					-- read/write bit
			wait until rising_edge(clk); wait for 1 ns;
			for srn in 4 downto 0 loop		-- designator (4:0)
				ser_tx <= ss_desig(srn);
				wait until rising_edge(clk); wait for 1 ns;
			end loop;
			ser_tx <= '1'; 					-- length start bit
			wait until rising_edge(clk); wait for 1 ns;
			for srn in 15 downto 0 loop		-- length (15:0)
				--ser_tx <= SLENGTH_PLUS1(n);
				ser_tx <= ss_addr(srn);
				wait until rising_edge(clk); wait for 1 ns;
			end loop;
			ser_tx <= '1'; 					-- 'stop' bit
			wait until rising_edge(clk); wait for 1 ns;
			ser_tx <= '0';

			-- Get returned data
			------------------------------------
			--for srn in 1 to 3 loop				-- rx data latency
				wait until rising_edge(clk);  wait for 1 ns;
			--end loop;
			for srn in 31 downto 0 loop		-- rx data
				wait for 5 ns;
				rx_data(srn) <= ser_rx;
				wait until rising_edge(clk); wait for 1 ns;
			end loop;
			wait until rising_edge(clk); wait for 1 ns;
			wait for 100 ns;
		end procedure;
		----------------------------------------------------------------
		procedure Serial_Write( iss_desig, iss_addr, iss_data : in integer ) is
			variable	ss_desig : std_logic_vector(4 downto 0);
			variable	ss_addr	: std_logic_vector(15 downto 0);
			variable	ss_data	: std_logic_vector(31 downto 0);									
			variable	swn	   : integer;
		begin
			ss_desig := CONV_STD_LOGIC_VECTOR(iss_desig, 5);
			ss_addr  := CONV_STD_LOGIC_VECTOR(iss_addr, 16);
			ss_data	:= CONV_STD_LOGIC_VECTOR(iss_data, 32);
			wait until rising_edge(clk); wait for 1 ns;
			ser_tx <= '1'; 					-- start bit
			wait until rising_edge(clk); wait for 1 ns;
			ser_tx <= SWRITE; 				-- read/write bit
			wait until rising_edge(clk); wait for 1 ns;
   		for swn in 4 downto 0 loop		-- designator (4:0)
				ser_tx <= ss_desig(swn);
				wait until rising_edge(clk); wait for 1 ns;
			end loop;
			ser_tx <= '1'; 					-- addr start bit (ex length field)
			wait until rising_edge(clk); wait for 1 ns;
			for swn in 15 downto 0 loop		-- addr (15:0) (was length field)
				ser_tx <= ss_addr(swn);
				wait until rising_edge(clk); wait for 1 ns;
			end loop;
			for swn in 31 downto 0 loop		-- data
				ser_tx <= ss_data(swn);
				wait until rising_edge(clk); wait for 1 ns;
			end loop;
			ser_tx <= '0'; 					-- idle
			wait until rising_edge(clk); wait for 1 ns;
			wait for 100 ns;
		end procedure;
		---------------------------------------------------------------
		procedure RegRead(iss_desig : in integer ) is
		begin
			Serial_Read(iss_desig, 0);
		end procedure;
		---------------------------------------------------------------
		procedure RegWrite(iss_desig, iss_data : in integer ) is
		begin
			Serial_Write(iss_desig, 0, iss_data);
		end procedure;
		---------------------------------------------------------------
		procedure RAMRead(iss_addr : in integer ) is
		begin
			Serial_Write(RAM_ADDRESS, 0, iss_addr);
			Serial_Read(RAM_DATA, 0);
		end procedure;
		---------------------------------------------------------------
		procedure RAMWrite(iss_addr, iss_data : in integer ) is
		begin
			Serial_Write(RAM_ADDRESS, 0, iss_addr);
			Serial_Write(RAM_DATA, 0, iss_data);
		end procedure;
		---------------------------------------------------------------
		procedure Send_Trig_Cmd is
		begin
			RegWrite(COMMAND,0);
			RegWrite(COMMAND,1);
			RegWrite(COMMAND,0);
		end procedure;
		---------------------------------------------------------------
		procedure Clear_Busy is
		begin
			RegWrite(CONTROL,0);
		end procedure;
		---------------------------------------------------------------
		procedure WaitClks(len : in integer) is
		begin
			wait for (len * 25 ns) - 10 ns;
			wait until rising_edge(clk); wait for 1 ns;
		end procedure;
		---------------------------------------------------------------

		---------------------------------------------------------------
		procedure Test_Squirt is
		begin
		
			for n in 1 to 320 loop
				trig_ext <= conv_std_logic_vector(n, 16);
				wait until rising_edge(clk);  wait for 2 ns;
			end loop;
			Send_Trig_Cmd;
			for n in 1000 to 1710 loop
				trig_ext <= conv_std_logic_vector(n, 16);
				wait until rising_edge(clk);  wait for 2 ns;
			end loop;
		
			--RegRead(CONTROL);
			--RegRead(FIFO_STATUS);

			--RegRead(FIFO_DATA);
			
			RegRead(SQUIRT);

			wait for 1025 * 25 ns;
			wait until rising_edge(clk);  wait for 2 ns;
						
		
		end procedure;	
	
		-----------------------------------------------------------------------------
		procedure Test_Busy is
		begin
		
			RegRead(FIFO_STATUS);
			RegRead(FIFO_DATA);
			RegWrite(TRIG_ENABLE,1);		-- Enable trig-ext0
		 	fe_trig_enable 	<= (others => '1'); -- enable all fe trigs
	
			wait for 100 ns;
	
			wait for 5 ns;
			trig_ext(0) <= '1';      -- Send trig ext 0
			wait for 10 ns;
			trig_ext(0) <= '0';
			wait for 10 ns;
	
			
	
			Send_Trig_Cmd;
			Send_Trig_Cmd;
			Clear_Busy;
			Send_Trig_Cmd;
		
		end procedure;

		---------------------------------------------------------------
		procedure Test_Async_Trig_with_Busy_Timeout is
		begin
		
			RegWrite(TRIG_ENABLE,1);		-- Enable trig-ext0
			RegWrite(BUSY_TIMEOUT,10);		-- Busy-Timeout Period
			RegWrite(ENABLE,16#0002#);		-- Enable Busy-Timeout
			
			WaitClks(40);
			
			for dly in 1 to 100 loop
			
				wait for dly * 53 ns;
				trig_ext(0) <= '1';      -- Send trig ext 0
				wait for dly * 10 ns;
				trig_ext(0) <= '0';
				wait for 10 ns;
				
			end loop;
			
		end procedure;
		
		
		---------------------------------------------------------------
		procedure Test_Sequencer is
		begin
		
			RamWrite( 16#00#, 15);
			RamWrite( 16#04#, 14);
			RamWrite( 16#08#, 13);
			RamWrite( 16#0C#, 12);
			RamWrite( 16#10#, 11);
			RamWrite( 16#14#, 10);
			RamWrite( 16#18#,  9);
			RamWrite( 16#1C#,  8);
			RamWrite( 16#20#,  7);
			RamWrite( 16#24#,  6);
			RamWrite( 16#28#,  5);
			RamWrite( 16#2C#,  4);
			RamWrite( 16#30#,  3);
			RamWrite( 16#34#,  2);
			RamWrite( 16#38#,  1);
			RamWrite( 16#3C#,  0);

			WaitClks(20);
		
			RegWrite(SEQUENCER,16#800AFFFF#); -- seq_reset, 10 count, en all seq_trigs
			RegWrite(SEQUENCER,16#400AFFFF#); -- + Go
			
			WaitClks(20);
			
			RegWrite(SEQUENCER,16#A00EFFFF#); -- seq_reset, en_cyclic, 16 count, en all seq_trigs
			RegWrite(SEQUENCER,16#600EFFFF#); -- + Go
			
			WaitClks(100);
			
		end procedure;
		
		---------------------------------------------------------------
		procedure Test_Burst is
		begin
		
			RegWrite(TRIG_ENABLE,1);	-- Enable trig-ext0
			RegWrite(BUSY_TIMEOUT,8);	-- Busy-Timeout Period
			RegWrite(BURST_COUNT,5);			-- Busy Len 5
			RegWrite(BURST_TIMEOUT,16#00010003#); -- 1ms IBTO, 3ms BTO 			
						
			RegWrite(ENABLE,16#0072#); 	-- Enable tbto, burst, bto, ibto
			
			WaitClks(2);
			RegWrite(CONTROL,16#0000#);   -- Clear all Busys
			
			WaitClks(40);
			
			for dly in 1 to 1000 loop
			
				wait for dly * 250 ns;
				trig_ext(0) <= '1';      -- Send trig ext 0
				wait for dly * 10 ns;
				trig_ext(0) <= '0';
				wait for 10 ns;
				
			end loop;
			
		end procedure;
		
		
		---------------------------------------------------------------
		procedure Test_FIFO_VME is
			variable  i : integer;
			variable  n0 : integer;
		begin
		
			-- Loop through all pattern modes
			for n0 in 0 to 3 loop 
		
				RegWrite(TRIG_ENABLE, 16#00008000#);
				RegWrite(CONFIG, 16#00050000# + n0); --idle depth = 5 + pattern mode
				
				--Fill FIFO
				----------------------------------------------
				for n in 1 to 150 loop
					
					i := 2 ** (n mod 16);

					trig_ext <= conv_std_logic_vector(i, 16);
					WaitClks(1);
					
				end loop;
				
				RegWrite(ENABLE, 16#00000000#);
				
				WaitClks(10);
				
				-- Read Out FIFO
				---------------------------------------------------
				for n in 1 to 60 loop
					RegRead(FIFO_DATA);
					
				end loop;
			
				RegWrite(CONTROL, 0); -- clear busy
				
				WaitClks(100);
				
				
			end loop;

		end procedure;	
		-----------------------------------------------------------------------------
		
		
		procedure Test_FIFO_QDR is
			variable  i : integer;
			variable  n0 : integer;
		begin
		
			RegWrite(TRIG_QDR, 16#00010002#); -- Readout delay 1, frame sync delay 2 ??
			
			tqdr_en <= '1';
		
		
			-- Loop through all pattern modes
			for n0 in 0 to 3 loop 
		
			
				RegWrite(TRIG_ENABLE, 	16#00008000#);
				RegWrite(CONFIG, 			16#00050000# + n0); --idle depth = 5 + pattern mode
				
		
				
				--Fill FIFO
				----------------------------------------------
				for n in 1 to 150 loop
					
					i := 2 ** (n mod 16);

					trig_ext <= conv_std_logic_vector(i, 16);
					WaitClks(1);
					
				end loop;
				
				RegWrite(ENABLE, 16#00000000#);
				
				
				readout_sync_in	<= '1';
				WaitClks(1);
				--*** readout_sync_in NOT dealt with outside process (see above)
				readout_sync_in	<= '0';
				
				-- Wait for FIFO readout
				WaitClks(1000);
		
				
				
				RegWrite(CONTROL, 0); -- clear busy				
				WaitClks(1000);
				
			end loop;

		end procedure;	
		-----------------------------------------------------------------------------
		
		
		
		---------------------------------------------------------------

		

		
	----------------------------------------------------------------------
	-- Main Simulation
	----------------------------------------------------------------------
	begin
		      
		wait for 1 ns;
	   
		-- Initial Values
		trig_ext 			<= (others => '0');
	 	fe_trig_enable 	<= (others => '0');
      trig_be        	<= '0';
      readout_sync_in	<= '0';
      tqdr_en         	<= '0';
      
            
      
		
		-- Reset
		rst <= '1';
		wait for 100 ns;
		rst <= '0';
		wait for 2000 ns;


				
		--Test_Async_Trig_with_Busy_Timeout;
		--Test_Sequencer;
		--Test_Squirt;
		--Test_Burst;
		--Test_FIFO_VME;
		Test_FIFO_QDR;

			
		
		wait;      
  	end process;  
end test;
