-- hds header_start
--
-- VHDL Entity back_end_fpga.APV_frame_gen.symbol
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:43:28 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


ENTITY APV_frame_gen IS
   PORT( 
      clk       : IN     std_logic;
      en        : IN     std_logic;
      rst       : IN     std_logic;
      APV_frame : OUT    std_logic;
      ana_dat   : OUT    std_logic
   );

-- Declarations

END APV_frame_gen ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.APV_frame_gen.fsm
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:43:28 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY exemplar;
USE exemplar.exemplar_1164.all;

-- synopsys translate_off
-- LIBRARY unisim;
-- USE unisim.all;
-- synopsys translate_on

ARCHITECTURE fsm OF APV_frame_gen IS

   -- Architecture Declarations
   signal cnt: std_logic_vector (7 downto 0);

   TYPE STATE_TYPE IS (
      s0,
      s2,
      s3,
      s5,
      s6,
      s8,
      s9,
      s11,
      s12,
      s14,
      s15,
      s17,
      s18,
      s19,
      s20,
      s21,
      s22,
      s24,
      s25,
      s26
   );

   -- State vector declaration
   ATTRIBUTE state_vector : string;
   ATTRIBUTE state_vector OF fsm : ARCHITECTURE IS "current_state" ;


   -- Declare current and next state signals
   SIGNAL current_state : STATE_TYPE ;
   SIGNAL next_state : STATE_TYPE ;

   -- Declare any pre-registered internal signals
   SIGNAL APV_frame_int : std_logic  ;
   SIGNAL ana_dat_int : std_logic  ;

BEGIN

   ----------------------------------------------------------------------------
   clocked : PROCESS(
      clk,
      rst
   )
   ----------------------------------------------------------------------------
   BEGIN
      IF (rst = '1') THEN
         current_state <= s0;
         -- Reset Values
         APV_frame <= '0';
         ana_dat <= '0';
         cnt <= "00000000";
      ELSIF (clk'EVENT AND clk = '1') THEN
         IF (en = '1') THEN
            current_state <= next_state;
            -- Registered output assignments
            APV_frame <= APV_frame_int;
            ana_dat <= ana_dat_int;

            -- Default Assignment To Internals

            -- Transition Actions for internal signals only
            CASE current_state IS
            WHEN s0 =>
               IF (rst = '0') THEN
                  cnt <= "00000000";
               END IF;
            WHEN s2 =>
               IF (cnt = "01000100") THEN
               ELSE
                  cnt <= cnt + "1";
               END IF;
            WHEN s3 =>
               cnt <= "00000000";
            WHEN s5 =>
               IF (cnt = "01000100") THEN
               ELSE
                  cnt <= cnt + "1";
               END IF;
            WHEN s6 =>
               cnt <= "00000000";
            WHEN s8 =>
               IF (cnt = "01000100") THEN
               ELSE
                  cnt <= cnt + "1";
               END IF;
            WHEN s9 =>
               cnt <= "00000000";
            WHEN s11 =>
               IF (cnt = "01000100") THEN
               ELSE
                  cnt <= cnt + "1";
               END IF;
            WHEN s12 =>
               cnt <= "00000000";
            WHEN s14 =>
               IF (cnt = "01000100") THEN
               ELSE
                  cnt <= cnt + "1";
               END IF;
            WHEN s15 =>
               cnt <= "00000000";
            WHEN s17 =>
               IF (cnt = "00000011") THEN
               ELSE
                  cnt <= cnt + "1";
               END IF;
            WHEN s18 =>
               IF (cnt = "00000110") THEN
               ELSE
                  cnt <= cnt + "1";
               END IF;
            WHEN s19 =>
               IF (cnt = "00001001") THEN
               ELSE
                  cnt <= cnt + "1";
               END IF;
            WHEN s20 =>
               IF (cnt = "00010000") THEN
               ELSE
                  cnt <= cnt + "1";
               END IF;
            WHEN s21 =>
               cnt <= "00000000";
            WHEN s22 =>
               cnt <= "00000000";
            WHEN s24 =>
               IF (cnt = "11111111") THEN
               ELSE
                  cnt <= cnt + "1";
               END IF;
            WHEN s26 =>
               cnt <= "00000000";
            WHEN OTHERS =>
               NULL;
            END CASE;

         END IF;
      END IF;

   END PROCESS clocked;

   ----------------------------------------------------------------------------
   nextstate : PROCESS (
      cnt,
      current_state,
      rst
   )
   ----------------------------------------------------------------------------
   BEGIN
      IF current_state = s0 AND (rst = '0') THEN
         next_state <= s2;
      ELSIF current_state = s0 THEN
         next_state <= s0;
      ELSIF current_state = s2 AND (cnt = "01000100") THEN
         next_state <= s3;
      ELSIF current_state = s2 THEN
         next_state <= s2;
      ELSIF current_state = s3 THEN
         next_state <= s5;
      ELSIF current_state = s5 AND (cnt = "01000100") THEN
         next_state <= s6;
      ELSIF current_state = s5 THEN
         next_state <= s5;
      ELSIF current_state = s6 THEN
         next_state <= s8;
      ELSIF current_state = s8 AND (cnt = "01000100") THEN
         next_state <= s9;
      ELSIF current_state = s8 THEN
         next_state <= s8;
      ELSIF current_state = s9 THEN
         next_state <= s11;
      ELSIF current_state = s11 AND (cnt = "01000100") THEN
         next_state <= s12;
      ELSIF current_state = s11 THEN
         next_state <= s11;
      ELSIF current_state = s12 THEN
         next_state <= s14;
      ELSIF current_state = s14 AND (cnt = "01000100") THEN
         next_state <= s15;
      ELSIF current_state = s14 THEN
         next_state <= s14;
      ELSIF current_state = s15 THEN
         next_state <= s17;
      ELSIF current_state = s17 AND (cnt = "00000011") THEN
         next_state <= s18;
      ELSIF current_state = s17 THEN
         next_state <= s17;
      ELSIF current_state = s18 AND (cnt = "00000110") THEN
         next_state <= s19;
      ELSIF current_state = s18 THEN
         next_state <= s18;
      ELSIF current_state = s19 AND (cnt = "00001001") THEN
         next_state <= s20;
      ELSIF current_state = s19 THEN
         next_state <= s19;
      ELSIF current_state = s20 AND (cnt = "00010000") THEN
         next_state <= s21;
      ELSIF current_state = s20 THEN
         next_state <= s20;
      ELSIF current_state = s21 THEN
         next_state <= s22;
      ELSIF current_state = s22 THEN
         next_state <= s24;
      ELSIF current_state = s24 AND (cnt = "11111111") THEN
         next_state <= s25;
      ELSIF current_state = s24 THEN
         next_state <= s24;
      ELSIF current_state = s25 THEN
         next_state <= s26;
      ELSIF current_state = s26 THEN
         next_state <= s2;
      ELSE
         next_state <= s0;
      END IF;

   END PROCESS nextstate;

   ----------------------------------------------------------------------------
   output : PROCESS (
      cnt,
      current_state
   )
   ----------------------------------------------------------------------------
   BEGIN
      -- Default Assignment
      APV_frame_int <= '0';
      ana_dat_int <= '0';
      -- Default Assignment To Internals

      -- State Actions
      CASE current_state IS

      WHEN s2 =>

         APV_frame_int <= '0';
      WHEN s3 =>

         APV_frame_int <= '1';
      WHEN s5 =>

         APV_frame_int <= '0';
      WHEN s6 =>

         APV_frame_int <= '1';
      WHEN s8 =>

         APV_frame_int <= '0';
      WHEN s9 =>

         APV_frame_int <= '1';
      WHEN s11 =>

         APV_frame_int <= '0';
      WHEN s12 =>

         APV_frame_int <= '1';
      WHEN s14 =>

         APV_frame_int <= '0';
      WHEN s15 =>

         APV_frame_int <= '1';
      WHEN s17 =>

         APV_frame_int <= '1';
      WHEN s18 =>

         APV_frame_int <= '0';
      WHEN s19 =>

         APV_frame_int <= '1';

      WHEN s21 =>

         APV_frame_int <= '1';


      WHEN s25 =>

         APV_frame_int <= '1';
      WHEN s26 =>

         APV_frame_int <= '1';
      WHEN OTHERS =>
         NULL;
      END CASE;

      -- State Actions Clocked On Next State
      -- Transition Actions
      CASE current_state IS
      WHEN s2 =>
         IF (cnt = "01000100") THEN
            APV_frame_int <= '1';
         END IF;
      WHEN s5 =>
         IF (cnt = "01000100") THEN
            APV_frame_int <= '1';
         END IF;
      WHEN s8 =>
         IF (cnt = "01000100") THEN
            APV_frame_int <= '1';
         END IF;
      WHEN s11 =>
         IF (cnt = "01000100") THEN
            APV_frame_int <= '1';
         END IF;
      WHEN s14 =>
         IF (cnt = "01000100") THEN
            APV_frame_int <= '1';
         END IF;
      WHEN s17 =>
         IF (cnt = "00000011") THEN
            APV_frame_int <= '1';
         END IF;
      WHEN s18 =>
         IF (cnt = "00000110") THEN
            APV_frame_int <= '0';
         END IF;
      WHEN s19 =>
         IF (cnt = "00001001") THEN
            APV_frame_int <= '1';
         END IF;
      WHEN s20 =>
         IF (cnt = "00010000") THEN
            APV_frame_int <= '0';
         END IF;
      WHEN s21 =>
         APV_frame_int <= '1';
      WHEN s22 =>
         APV_frame_int <= '1';
      WHEN s24 =>
         IF (cnt = "11111111") THEN
            ana_dat_int <= '1';
         ELSE
            ana_dat_int <= '1';
         END IF;
      WHEN OTHERS =>
         NULL;
      END CASE;

   END PROCESS output;

   -- Concurrent Statements

END fsm;
