-- hds header_start
--
-- VHDL Entity back_end_fpga.data_merger.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:37:37 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;

ENTITY data_merger IS
   PORT( 
      clk2x      : IN     std_logic;
      data1      : IN     std_logic_vector (7 DOWNTO 0);
      data2      : IN     std_logic_vector (7 DOWNTO 0);
      data3      : IN     std_logic_vector (7 DOWNTO 0);
      data4      : IN     std_logic_vector (7 DOWNTO 0);
      data5      : IN     std_logic_vector (7 DOWNTO 0);
      data6      : IN     std_logic_vector (7 DOWNTO 0);
      data7      : IN     std_logic_vector (7 DOWNTO 0);
      data8      : IN     std_logic_vector (7 DOWNTO 0);
      mux1to8_en : IN     std_logic;
      reset      : IN     std_logic;
      fe_data    : OUT    std_logic_vector (63 DOWNTO 0)
   );

-- Declarations

END data_merger ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.data_merger.struct_1
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:37:39 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY back_end_fpga;

ARCHITECTURE struct_1 OF data_merger IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL dout1     : std_logic_vector(63 DOWNTO 0);
   SIGNAL dout1_rdy : std_logic;
   SIGNAL dout2     : std_logic_vector(63 DOWNTO 0);
   SIGNAL dout2_rdy : std_logic;
   SIGNAL dout3     : std_logic_vector(63 DOWNTO 0);
   SIGNAL dout3_rdy : std_logic;
   SIGNAL dout4     : std_logic_vector(63 DOWNTO 0);
   SIGNAL dout4_rdy : std_logic;
   SIGNAL dout5     : std_logic_vector(63 DOWNTO 0);
   SIGNAL dout5_rdy : std_logic;
   SIGNAL dout6     : std_logic_vector(63 DOWNTO 0);
   SIGNAL dout6_rdy : std_logic;
   SIGNAL dout7     : std_logic_vector(63 DOWNTO 0);
   SIGNAL dout7_rdy : std_logic;
   SIGNAL dout8     : std_logic_vector(63 DOWNTO 0);
   SIGNAL dout8_rdy : std_logic;
   SIGNAL dout_rdy  : std_logic;


   -- Component Declarations
   COMPONENT mux1to8
   GENERIC (
      widthin  : INTEGER := 8;
      widthout : INTEGER := 64
   );
   PORT (
      clk      : IN     std_logic ;
      din      : IN     std_logic_vector (widthin-1 DOWNTO 0);
      enable   : IN     std_logic ;
      reset    : IN     std_logic ;
      dout     : OUT    std_logic_vector (widthout-1 DOWNTO 0);
      dout_rdy : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT rdout_mux8to1
   GENERIC (
      widthout : integer := 64
   );
   PORT (
      clk2x    : IN     std_logic ;
      dout1    : IN     std_logic_vector (63 DOWNTO 0);
      dout2    : IN     std_logic_vector (63 DOWNTO 0);
      dout3    : IN     std_logic_vector (63 DOWNTO 0);
      dout4    : IN     std_logic_vector (63 DOWNTO 0);
      dout5    : IN     std_logic_vector (63 DOWNTO 0);
      dout6    : IN     std_logic_vector (63 DOWNTO 0);
      dout7    : IN     std_logic_vector (63 DOWNTO 0);
      dout8    : IN     std_logic_vector (63 DOWNTO 0);
      dout_rdy : IN     std_logic ;
      reset    : IN     std_logic ;
      fe_data  : OUT    std_logic_vector (63 DOWNTO 0)
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : mux1to8 USE ENTITY back_end_fpga.mux1to8;
   FOR ALL : rdout_mux8to1 USE ENTITY back_end_fpga.rdout_mux8to1;
   -- pragma synthesis_on


BEGIN

   -- ModuleWare code for instance 'I0' of 'or8'
   dout_rdy <= dout1_rdy OR dout2_rdy OR dout3_rdy OR dout4_rdy OR dout5_rdy OR dout6_rdy OR dout7_rdy OR dout8_rdy;
   -- Instance port mappings.
   I13 : mux1to8
      GENERIC MAP (
         widthin  => 8,
         widthout => 64
      )
      PORT MAP (
         clk      => clk2x,
         din      => data4,
         enable   => mux1to8_en,
         reset    => reset,
         dout     => dout4,
         dout_rdy => dout4_rdy
      );
   I12 : mux1to8
      GENERIC MAP (
         widthin  => 8,
         widthout => 64
      )
      PORT MAP (
         clk      => clk2x,
         din      => data3,
         enable   => mux1to8_en,
         reset    => reset,
         dout     => dout3,
         dout_rdy => dout3_rdy
      );
   I9 : mux1to8
      GENERIC MAP (
         widthin  => 8,
         widthout => 64
      )
      PORT MAP (
         clk      => clk2x,
         din      => data2,
         enable   => mux1to8_en,
         reset    => reset,
         dout     => dout2,
         dout_rdy => dout2_rdy
      );
   I17 : mux1to8
      GENERIC MAP (
         widthin  => 8,
         widthout => 64
      )
      PORT MAP (
         clk      => clk2x,
         din      => data8,
         enable   => mux1to8_en,
         reset    => reset,
         dout     => dout8,
         dout_rdy => dout8_rdy
      );
   I16 : mux1to8
      GENERIC MAP (
         widthin  => 8,
         widthout => 64
      )
      PORT MAP (
         clk      => clk2x,
         din      => data7,
         enable   => mux1to8_en,
         reset    => reset,
         dout     => dout7,
         dout_rdy => dout7_rdy
      );
   I15 : mux1to8
      GENERIC MAP (
         widthin  => 8,
         widthout => 64
      )
      PORT MAP (
         clk      => clk2x,
         din      => data6,
         enable   => mux1to8_en,
         reset    => reset,
         dout     => dout6,
         dout_rdy => dout6_rdy
      );
   I14 : mux1to8
      GENERIC MAP (
         widthin  => 8,
         widthout => 64
      )
      PORT MAP (
         clk      => clk2x,
         din      => data5,
         enable   => mux1to8_en,
         reset    => reset,
         dout     => dout5,
         dout_rdy => dout5_rdy
      );
   I11 : mux1to8
      GENERIC MAP (
         widthin  => 8,
         widthout => 64
      )
      PORT MAP (
         clk      => clk2x,
         din      => data1,
         enable   => mux1to8_en,
         reset    => reset,
         dout     => dout1,
         dout_rdy => dout1_rdy
      );
   I1 : rdout_mux8to1
      GENERIC MAP (
         widthout => 64
      )
      PORT MAP (
         clk2x    => clk2x,
         dout1    => dout1,
         dout2    => dout2,
         dout3    => dout3,
         dout4    => dout4,
         dout5    => dout5,
         dout6    => dout6,
         dout7    => dout7,
         dout8    => dout8,
         dout_rdy => dout_rdy,
         reset    => reset,
         fe_data  => fe_data
      );

END struct_1;
