-- hds header_start
--
-- VHDL Entity back_end_fpga.deserialiser_80.symbol
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:38:46 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY deserialiser_80 IS
   PORT( 
      clk   : IN     std_logic;
      clr_Q : IN     std_logic;
      data  : IN     std_logic;
      en    : IN     std_logic;
      reset : IN     std_logic;
      Q     : OUT    std_logic_vector (79 DOWNTO 0);
      done  : OUT    std_logic
   );

-- Declarations

END deserialiser_80 ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.deserialiser_80.fsm
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:38:46 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ARCHITECTURE fsm OF deserialiser_80 IS

   -- Architecture Declarations
   signal data_count : integer range 0 to 82;
   signal tmp_q : std_logic_vector(81 downto 0);

   TYPE STATE_TYPE IS (
      ser_0,
      ser_2,
      ser_3,
      ser_1,
      ser_4
   );

   -- State vector declaration
   ATTRIBUTE state_vector : string;
   ATTRIBUTE state_vector OF fsm : ARCHITECTURE IS "current_state" ;


   -- Declare current and next state signals
   SIGNAL current_state : STATE_TYPE ;
   SIGNAL next_state : STATE_TYPE ;

   -- Declare any pre-registered internal signals
   SIGNAL Q_cld : std_logic_vector (79 DOWNTO 0) ;
   SIGNAL done_cld : std_logic  ;

BEGIN

   ----------------------------------------------------------------------------
   clocked : PROCESS(
      clk,
      reset
   )
   ----------------------------------------------------------------------------
   BEGIN
      IF (reset = '1') THEN
         current_state <= ser_0;
         -- Reset Values
         Q_cld <= (others => '0');
         done_cld <= '0';
         data_count <= 0;
         tmp_q <= (others => '0');
      ELSIF (clk'EVENT AND clk = '1') THEN
         current_state <= next_state;
         -- Default Assignment To Internals

         -- Combined Actions for internal signals only
         CASE current_state IS
         WHEN ser_0 =>
            data_count <= 0;
            done_cld <= '0' ;
            tmp_q <= (others => '0') ;
            Q_cld <= (others => '0');
         WHEN ser_2 =>
            tmp_q(data_count) <= data;
            data_count <= data_count  - 1;
         WHEN ser_3 =>
            Q_cld <= tmp_q (81 downto 2)
            after 1 ns ;
            done_cld <= '1' after 1 ns ;
         WHEN ser_1 =>
            data_count <= 81;
         WHEN OTHERS =>
            NULL;
         END CASE;

      END IF;

   END PROCESS clocked;

   ----------------------------------------------------------------------------
   nextstate : PROCESS (
      clr_Q,
      current_state,
      data,
      data_count,
      en
   )
   ----------------------------------------------------------------------------
   BEGIN
      CASE current_state IS
      WHEN ser_0 =>
         IF (en = '1') THEN
            next_state <= ser_1;
         ELSE
            next_state <= ser_0;
         END IF;
      WHEN ser_2 =>
         IF (data_count = 2) THEN
            next_state <= ser_3;
         ELSE
            next_state <= ser_2;
         END IF;
      WHEN ser_3 =>
         IF (clr_Q = '1') THEN
            next_state <= ser_4;
         ELSE
            next_state <= ser_3;
         END IF;
      WHEN ser_1 =>
         IF (en = '0') THEN
            next_state <= ser_0;
         ELSIF (data = '1' AND en = '1') THEN
            next_state <= ser_2;
         ELSE
            next_state <= ser_1;
         END IF;
      WHEN ser_4 =>
         IF (clr_Q = '0') THEN
            next_state <= ser_0;
         ELSE
            next_state <= ser_4;
         END IF;
      WHEN OTHERS =>
         next_state <= ser_0;
      END CASE;

   END PROCESS nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   Q <= Q_cld;
   done <= done_cld;


END fsm;
