-- hds header_start
--
-- VHDL Entity back_end_fpga.enable_inputDDR.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:37:39 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY enable_inputDDR IS
   PORT( 
      FE_enable_reg        : IN     std_logic_vector (8 DOWNTO 1);
      clk2x                : IN     std_logic;
      frm_addr_fifo_empty  : IN     std_logic;
      rdout_sync_out_sig1  : IN     std_logic;
      reset                : IN     std_logic;
      store_frame_data_bus : IN     std_logic_VECTOR (7 DOWNTO 0);
      inputDDR_en          : OUT    std_logic
   );

-- Declarations

END enable_inputDDR ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.enable_inputDDR.fsm
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:37:39 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ARCHITECTURE fsm OF enable_inputDDR IS

   -- Architecture Declarations
   signal count : integer range 0 to 8;

   TYPE STATE_TYPE IS (
      in_ddr_0,
      in_ddr_1,
      in_ddr_2,
      in_ddr_3,
      in_ddr_4,
      in_ddr_5,
      in_ddr_6,
      in_ddr_7,
      in_ddr_8
   );

   -- State vector declaration
   ATTRIBUTE state_vector : string;
   ATTRIBUTE state_vector OF fsm : ARCHITECTURE IS "current_state" ;


   -- Declare current and next state signals
   SIGNAL current_state : STATE_TYPE ;
   SIGNAL next_state : STATE_TYPE ;

   -- Declare any pre-registered internal signals
   SIGNAL inputDDR_en_cld : std_logic  ;

BEGIN

   ----------------------------------------------------------------------------
   clocked : PROCESS(
      clk2x,
      reset
   )
   ----------------------------------------------------------------------------
   BEGIN
      IF (reset = '1') THEN
         current_state <= in_ddr_0;
         -- Reset Values
         inputDDR_en_cld <= '0';
         count <= 0;
      ELSIF (clk2x'EVENT AND clk2x = '1') THEN
         current_state <= next_state;
         -- Default Assignment To Internals
         count <= 0;

         -- Combined Actions for internal signals only
         CASE current_state IS
         WHEN in_ddr_0 =>
            inputDDR_en_cld <= '0' ;
            count <= 0 ;
         WHEN in_ddr_2 =>
            count <= count + 1;
         WHEN in_ddr_3 =>
            inputDDR_en_cld <= '1' after 1 ns;
         WHEN in_ddr_4 =>
            IF (store_frame_data_bus = "00000000") THEN
               inputDDR_en_cld <= '0' after 1 ns;
            END IF;
         WHEN OTHERS =>
            NULL;
         END CASE;

      END IF;

   END PROCESS clocked;

   ----------------------------------------------------------------------------
   nextstate : PROCESS (
      FE_enable_reg,
      count,
      current_state,
      frm_addr_fifo_empty,
      rdout_sync_out_sig1,
      store_frame_data_bus
   )
   ----------------------------------------------------------------------------
   BEGIN
      CASE current_state IS
      WHEN in_ddr_0 =>
         IF (frm_addr_fifo_empty = '0') THEN
            next_state <= in_ddr_1;
         ELSIF (FE_enable_reg = "00000000") THEN
            next_state <= in_ddr_0;
         ELSE
            next_state <= in_ddr_0;
         END IF;
      WHEN in_ddr_1 =>
         IF (rdout_sync_out_sig1 = '1') THEN
            next_state <= in_ddr_2;
         ELSE
            next_state <= in_ddr_1;
         END IF;
      WHEN in_ddr_2 =>
         IF (count = 4) THEN
            next_state <= in_ddr_3;
         ELSE
            next_state <= in_ddr_2;
         END IF;
      WHEN in_ddr_3 =>
         IF (store_frame_data_bus /= "00000000") THEN
            next_state <= in_ddr_4;
         ELSE
            next_state <= in_ddr_3;
         END IF;
      WHEN in_ddr_4 =>
         IF (store_frame_data_bus = "00000000") THEN
            next_state <= in_ddr_5;
         ELSE
            next_state <= in_ddr_4;
         END IF;
      WHEN in_ddr_5 =>
            next_state <= in_ddr_6;
      WHEN in_ddr_6 =>
         IF (frm_addr_fifo_empty = '0') THEN
            next_state <= in_ddr_1;
         ELSIF (frm_addr_fifo_empty = '1') THEN
            next_state <= in_ddr_7;
         ELSE
            next_state <= in_ddr_6;
         END IF;
      WHEN in_ddr_7 =>
            next_state <= in_ddr_8;
      WHEN in_ddr_8 =>
            next_state <= in_ddr_0;
      WHEN OTHERS =>
         next_state <= in_ddr_0;
      END CASE;

   END PROCESS nextstate;

   ----------------------------------------------------------------------------
   output : PROCESS (
      current_state
   )
   ----------------------------------------------------------------------------
   BEGIN
      -- Default Assignment
      -- Default Assignment To Internals

      -- Combined Actions
      CASE current_state IS
      WHEN in_ddr_5 =>
         -- inputDDR_en_cld <= '0' ;
      WHEN OTHERS =>
         NULL;
      END CASE;

   END PROCESS output;

   -- Concurrent Statements
   -- Clocked output assignments
   inputDDR_en <= inputDDR_en_cld;


END fsm;
