-- hds header_start
--
-- VHDL Entity back_end_fpga.frame_sync_sig_gen.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:38:45 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

ENTITY frame_sync_sig_gen IS
   PORT( 
      FE_trigger          : IN     std_logic;
      be_status_reg       : IN     std_logic_vector (31 DOWNTO 0);
      clk1x               : IN     std_logic;
      done                : IN     std_logic;
      en_fe_data_capture  : IN     std_logic;
      frame_sync_en       : IN     std_logic;
      mode_reg            : IN     std_logic_vector (3 DOWNTO 0);
      reset               : IN     std_logic;
      temp_bus            : IN     std_logic_vector (47 DOWNTO 0);
      tracker_header_1    : IN     std_logic_vector (127 DOWNTO 0);
      tracker_header_2    : IN     std_logic_vector (127 DOWNTO 0);
      tracker_header_3    : IN     std_logic_vector (127 DOWNTO 0);
      tracker_header_4    : IN     std_logic_vector (127 DOWNTO 0);
      tracker_header_5    : IN     std_logic_vector (127 DOWNTO 0);
      tracker_header_6    : IN     std_logic_vector (127 DOWNTO 0);
      tracker_header_7    : IN     std_logic_vector (127 DOWNTO 0);
      tracker_header_8    : IN     std_logic_vector (127 DOWNTO 0);
      en_trkr_hdr_fifo_wr : OUT    std_logic;
      frm_sync_in_en      : OUT    std_logic;
      tracker_header      : OUT    std_logic_vector (63 DOWNTO 0)
   );

-- Declarations

END frame_sync_sig_gen ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.frame_sync_sig_gen.fsm
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:38:45 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ARCHITECTURE fsm OF frame_sync_sig_gen IS

   -- Architecture Declarations
   signal count : integer range 0 to 270;

   TYPE STATE_TYPE IS (
      frm_syn_0,
      frm_syn_1a,
      frm_syn_2,
      frm_syn_3,
      frm_syn_4,
      frm_syn_5,
      frm_syn_6,
      frm_syn_7,
      frm_syn_8,
      frm_syn_9,
      frm_syn_10,
      frm_syn_11,
      frm_syn_12,
      frm_syn_13,
      frm_syn_14,
      frm_syn_15,
      frm_syn_16,
      frm_syn_17,
      frm_syn_18,
      frm_syn_19,
      s_m_0,
      s_m_1,
      s_m_3,
      frm_syn_1,
      s_m_2
   );

   -- State vector declaration
   ATTRIBUTE state_vector : string;
   ATTRIBUTE state_vector OF fsm : ARCHITECTURE IS "current_state" ;


   -- Declare current and next state signals
   SIGNAL current_state : STATE_TYPE ;
   SIGNAL next_state : STATE_TYPE ;

   -- Declare any pre-registered internal signals
   SIGNAL en_trkr_hdr_fifo_wr_cld : std_logic  ;
   SIGNAL frm_sync_in_en_cld : std_logic  ;
   SIGNAL tracker_header_cld : std_logic_vector (63 DOWNTO 0) ;

BEGIN

   ----------------------------------------------------------------------------
   clocked : PROCESS(
      clk1x,
      reset
   )
   ----------------------------------------------------------------------------
   BEGIN
      IF (reset = '1') THEN
         current_state <= frm_syn_0;
         -- Reset Values
         en_trkr_hdr_fifo_wr_cld <= '0';
         frm_sync_in_en_cld <= '0';
         tracker_header_cld <= (others => '0' );
         count <= 0;
      ELSIF (clk1x'EVENT AND clk1x = '1') THEN
         IF (en_fe_data_capture = '1') THEN
            current_state <= next_state;
            -- Default Assignment To Internals
            en_trkr_hdr_fifo_wr_cld <= '0';
            frm_sync_in_en_cld <= '0';
            tracker_header_cld <= (others => '0' );

            -- Combined Actions for internal signals only
            CASE current_state IS
            WHEN frm_syn_0 =>
               frm_sync_in_en_cld <= '0' ;
               en_trkr_hdr_fifo_wr_cld <= '0' ;
               tracker_header_cld <= (others => '0');
               count <= 0 ;
            WHEN frm_syn_2 =>
               en_trkr_hdr_fifo_wr_cld <= '1' after 1 ns;
               tracker_header_cld <= tracker_header_1 (63 downto 0)
                after 1 ns;
            WHEN frm_syn_3 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_1 (127 downto 112)
               & be_status_reg & tracker_header_1 (79 downto 64)
                after 1 ns;
            WHEN frm_syn_4 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_2(63 downto 0)
                after 1 ns;
            WHEN frm_syn_5 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_2 (127 downto 64)
                after 1 ns;
            WHEN frm_syn_6 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_3(63 downto 0)
                after 1 ns;
            WHEN frm_syn_7 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_3 (127 downto 64)
                after 1 ns;
            WHEN frm_syn_8 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_4 (63 downto 0)
                after 1 ns;
            WHEN frm_syn_9 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_4 (127 downto 64)
                after 1 ns;
            WHEN frm_syn_10 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_5(63 downto 0)
                after 1 ns;
            WHEN frm_syn_11 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_5 (127 downto 64)
                after 1 ns;
            WHEN frm_syn_12 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_6 (63 downto 0)
                after 1 ns;
            WHEN frm_syn_13 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_6 (127 downto 64)
                after 1 ns;
            WHEN frm_syn_14 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_7 (63 downto 0)
                after 1 ns;
            WHEN frm_syn_15 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_7 (127 downto 64)
                after 1 ns;
            WHEN frm_syn_16 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_8 (63 downto 0)
                after 1 ns;
            WHEN frm_syn_17 =>
               en_trkr_hdr_fifo_wr_cld <= '1'  after 1 ns;
               tracker_header_cld <= tracker_header_8 (127 downto 64)
                after 1 ns;
            WHEN frm_syn_18 =>
               en_trkr_hdr_fifo_wr_cld <= '0'  after 1 ns;
            WHEN s_m_0 =>
               en_trkr_hdr_fifo_wr_cld <= '0' after 1 ns;
            WHEN s_m_1 =>
               tracker_header_cld <= "0011001100110011" &
               be_status_reg & "0011001100110011" 
               after 1 ns;
               en_trkr_hdr_fifo_wr_cld <= '1' after 1 ns;
               count <= count + 1;
            WHEN s_m_3 =>
               en_trkr_hdr_fifo_wr_cld <= '0' after 1 ns;
            WHEN s_m_2 =>
               tracker_header_cld <= "0001110001110001" &
               "1100011100011100" & "0111000111000111" 
               & "0001110001110001" after 1 ns;
               en_trkr_hdr_fifo_wr_cld <= '1' after 1 ns;
               count <= count + 1;
               IF (count = 16) THEN
                  en_trkr_hdr_fifo_wr_cld <= '0' after 1 ns;
                  tracker_header_cld <= (others => '0')
                   after 1 ns;
               END IF;
            WHEN OTHERS =>
               NULL;
            END CASE;

         END IF;
      END IF;

   END PROCESS clocked;

   ----------------------------------------------------------------------------
   nextstate : PROCESS (
      count,
      current_state,
      done,
      frame_sync_en,
      mode_reg
   )
   ----------------------------------------------------------------------------
   BEGIN
      CASE current_state IS
      WHEN frm_syn_0 =>
         IF (mode_reg(1 downto 0) = "10") THEN
            next_state <= frm_syn_1;
         ELSIF (mode_reg(1 downto 0) = "01") THEN
            next_state <= s_m_0;
         ELSE
            next_state <= frm_syn_0;
         END IF;
      WHEN frm_syn_1a =>
            next_state <= frm_syn_2;
      WHEN frm_syn_2 =>
            next_state <= frm_syn_3;
      WHEN frm_syn_3 =>
            next_state <= frm_syn_4;
      WHEN frm_syn_4 =>
            next_state <= frm_syn_5;
      WHEN frm_syn_5 =>
            next_state <= frm_syn_6;
      WHEN frm_syn_6 =>
            next_state <= frm_syn_7;
      WHEN frm_syn_7 =>
            next_state <= frm_syn_8;
      WHEN frm_syn_8 =>
            next_state <= frm_syn_9;
      WHEN frm_syn_9 =>
            next_state <= frm_syn_10;
      WHEN frm_syn_10 =>
            next_state <= frm_syn_11;
      WHEN frm_syn_11 =>
            next_state <= frm_syn_12;
      WHEN frm_syn_12 =>
            next_state <= frm_syn_13;
      WHEN frm_syn_13 =>
            next_state <= frm_syn_14;
      WHEN frm_syn_14 =>
            next_state <= frm_syn_15;
      WHEN frm_syn_15 =>
            next_state <= frm_syn_16;
      WHEN frm_syn_16 =>
            next_state <= frm_syn_17;
      WHEN frm_syn_17 =>
            next_state <= frm_syn_18;
      WHEN frm_syn_18 =>
            next_state <= frm_syn_19;
      WHEN frm_syn_19 =>
            next_state <= frm_syn_0;
      WHEN s_m_0 =>
         IF (mode_reg(1 downto 0) = "10") THEN
            next_state <= frm_syn_0;
         ELSIF (done = '1') THEN
            next_state <= s_m_1;
         ELSE
            next_state <= s_m_0;
         END IF;
      WHEN s_m_1 =>
            next_state <= s_m_2;
      WHEN s_m_3 =>
            next_state <= frm_syn_0;
      WHEN frm_syn_1 =>
         IF (mode_reg(1 downto 0) = "01") THEN
            next_state <= frm_syn_0;
         ELSIF (frame_sync_en = '1') THEN
            next_state <= frm_syn_1a;
         ELSE
            next_state <= frm_syn_1;
         END IF;
      WHEN s_m_2 =>
         IF (count = 16) THEN
            next_state <= s_m_3;
         ELSE
            next_state <= s_m_2;
         END IF;
      WHEN OTHERS =>
         next_state <= frm_syn_0;
      END CASE;

   END PROCESS nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   en_trkr_hdr_fifo_wr <= en_trkr_hdr_fifo_wr_cld;
   frm_sync_in_en <= frm_sync_in_en_cld;
   tracker_header <= tracker_header_cld;


END fsm;
