-- hds header_start
--
-- VHDL Entity back_end_fpga.gen_sw_rst.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:23 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;

ENTITY gen_sw_rst IS
   PORT( 
      clk1x      : IN     std_logic;
      data_valid : IN     std_logic;
      rst        : IN     std_logic;
      sw_reset1  : IN     std_logic;
      sw_reset   : OUT    std_logic
   );

-- Declarations

END gen_sw_rst ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.gen_sw_rst.fsm
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:23 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ARCHITECTURE fsm OF gen_sw_rst IS

   -- Architecture Declarations
   TYPE STATE_TYPE IS (
      sw_rst0,
      sw_rst1,
      sw_rst2,
      sw_rst3
   );

   -- State vector declaration
   ATTRIBUTE state_vector : string;
   ATTRIBUTE state_vector OF fsm : ARCHITECTURE IS "current_state" ;


   -- Declare current and next state signals
   SIGNAL current_state : STATE_TYPE ;
   SIGNAL next_state : STATE_TYPE ;

   -- Declare any pre-registered internal signals
   SIGNAL sw_reset_cld : std_logic  ;

BEGIN

   ----------------------------------------------------------------------------
   clocked : PROCESS(
      clk1x,
      rst
   )
   ----------------------------------------------------------------------------
   BEGIN
      IF (rst = '1') THEN
         current_state <= sw_rst0;
         -- Reset Values
         sw_reset_cld <= '0';
      ELSIF (clk1x'EVENT AND clk1x = '1') THEN
         current_state <= next_state;
         -- Default Assignment To Internals
         sw_reset_cld <= '0';

         -- Combined Actions for internal signals only
         CASE current_state IS
         WHEN sw_rst0 =>
            sw_reset_cld <= '0' ;
         WHEN sw_rst1 =>
            sw_reset_cld <= '1' ;
         WHEN sw_rst2 =>
            sw_reset_cld <= '1' ;
         WHEN sw_rst3 =>
            sw_reset_cld <= '1' ;
         WHEN OTHERS =>
            NULL;
         END CASE;

      END IF;

   END PROCESS clocked;

   ----------------------------------------------------------------------------
   nextstate : PROCESS (
      current_state,
      sw_reset1
   )
   ----------------------------------------------------------------------------
   BEGIN
      CASE current_state IS
      WHEN sw_rst0 =>
         IF (sw_reset1 = '1') THEN
            next_state <= sw_rst1;
         ELSE
            next_state <= sw_rst0;
         END IF;
      WHEN sw_rst1 =>
            next_state <= sw_rst2;
      WHEN sw_rst2 =>
            next_state <= sw_rst3;
      WHEN sw_rst3 =>
            next_state <= sw_rst0;
      WHEN OTHERS =>
         next_state <= sw_rst0;
      END CASE;

   END PROCESS nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   sw_reset <= sw_reset_cld;


END fsm;
