-- hds header_start
--
-- VHDL Entity back_end_fpga.gen_ttc_rx_rst.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:23 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;

ENTITY gen_ttc_rx_rst IS
   PORT( 
      TTC_rst_frm_vme_b : IN     std_logic;
      clk1x             : IN     std_logic;
      rst               : IN     std_logic;
      ttc_rx_rst_1      : IN     std_logic;
      ttc_reset_b_1     : OUT    std_logic
   );

-- Declarations

END gen_ttc_rx_rst ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.gen_ttc_rx_rst.fsm
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:23 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ARCHITECTURE fsm OF gen_ttc_rx_rst IS

   -- Architecture Declarations
   signal icount: natural range 0 to 2047;

   TYPE STATE_TYPE IS (
      ttc_rst_0,
      ttc_rst_1,
      ttc_rst_2,
      ttc_rst_3
   );

   -- State vector declaration
   ATTRIBUTE state_vector : string;
   ATTRIBUTE state_vector OF fsm : ARCHITECTURE IS "current_state" ;


   -- Declare current and next state signals
   SIGNAL current_state : STATE_TYPE ;
   SIGNAL next_state : STATE_TYPE ;

   -- Declare any pre-registered internal signals
   SIGNAL ttc_reset_b_1_cld : std_logic  ;

BEGIN

   ----------------------------------------------------------------------------
   clocked : PROCESS(
      clk1x,
      rst
   )
   ----------------------------------------------------------------------------
   BEGIN
      IF (rst = '1') THEN
         current_state <= ttc_rst_0;
         -- Reset Values
         ttc_reset_b_1_cld <= '1';
         icount <= 0;
      ELSIF (clk1x'EVENT AND clk1x = '1') THEN
         current_state <= next_state;
         -- Default Assignment To Internals
         icount <= 0;
         ttc_reset_b_1_cld <= '1';

         -- Combined Actions for internal signals only
         CASE current_state IS
         WHEN ttc_rst_0 =>
            ttc_reset_b_1_cld <= '1' after 1 ns;
            icount <= 0 ;
         WHEN ttc_rst_1 =>
            icount <= icount + 1;
            ttc_reset_b_1_cld <= '0' after 1 ns;
         WHEN ttc_rst_2 =>
            ttc_reset_b_1_cld <= '1'  after 1 ns;
         WHEN OTHERS =>
            NULL;
         END CASE;

      END IF;

   END PROCESS clocked;

   ----------------------------------------------------------------------------
   nextstate : PROCESS (
      TTC_rst_frm_vme_b,
      current_state,
      icount,
      ttc_rx_rst_1
   )
   ----------------------------------------------------------------------------
   BEGIN
      CASE current_state IS
      WHEN ttc_rst_0 =>
         IF (ttc_rx_rst_1 = '1' OR 
         TTC_rst_frm_vme_b = '0') THEN
            next_state <= ttc_rst_1;
         ELSE
            next_state <= ttc_rst_0;
         END IF;
      WHEN ttc_rst_1 =>
         IF (icount = 2046) THEN
            next_state <= ttc_rst_2;
         ELSE
            next_state <= ttc_rst_1;
         END IF;
      WHEN ttc_rst_2 =>
            next_state <= ttc_rst_3;
      WHEN ttc_rst_3 =>
            next_state <= ttc_rst_0;
      WHEN OTHERS =>
         next_state <= ttc_rst_0;
      END CASE;

   END PROCESS nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   ttc_reset_b_1 <= ttc_reset_b_1_cld;


END fsm;
