-- hds header_start
--
-- VHDL Entity back_end_fpga.gen_tts_lvds.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:42:56 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY gen_tts_lvds IS
   PORT( 
      TTC_reset                : IN     std_logic;
      all_flags_empty          : IN     std_logic;
      all_full_flags           : IN     std_logic;
      all_half_full_flags      : IN     std_logic;
      all_partial_empty_flags  : IN     std_logic;
      all_partial_full_flags   : IN     std_logic;
      clk1x                    : IN     std_logic;
      reset                    : IN     std_logic;
      tts_j0_busy_out          : OUT    std_logic;
      tts_j0_out_of_sync_out   : OUT    std_logic;
      tts_j0_ready_out         : OUT    std_logic;
      tts_j0_warn_overflow_out : OUT    std_logic
   );

-- Declarations

END gen_tts_lvds ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.gen_tts_lvds.fsm
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:42:56 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ARCHITECTURE fsm OF gen_tts_lvds IS

   -- Architecture Declarations
   TYPE STATE_TYPE IS (
      tts_0,
      tts_1,
      tts_2,
      tts_3,
      tts_4,
      tts_5,
      tts_6
   );

   -- State vector declaration
   ATTRIBUTE state_vector : string;
   ATTRIBUTE state_vector OF fsm : ARCHITECTURE IS "current_state" ;


   -- Declare current and next state signals
   SIGNAL current_state : STATE_TYPE ;
   SIGNAL next_state : STATE_TYPE ;

   -- Declare any pre-registered internal signals
   SIGNAL tts_j0_busy_out_cld : std_logic  ;
   SIGNAL tts_j0_out_of_sync_out_cld : std_logic  ;
   SIGNAL tts_j0_ready_out_cld : std_logic  ;
   SIGNAL tts_j0_warn_overflow_out_cld : std_logic  ;

BEGIN

   ----------------------------------------------------------------------------
   clocked : PROCESS(
      clk1x,
      reset
   )
   ----------------------------------------------------------------------------
   BEGIN
      IF (reset = '1') THEN
         current_state <= tts_0;
         -- Reset Values
         tts_j0_busy_out_cld <= '0';
         tts_j0_out_of_sync_out_cld <= '0';
         tts_j0_ready_out_cld <= '0';
         tts_j0_warn_overflow_out_cld <= '0';
      ELSIF (clk1x'EVENT AND clk1x = '1') THEN
         current_state <= next_state;
         -- Default Assignment To Internals
         tts_j0_busy_out_cld <= '0';
         tts_j0_out_of_sync_out_cld <= '0';
         tts_j0_ready_out_cld <= '0';
         tts_j0_warn_overflow_out_cld <= '0';

         -- Combined Actions for internal signals only
         CASE current_state IS
         WHEN tts_0 =>
            tts_j0_ready_out_cld <= '1' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '0'  after 1 ns;
            tts_j0_busy_out_cld <= '0'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '0'  after 1 ns;
         WHEN tts_1 =>
            tts_j0_ready_out_cld <= '0' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '1'  after 1 ns;
            tts_j0_busy_out_cld <= '0'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '0'  after 1 ns;
         WHEN tts_2 =>
            tts_j0_ready_out_cld <= '0' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '0'  after 1 ns;
            tts_j0_busy_out_cld <= '1'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '0'  after 1 ns;
         WHEN tts_3 =>
            tts_j0_ready_out_cld <= '0' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '0'  after 1 ns;
            tts_j0_busy_out_cld <= '0'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '1'  after 1 ns;
         WHEN tts_4 =>
            tts_j0_ready_out_cld <= '0' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '0'  after 1 ns;
            tts_j0_busy_out_cld <= '1'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '0'  after 1 ns;
         WHEN tts_5 =>
            tts_j0_ready_out_cld <= '0' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '0'  after 1 ns;
            tts_j0_busy_out_cld <= '1'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '0'  after 1 ns;
         WHEN tts_6 =>
            tts_j0_ready_out_cld <= '0' after 1 ns;
            tts_j0_warn_overflow_out_cld <= '0'  after 1 ns;
            tts_j0_busy_out_cld <= '1'  after 1 ns; 
            tts_j0_out_of_sync_out_cld <= '0'  after 1 ns;
         WHEN OTHERS =>
            NULL;
         END CASE;

      END IF;

   END PROCESS clocked;

   ----------------------------------------------------------------------------
   nextstate : PROCESS (
      TTC_reset,
      all_full_flags,
      all_half_full_flags,
      all_partial_empty_flags,
      all_partial_full_flags,
      current_state,
      reset
   )
   ----------------------------------------------------------------------------
   BEGIN
      CASE current_state IS
      WHEN tts_0 =>
         IF (all_half_full_flags = '1') THEN
            next_state <= tts_1;
         ELSIF (TTC_reset = '1') THEN
            next_state <= tts_4;
         ELSE
            next_state <= tts_0;
         END IF;
      WHEN tts_1 =>
         IF (all_partial_empty_flags = '0') THEN
            next_state <= tts_0;
         ELSIF (all_partial_full_flags = '1') THEN
            next_state <= tts_2;
         ELSIF (TTC_reset = '1') THEN
            next_state <= tts_4;
         ELSE
            next_state <= tts_1;
         END IF;
      WHEN tts_2 =>
         IF (all_half_full_flags = '0') THEN
            next_state <= tts_1;
         ELSIF (all_full_flags /= '0') THEN
            next_state <= tts_3;
         ELSIF (TTC_reset = '1') THEN
            next_state <= tts_4;
         ELSE
            next_state <= tts_2;
         END IF;
      WHEN tts_3 =>
         IF (reset = '1') THEN
            next_state <= tts_0;
         ELSIF (TTC_reset = '1') THEN
            next_state <= tts_4;
         ELSE
            next_state <= tts_3;
         END IF;
      WHEN tts_4 =>
            next_state <= tts_5;
      WHEN tts_5 =>
            next_state <= tts_6;
      WHEN tts_6 =>
            next_state <= tts_0;
      WHEN OTHERS =>
         next_state <= tts_0;
      END CASE;

   END PROCESS nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   tts_j0_busy_out <= tts_j0_busy_out_cld;
   tts_j0_out_of_sync_out <= tts_j0_out_of_sync_out_cld;
   tts_j0_ready_out <= tts_j0_ready_out_cld;
   tts_j0_warn_overflow_out <= tts_j0_warn_overflow_out_cld;


END fsm;
