-- hds header_start
--
-- VHDL Entity back_end_fpga.i2c_cntl_lm82.symbol
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:32 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY i2c_cntl_lm82 IS
   PORT( 
      ce_i2c          : IN     std_logic;
      data_from_lm82  : IN     std_logic_vector (7 DOWNTO 0);
      i2c_busy        : IN     std_logic;
      i2c_err         : IN     std_logic;
      i2c_rst         : IN     std_logic;
      iclk40          : IN     std_logic;
      lm82_control    : IN     std_logic_vector (16 DOWNTO 0);
      set_lm82_status : IN     std_logic;
      data_to_lm82    : OUT    std_logic_vector (7 DOWNTO 0);
      i2c_abort       : OUT    std_logic;
      i2c_rd_nwr      : OUT    std_logic;
      lm82_cmnd       : OUT    std_logic_vector (7 DOWNTO 0);
      lm82_status     : OUT    std_logic_vector (15 DOWNTO 0)
   );

-- Declarations

END i2c_cntl_lm82 ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.i2c_cntl_lm82.struct
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:32 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

LIBRARY back_end_fpga;

ARCHITECTURE struct OF i2c_cntl_lm82 IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL i2c_err_held   : std_logic;
   SIGNAL ipb_high       : std_logic;
   SIGNAL lm82_data_held : std_logic_vector(7 DOWNTO 0);


   -- Component Declarations
   COMPONENT i2c_ff_e
   GENERIC (
      q_rst : std_logic := '0'
   );
   PORT (
      d   : IN     std_logic ;
      clk : IN     std_logic ;
      rst : IN     std_logic ;
      q   : OUT    std_logic ;
      ce  : IN     std_logic 
   );
   END COMPONENT;
   COMPONENT i2c_reg_e
   GENERIC (
      width : integer   := 16;
      edge  : std_logic := '1'
   );
   PORT (
      d   : IN     std_logic_vector (width-1 DOWNTO 0);
      clk : IN     std_logic ;
      rst : IN     std_logic ;
      q   : OUT    std_logic_vector (width-1 DOWNTO 0);
      ce  : IN     std_logic 
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : i2c_ff_e USE ENTITY back_end_fpga.i2c_ff_e;
   FOR ALL : i2c_reg_e USE ENTITY back_end_fpga.i2c_reg_e;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   -- eb1 1
   lm82_status <= "000000"  
                 & i2c_err_held 
                 & i2c_busy
                 & lm82_data_held;

   -- HDL Embedded Text Block 3 eb3
   -- eb3 3
   ipb_high <= '1';

   -- HDL Embedded Text Block 4 eb4
   i2c_abort <= '0';
   i2c_rd_nwr  <=  lm82_control(16);
   lm82_cmnd <= lm82_control(15 downto 8);
   data_to_lm82 <= lm82_control(7 downto 0);

   -- Instance port mappings.
   I1 : i2c_ff_e
      GENERIC MAP (
         q_rst => '0'
      )
      PORT MAP (
         d   => ipb_high,
         clk => iclk40,
         rst => i2c_rst,
         q   => i2c_err_held,
         ce  => i2c_err
      );
   I0 : i2c_reg_e
      GENERIC MAP (
         width => 8,
         edge  => '1'
      )
      PORT MAP (
         d   => data_from_lm82,
         clk => iclk40,
         rst => i2c_rst,
         q   => lm82_data_held,
         ce  => set_lm82_status
      );

END struct;
