-- hds header_start
--
-- VHDL Entity back_end_fpga.i2c_lm82.symbol
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:33 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY i2c_lm82 IS
   PORT( 
      i2c_init     : IN     std_logic;
      i2c_rst      : IN     std_logic;
      iclk40       : IN     std_logic;
      lm82_control : IN     std_logic_vector (16 DOWNTO 0);
      lm82_status  : OUT    std_logic_vector (15 DOWNTO 0);
      scl          : OUT    std_logic;
      sda          : INOUT  std_logic
   );

-- Declarations

END i2c_lm82 ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.i2c_lm82.struct
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:37 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

LIBRARY back_end_fpga;
LIBRARY unisim;

ARCHITECTURE struct OF i2c_lm82 IS

   -- Architecture declarations
   --attribute no_buff: boolean;
   --attribute noopt: boolean;

   -- Internal signal declarations
   SIGNAL ce_i2c          : std_logic;
   SIGNAL ce_i2c_rcv      : std_logic;
   SIGNAL data_from_lm82  : std_logic_vector(7 DOWNTO 0);
   SIGNAL data_to_lm82    : std_logic_vector(7 DOWNTO 0);
   SIGNAL dir_sda         : std_logic;
   SIGNAL en_sr_in        : std_logic;
   SIGNAL en_sr_out       : std_logic;
   SIGNAL i2c_abort       : std_logic;
   SIGNAL i2c_busy        : std_logic;
   SIGNAL i2c_err         : std_logic;
   SIGNAL i2c_rd_nwr      : std_logic;
   SIGNAL ipb_low         : std_logic;
   SIGNAL ld_sr_out       : std_logic;
   SIGNAL lm82_cmnd       : std_logic_vector(7 DOWNTO 0);
   SIGNAL lm82_ptr_addr   : std_logic_vector(6 DOWNTO 0);
   SIGNAL pda_out         : std_logic_vector(15 DOWNTO 0);
   SIGNAL scl_en          : std_logic;
   SIGNAL scl_int         : std_logic;
   SIGNAL scl_source      : std_logic;
   SIGNAL sda_in          : std_logic;
   SIGNAL sda_out         : std_logic;
   SIGNAL sel_pointer     : std_logic;
   SIGNAL set_lm82_status : std_logic;
   SIGNAL sr_out          : std_logic;


constant firmware_id: std_logic_vector := "0100";
constant revision_id: std_logic_vector := "00000100";

--attribute no_buff of ds : signal is TRUE;
--attribute noopt of ds : signal is TRUE;

   -- Component Declarations
   COMPONENT IOBUF
   PORT (
      I  : IN     STD_ULOGIC;
      T  : IN     STD_ULOGIC;
      O  : OUT    STD_ULOGIC;
      IO : INOUT  STD_ULOGIC
   );
   END COMPONENT;
   COMPONENT i2c_clk_gen
   PORT (
      clk40      : IN     std_logic ;
      i2c_rst    : IN     std_logic ;
      scl_source : OUT    std_logic ;
      ce_i2c     : OUT    std_logic ;
      ce_i2c_rcv : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT i2c_cntl_lm82
   PORT (
      ce_i2c          : IN     std_logic ;
      data_from_lm82  : IN     std_logic_vector (7 DOWNTO 0);
      i2c_busy        : IN     std_logic ;
      i2c_err         : IN     std_logic ;
      i2c_rst         : IN     std_logic ;
      iclk40          : IN     std_logic ;
      lm82_control    : IN     std_logic_vector (16 DOWNTO 0);
      set_lm82_status : IN     std_logic ;
      data_to_lm82    : OUT    std_logic_vector (7 DOWNTO 0);
      i2c_abort       : OUT    std_logic ;
      i2c_rd_nwr      : OUT    std_logic ;
      lm82_cmnd       : OUT    std_logic_vector (7 DOWNTO 0);
      lm82_status     : OUT    std_logic_vector (15 DOWNTO 0)
   );
   END COMPONENT;
   COMPONENT i2c_ff
   GENERIC (
      q_rst : std_logic := '0'
   );
   PORT (
      d   : IN     std_logic ;
      clk : IN     std_logic ;
      rst : IN     std_logic ;
      q   : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT i2c_lm82_engine
   PORT (
      ce_i2c          : IN     std_logic ;
      ce_i2c_rcv      : IN     std_logic ;
      data_to_lm82    : IN     std_logic_vector (7 DOWNTO 0);
      i2c_abort       : IN     std_logic ;
      i2c_init        : IN     std_logic ;
      i2c_rd_nwr      : IN     std_logic ;
      i2c_rst         : IN     std_logic ;
      iclk40          : IN     std_logic ;
      lm82_cmnd       : IN     std_logic_vector (7 DOWNTO 0);
      scl_source      : IN     std_logic ;
      sda_in          : IN     std_logic ;
      sr_out          : IN     std_logic ;
      dir_sda         : OUT    std_logic ;
      en_sr_in        : OUT    std_logic ;
      en_sr_out       : OUT    std_logic ;
      i2c_busy        : OUT    std_logic ;
      i2c_err         : OUT    std_logic ;
      ld_sr_out       : OUT    std_logic ;
      scl_en          : OUT    std_logic ;
      sda_out         : OUT    std_logic ;
      sel_pointer     : OUT    std_logic ;
      set_lm82_status : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT i2c_lm82_sda_out
   PORT (
      data_to_lm82  : IN     std_logic_vector (7 DOWNTO 0);
      i2c_rd_nwr    : IN     std_logic ;
      sel_pointer   : IN     std_logic ;
      lm82_cmnd     : IN     std_logic_vector (7 DOWNTO 0);
      lm82_ptr_addr : IN     std_logic_vector (6 DOWNTO 0);
      pda_out       : OUT    std_logic_vector (15 DOWNTO 0);
      rst           : IN     std_logic 
   );
   END COMPONENT;
   COMPONENT i2c_sr_input
   PORT (
      en_sr_in    : IN     std_logic ;
      i2c_rst     : IN     std_logic ;
      iclk40      : IN     std_logic ;
      sda_in      : IN     std_logic ;
      i2c_data_in : OUT    std_logic_vector (7 DOWNTO 0)
   );
   END COMPONENT;
   COMPONENT i2c_sr_ps
   GENERIC (
      width : integer := 16
   );
   PORT (
      clk         : IN     std_logic ;
      din_para    : IN     std_logic_vector (width-1 DOWNTO 0);
      din_serial  : IN     std_logic ;
      en_shift    : IN     std_logic ;
      load_para   : IN     std_logic ;
      rst         : IN     std_logic ;
      dout_serial : OUT    std_logic 
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : IOBUF USE ENTITY unisim.IOBUF;
   FOR ALL : i2c_clk_gen USE ENTITY back_end_fpga.i2c_clk_gen;
   FOR ALL : i2c_cntl_lm82 USE ENTITY back_end_fpga.i2c_cntl_lm82;
   FOR ALL : i2c_ff USE ENTITY back_end_fpga.i2c_ff;
   FOR ALL : i2c_lm82_engine USE ENTITY back_end_fpga.i2c_lm82_engine;
   FOR ALL : i2c_lm82_sda_out USE ENTITY back_end_fpga.i2c_lm82_sda_out;
   FOR ALL : i2c_sr_input USE ENTITY back_end_fpga.i2c_sr_input;
   FOR ALL : i2c_sr_ps USE ENTITY back_end_fpga.i2c_sr_ps;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 3 eb3
   lm82_ptr_addr <= "0011000";
   
   ipb_low <= '0';

   -- HDL Embedded Text Block 7 eb7
   -- eb7 7
   scl_int <= not (scl_en and not scl_source);

   -- Instance port mappings.
   I3 : IOBUF
      PORT MAP (
         O  => sda_in,
         IO => sda,
         I  => sda_out,
         T  => dir_sda
      );
   I5 : i2c_clk_gen
      PORT MAP (
         clk40      => iclk40,
         i2c_rst    => i2c_rst,
         scl_source => scl_source,
         ce_i2c     => ce_i2c,
         ce_i2c_rcv => ce_i2c_rcv
      );
   I2 : i2c_cntl_lm82
      PORT MAP (
         ce_i2c          => ce_i2c,
         data_from_lm82  => data_from_lm82,
         i2c_busy        => i2c_busy,
         i2c_err         => i2c_err,
         i2c_rst         => i2c_rst,
         iclk40          => iclk40,
         lm82_control    => lm82_control,
         set_lm82_status => set_lm82_status,
         data_to_lm82    => data_to_lm82,
         i2c_abort       => i2c_abort,
         i2c_rd_nwr      => i2c_rd_nwr,
         lm82_cmnd       => lm82_cmnd,
         lm82_status     => lm82_status
      );
   I7 : i2c_ff
      GENERIC MAP (
         q_rst => '1'
      )
      PORT MAP (
         d   => scl_int,
         clk => iclk40,
         rst => i2c_rst,
         q   => scl
      );
   I1 : i2c_lm82_engine
      PORT MAP (
         ce_i2c          => ce_i2c,
         ce_i2c_rcv      => ce_i2c_rcv,
         data_to_lm82    => data_to_lm82,
         i2c_abort       => i2c_abort,
         i2c_init        => i2c_init,
         i2c_rd_nwr      => i2c_rd_nwr,
         i2c_rst         => i2c_rst,
         iclk40          => iclk40,
         lm82_cmnd       => lm82_cmnd,
         scl_source      => scl_source,
         sda_in          => sda_in,
         sr_out          => sr_out,
         dir_sda         => dir_sda,
         en_sr_in        => en_sr_in,
         en_sr_out       => en_sr_out,
         i2c_busy        => i2c_busy,
         i2c_err         => i2c_err,
         ld_sr_out       => ld_sr_out,
         scl_en          => scl_en,
         sda_out         => sda_out,
         sel_pointer     => sel_pointer,
         set_lm82_status => set_lm82_status
      );
   I0 : i2c_lm82_sda_out
      PORT MAP (
         data_to_lm82  => data_to_lm82,
         i2c_rd_nwr    => i2c_rd_nwr,
         sel_pointer   => sel_pointer,
         lm82_cmnd     => lm82_cmnd,
         lm82_ptr_addr => lm82_ptr_addr,
         pda_out       => pda_out,
         rst           => i2c_rst
      );
   I6 : i2c_sr_input
      PORT MAP (
         en_sr_in    => en_sr_in,
         i2c_rst     => i2c_rst,
         iclk40      => iclk40,
         sda_in      => sda_in,
         i2c_data_in => data_from_lm82
      );
   I4 : i2c_sr_ps
      GENERIC MAP (
         width => 16
      )
      PORT MAP (
         clk         => iclk40,
         din_para    => pda_out,
         din_serial  => ipb_low,
         en_shift    => en_sr_out,
         load_para   => ld_sr_out,
         rst         => i2c_rst,
         dout_serial => sr_out
      );

END struct;
