-- hds header_start
--
-- VHDL Entity back_end_fpga.i2c_ttc.symbol
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:26 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY i2c_ttc IS
   PORT( 
      TTC_control : IN     std_logic_vector (15 DOWNTO 0);
      i2c_init    : IN     std_logic;
      i2c_rst     : IN     std_logic;
      iclk40      : IN     std_logic;
      scl         : OUT    std_logic;
      ttc_status  : OUT    std_logic_vector (15 DOWNTO 0);
      sda         : INOUT  std_logic
   );

-- Declarations

END i2c_ttc ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.i2c_ttc.struct
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:30 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

LIBRARY back_end_fpga;
LIBRARY unisim;

ARCHITECTURE struct OF i2c_ttc IS

   -- Architecture declarations
   --attribute no_buff: boolean;
   --attribute noopt: boolean;

   -- Internal signal declarations
   SIGNAL ce_i2c         : std_logic;
   SIGNAL ce_i2c_rcv     : std_logic;
   SIGNAL data_from_ttc  : std_logic_vector(7 DOWNTO 0);
   SIGNAL data_to_ttc    : std_logic_vector(7 DOWNTO 0);
   SIGNAL dir_sda        : std_logic;
   SIGNAL en_sr_in       : std_logic;
   SIGNAL en_sr_out      : std_logic;
   SIGNAL i2c_abort      : std_logic;
   SIGNAL i2c_busy       : std_logic;
   SIGNAL i2c_err        : std_logic;
   SIGNAL i2c_rd_nwr     : std_logic;
   SIGNAL ipb_low        : std_logic;
   SIGNAL ld_sr_out      : std_logic;
   SIGNAL pda_out        : std_logic_vector(15 DOWNTO 0);
   SIGNAL scl_en         : std_logic;
   SIGNAL scl_int        : std_logic;
   SIGNAL scl_source     : std_logic;
   SIGNAL sda_in         : std_logic;
   SIGNAL sda_out        : std_logic;
   SIGNAL sel_pointer    : std_logic;
   SIGNAL set_vme_status : std_logic;
   SIGNAL sr_out         : std_logic;
   SIGNAL ttc_data_addr  : std_logic_vector(6 DOWNTO 0);
   SIGNAL ttc_i2c_id     : std_logic_vector(5 DOWNTO 0);
   SIGNAL ttc_pointer    : std_logic_vector(4 DOWNTO 0);
   SIGNAL ttc_ptr_addr   : std_logic_vector(6 DOWNTO 0);


constant firmware_id: std_logic_vector := "0100";
constant revision_id: std_logic_vector := "00000100";

--attribute no_buff of ds : signal is TRUE;
--attribute noopt of ds : signal is TRUE;

   -- Component Declarations
   COMPONENT IOBUF
   PORT (
      I  : IN     STD_ULOGIC;
      T  : IN     STD_ULOGIC;
      O  : OUT    STD_ULOGIC;
      IO : INOUT  STD_ULOGIC
   );
   END COMPONENT;
   COMPONENT i2c_clk_gen
   PORT (
      clk40      : IN     std_logic ;
      i2c_rst    : IN     std_logic ;
      scl_source : OUT    std_logic ;
      ce_i2c     : OUT    std_logic ;
      ce_i2c_rcv : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT i2c_ff
   GENERIC (
      q_rst : std_logic := '0'
   );
   PORT (
      d   : IN     std_logic ;
      clk : IN     std_logic ;
      rst : IN     std_logic ;
      q   : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT i2c_sr_input
   PORT (
      en_sr_in    : IN     std_logic ;
      i2c_rst     : IN     std_logic ;
      iclk40      : IN     std_logic ;
      sda_in      : IN     std_logic ;
      i2c_data_in : OUT    std_logic_vector (7 DOWNTO 0)
   );
   END COMPONENT;
   COMPONENT i2c_sr_ps
   GENERIC (
      width : integer := 16
   );
   PORT (
      clk         : IN     std_logic ;
      din_para    : IN     std_logic_vector (width-1 DOWNTO 0);
      din_serial  : IN     std_logic ;
      en_shift    : IN     std_logic ;
      load_para   : IN     std_logic ;
      rst         : IN     std_logic ;
      dout_serial : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT i2c_ttc_engine
   PORT (
      ce_i2c         : IN     std_logic ;
      ce_i2c_rcv     : IN     std_logic ;
      data_to_ttc    : IN     std_logic_vector (7 DOWNTO 0);
      i2c_abort      : IN     std_logic ;
      i2c_init       : IN     std_logic ;
      i2c_rd_nwr     : IN     std_logic ;
      i2c_rst        : IN     std_logic ;
      iclk40         : IN     std_logic ;
      scl_source     : IN     std_logic ;
      sda_in         : IN     std_logic ;
      sr_out         : IN     std_logic ;
      ttc_pointer    : IN     std_logic_vector (4 DOWNTO 0);
      dir_sda        : OUT    std_logic ;
      en_sr_in       : OUT    std_logic ;
      en_sr_out      : OUT    std_logic ;
      i2c_busy       : OUT    std_logic ;
      i2c_err        : OUT    std_logic ;
      ld_sr_out      : OUT    std_logic ;
      scl_en         : OUT    std_logic ;
      sda_out        : OUT    std_logic ;
      sel_pointer    : OUT    std_logic ;
      set_vme_status : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT i2c_ttc_sda_out
   PORT (
      data_to_ttc   : IN     std_logic_vector (7 DOWNTO 0);
      i2c_rd_nwr    : IN     std_logic ;
      sel_pointer   : IN     std_logic ;
      ttc_data_addr : IN     std_logic_vector (6 DOWNTO 0);
      ttc_pointer   : IN     std_logic_vector (4 DOWNTO 0);
      ttc_ptr_addr  : IN     std_logic_vector (6 DOWNTO 0);
      pda_out       : OUT    std_logic_vector (15 DOWNTO 0)
   );
   END COMPONENT;
   COMPONENT i2c_ttc_vme
   PORT (
      TTC_control    : IN     std_logic_vector (15 DOWNTO 0);
      ce_i2c         : IN     std_logic ;
      data_from_ttc  : IN     std_logic_vector (7 DOWNTO 0);
      i2c_busy       : IN     std_logic ;
      i2c_err        : IN     std_logic ;
      i2c_rst        : IN     std_logic ;
      iclk40         : IN     std_logic ;
      set_vme_status : IN     std_logic ;
      data_to_ttc    : OUT    std_logic_vector (7 DOWNTO 0);
      i2c_abort      : OUT    std_logic ;
      i2c_rd_nwr     : OUT    std_logic ;
      ttc_pointer    : OUT    std_logic_vector (4 DOWNTO 0);
      ttc_status     : OUT    std_logic_vector (15 DOWNTO 0)
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : IOBUF USE ENTITY unisim.IOBUF;
   FOR ALL : i2c_clk_gen USE ENTITY back_end_fpga.i2c_clk_gen;
   FOR ALL : i2c_ff USE ENTITY back_end_fpga.i2c_ff;
   FOR ALL : i2c_sr_input USE ENTITY back_end_fpga.i2c_sr_input;
   FOR ALL : i2c_sr_ps USE ENTITY back_end_fpga.i2c_sr_ps;
   FOR ALL : i2c_ttc_engine USE ENTITY back_end_fpga.i2c_ttc_engine;
   FOR ALL : i2c_ttc_sda_out USE ENTITY back_end_fpga.i2c_ttc_sda_out;
   FOR ALL : i2c_ttc_vme USE ENTITY back_end_fpga.i2c_ttc_vme;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 3 eb3
   ttc_ptr_addr <= ttc_i2c_id & '0';
   ttc_data_addr <= ttc_i2c_id & '1';

   -- HDL Embedded Text Block 5 eb5
   -- eb5 5
   ttc_i2c_id <= "000000";

   -- HDL Embedded Text Block 7 eb7
   -- eb7 7
   scl_int <= not (scl_en and not scl_source);

   -- Instance port mappings.
   I0 : IOBUF
      PORT MAP (
         O  => sda_in,
         IO => sda,
         I  => sda_out,
         T  => dir_sda
      );
   I5 : i2c_clk_gen
      PORT MAP (
         clk40      => iclk40,
         i2c_rst    => i2c_rst,
         scl_source => scl_source,
         ce_i2c     => ce_i2c,
         ce_i2c_rcv => ce_i2c_rcv
      );
   I7 : i2c_ff
      GENERIC MAP (
         q_rst => '1'
      )
      PORT MAP (
         d   => scl_int,
         clk => iclk40,
         rst => i2c_rst,
         q   => scl
      );
   I4 : i2c_sr_input
      PORT MAP (
         en_sr_in    => en_sr_in,
         i2c_rst     => i2c_rst,
         iclk40      => iclk40,
         sda_in      => sda_in,
         i2c_data_in => data_from_ttc
      );
   I3 : i2c_sr_ps
      GENERIC MAP (
         width => 16
      )
      PORT MAP (
         clk         => iclk40,
         din_para    => pda_out,
         din_serial  => ipb_low,
         en_shift    => en_sr_out,
         load_para   => ld_sr_out,
         rst         => i2c_rst,
         dout_serial => sr_out
      );
   I6 : i2c_ttc_engine
      PORT MAP (
         ce_i2c         => ce_i2c,
         ce_i2c_rcv     => ce_i2c_rcv,
         data_to_ttc    => data_to_ttc,
         i2c_abort      => i2c_abort,
         i2c_init       => i2c_init,
         i2c_rd_nwr     => i2c_rd_nwr,
         i2c_rst        => i2c_rst,
         iclk40         => iclk40,
         scl_source     => scl_source,
         sda_in         => sda_in,
         sr_out         => sr_out,
         ttc_pointer    => ttc_pointer,
         dir_sda        => dir_sda,
         en_sr_in       => en_sr_in,
         en_sr_out      => en_sr_out,
         i2c_busy       => i2c_busy,
         i2c_err        => i2c_err,
         ld_sr_out      => ld_sr_out,
         scl_en         => scl_en,
         sda_out        => sda_out,
         sel_pointer    => sel_pointer,
         set_vme_status => set_vme_status
      );
   I2 : i2c_ttc_sda_out
      PORT MAP (
         data_to_ttc   => data_to_ttc,
         i2c_rd_nwr    => i2c_rd_nwr,
         sel_pointer   => sel_pointer,
         ttc_data_addr => ttc_data_addr,
         ttc_pointer   => ttc_pointer,
         ttc_ptr_addr  => ttc_ptr_addr,
         pda_out       => pda_out
      );
   I1 : i2c_ttc_vme
      PORT MAP (
         TTC_control    => TTC_control,
         ce_i2c         => ce_i2c,
         data_from_ttc  => data_from_ttc,
         i2c_busy       => i2c_busy,
         i2c_err        => i2c_err,
         i2c_rst        => i2c_rst,
         iclk40         => iclk40,
         set_vme_status => set_vme_status,
         data_to_ttc    => data_to_ttc,
         i2c_abort      => i2c_abort,
         i2c_rd_nwr     => i2c_rd_nwr,
         ttc_pointer    => ttc_pointer,
         ttc_status     => ttc_status
      );

END struct;
