-- hds header_start
--
-- VHDL Entity back_end_fpga.i2c_ttc_vme.symbol
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:25 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

ENTITY i2c_ttc_vme IS
   PORT( 
      TTC_control    : IN     std_logic_vector (15 DOWNTO 0);
      ce_i2c         : IN     std_logic;
      data_from_ttc  : IN     std_logic_vector (7 DOWNTO 0);
      i2c_busy       : IN     std_logic;
      i2c_err        : IN     std_logic;
      i2c_rst        : IN     std_logic;
      iclk40         : IN     std_logic;
      set_vme_status : IN     std_logic;
      data_to_ttc    : OUT    std_logic_vector (7 DOWNTO 0);
      i2c_abort      : OUT    std_logic;
      i2c_rd_nwr     : OUT    std_logic;
      ttc_pointer    : OUT    std_logic_vector (4 DOWNTO 0);
      ttc_status     : OUT    std_logic_vector (15 DOWNTO 0)
   );

-- Declarations

END i2c_ttc_vme ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.i2c_ttc_vme.struct
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:25 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.all;

LIBRARY back_end_fpga;

ARCHITECTURE struct OF i2c_ttc_vme IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL i2c_err_held  : std_logic;
   SIGNAL ipb_high      : std_logic;
   SIGNAL rst_status    : std_logic;
   SIGNAL ttc_data_held : std_logic_vector(7 DOWNTO 0);


   -- Component Declarations
   COMPONENT i2c_ff_e
   GENERIC (
      q_rst : std_logic := '0'
   );
   PORT (
      d   : IN     std_logic ;
      clk : IN     std_logic ;
      rst : IN     std_logic ;
      q   : OUT    std_logic ;
      ce  : IN     std_logic 
   );
   END COMPONENT;
   COMPONENT i2c_reg_e
   GENERIC (
      width : integer   := 16;
      edge  : std_logic := '1'
   );
   PORT (
      d   : IN     std_logic_vector (width-1 DOWNTO 0);
      clk : IN     std_logic ;
      rst : IN     std_logic ;
      q   : OUT    std_logic_vector (width-1 DOWNTO 0);
      ce  : IN     std_logic 
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : i2c_ff_e USE ENTITY back_end_fpga.i2c_ff_e;
   FOR ALL : i2c_reg_e USE ENTITY back_end_fpga.i2c_reg_e;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   -- eb1 1
   ttc_status <= "000000"  
                 & i2c_err_held 
                 & i2c_busy
                 & ttc_data_held;

   -- HDL Embedded Text Block 3 eb3
   -- eb3 3
   ipb_high <= '1';

   -- HDL Embedded Text Block 4 eb4
   -- eb4 4
   i2c_abort <= TTC_control(15);
   rst_status <= TTC_control(15) or i2c_rst;
   -- don't use   TTC_control(14)
   ttc_pointer <= TTC_control(13 downto 9);
   i2c_rd_nwr  <=  TTC_control(8);
   data_to_ttc <= TTC_control(7 downto 0);

   -- Instance port mappings.
   I1 : i2c_ff_e
      GENERIC MAP (
         q_rst => '0'
      )
      PORT MAP (
         d   => ipb_high,
         clk => iclk40,
         rst => rst_status,
         q   => i2c_err_held,
         ce  => i2c_err
      );
   I0 : i2c_reg_e
      GENERIC MAP (
         width => 8,
         edge  => '1'
      )
      PORT MAP (
         d   => data_from_ttc,
         clk => iclk40,
         rst => rst_status,
         q   => ttc_data_held,
         ce  => set_vme_status
      );

END struct;
