-- hds header_start
--
-- VHDL Entity back_end_fpga.length_in_header.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:38:46 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

ENTITY length_in_header IS
   PORT( 
      clk2x          : IN     std_logic;
      rd_fe_lengths1 : IN     std_logic_vector (15 DOWNTO 0);
      read_hdr_en2   : IN     std_logic;
      reset          : IN     std_logic;
      temp_trkr_hdr  : IN     std_logic_vector (63 DOWNTO 0);
      int_trkr_hdr1  : OUT    std_logic_vector (63 DOWNTO 0)
   );

-- Declarations

END length_in_header ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.length_in_header.fsm
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:38:46 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ARCHITECTURE fsm OF length_in_header IS

   -- Architecture Declarations
   TYPE STATE_TYPE IS (
      L_hdr_0,
      L_hdr_1,
      L_hdr_2,
      L_hdr_3,
      L_hdr_4,
      L_hdr_5,
      L_hdr_6,
      L_hdr_7,
      L_hdr_8,
      L_hdr_9,
      L_hdr_10,
      L_hdr_12,
      L_hdr_11,
      L_hdr_14,
      L_hdr_13,
      L_hdr_15,
      L_hdr_16,
      L_hdr_17,
      L_hdr_18
   );

   -- State vector declaration
   ATTRIBUTE state_vector : string;
   ATTRIBUTE state_vector OF fsm : ARCHITECTURE IS "current_state" ;


   -- Declare current and next state signals
   SIGNAL current_state : STATE_TYPE ;
   SIGNAL next_state : STATE_TYPE ;

   -- Declare any pre-registered internal signals
   SIGNAL int_trkr_hdr1_cld : std_logic_vector (63 DOWNTO 0) ;

BEGIN

   ----------------------------------------------------------------------------
   clocked : PROCESS(
      clk2x,
      reset
   )
   ----------------------------------------------------------------------------
   BEGIN
      IF (reset = '1') THEN
         current_state <= L_hdr_0;
         -- Reset Values
         int_trkr_hdr1_cld <= (others => '0');
      ELSIF (clk2x'EVENT AND clk2x = '1') THEN
         current_state <= next_state;
         -- Default Assignment To Internals
         int_trkr_hdr1_cld <= (others => '0');

         -- Combined Actions for internal signals only
         CASE current_state IS
         WHEN L_hdr_0 =>
            int_trkr_hdr1_cld <= (others => '0') ;
         WHEN L_hdr_1 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         WHEN L_hdr_2 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         WHEN L_hdr_3 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         WHEN L_hdr_4 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         WHEN L_hdr_5 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         WHEN L_hdr_6 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         WHEN L_hdr_7 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         WHEN L_hdr_8 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         WHEN L_hdr_9 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         WHEN L_hdr_10 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         WHEN L_hdr_12 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         WHEN L_hdr_11 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         WHEN L_hdr_14 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         WHEN L_hdr_13 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         WHEN L_hdr_15 =>
            int_trkr_hdr1_cld <=  
            temp_trkr_hdr ;
         WHEN L_hdr_16 =>
            int_trkr_hdr1_cld <= (rd_fe_lengths1 & 
            temp_trkr_hdr(47 downto 0)) ;
         WHEN OTHERS =>
            NULL;
         END CASE;

      END IF;

   END PROCESS clocked;

   ----------------------------------------------------------------------------
   nextstate : PROCESS (
      current_state,
      read_hdr_en2
   )
   ----------------------------------------------------------------------------
   BEGIN
      CASE current_state IS
      WHEN L_hdr_0 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_1;
         ELSE
            next_state <= L_hdr_0;
         END IF;
      WHEN L_hdr_1 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_2;
         ELSE
            next_state <= L_hdr_1;
         END IF;
      WHEN L_hdr_2 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_3;
         ELSE
            next_state <= L_hdr_2;
         END IF;
      WHEN L_hdr_3 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_4;
         ELSE
            next_state <= L_hdr_3;
         END IF;
      WHEN L_hdr_4 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_5;
         ELSE
            next_state <= L_hdr_4;
         END IF;
      WHEN L_hdr_5 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_6;
         ELSE
            next_state <= L_hdr_5;
         END IF;
      WHEN L_hdr_6 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_7;
         ELSE
            next_state <= L_hdr_6;
         END IF;
      WHEN L_hdr_7 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_8;
         ELSE
            next_state <= L_hdr_7;
         END IF;
      WHEN L_hdr_8 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_9;
         ELSE
            next_state <= L_hdr_8;
         END IF;
      WHEN L_hdr_9 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_10;
         ELSE
            next_state <= L_hdr_9;
         END IF;
      WHEN L_hdr_10 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_11;
         ELSE
            next_state <= L_hdr_10;
         END IF;
      WHEN L_hdr_12 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_13;
         ELSE
            next_state <= L_hdr_12;
         END IF;
      WHEN L_hdr_11 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_12;
         ELSE
            next_state <= L_hdr_11;
         END IF;
      WHEN L_hdr_14 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_15;
         ELSE
            next_state <= L_hdr_14;
         END IF;
      WHEN L_hdr_13 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_14;
         ELSE
            next_state <= L_hdr_13;
         END IF;
      WHEN L_hdr_15 =>
         IF (read_hdr_en2 = '1') THEN
            next_state <= L_hdr_16;
         ELSE
            next_state <= L_hdr_15;
         END IF;
      WHEN L_hdr_16 =>
            next_state <= L_hdr_17;
      WHEN L_hdr_17 =>
            next_state <= L_hdr_18;
      WHEN L_hdr_18 =>
            next_state <= L_hdr_0;
      WHEN OTHERS =>
         next_state <= L_hdr_0;
      END CASE;

   END PROCESS nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   int_trkr_hdr1 <= int_trkr_hdr1_cld;


END fsm;
