-- hds header_start
--
-- VHDL Entity back_end_fpga.rdout_mux8to1.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:37:37 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY rdout_mux8to1 IS
   GENERIC( 
      widthout : integer := 64
   );
   PORT( 
      clk2x    : IN     std_logic;
      dout1    : IN     std_logic_vector (63 DOWNTO 0);
      dout2    : IN     std_logic_vector (63 DOWNTO 0);
      dout3    : IN     std_logic_vector (63 DOWNTO 0);
      dout4    : IN     std_logic_vector (63 DOWNTO 0);
      dout5    : IN     std_logic_vector (63 DOWNTO 0);
      dout6    : IN     std_logic_vector (63 DOWNTO 0);
      dout7    : IN     std_logic_vector (63 DOWNTO 0);
      dout8    : IN     std_logic_vector (63 DOWNTO 0);
      dout_rdy : IN     std_logic;
      reset    : IN     std_logic;
      fe_data  : OUT    std_logic_vector (63 DOWNTO 0)
   );

-- Declarations

END rdout_mux8to1 ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.rdout_mux8to1.fsm
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:37:37 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ARCHITECTURE fsm OF rdout_mux8to1 IS

   -- Architecture Declarations
   TYPE STATE_TYPE IS (
      rdout0,
      rdout1,
      rdout2,
      rdout3,
      rdout4,
      rdout5,
      rdout6,
      rdout7
   );

   -- State vector declaration
   ATTRIBUTE state_vector : string;
   ATTRIBUTE state_vector OF fsm : ARCHITECTURE IS "current_state" ;


   -- Declare current and next state signals
   SIGNAL current_state : STATE_TYPE ;
   SIGNAL next_state : STATE_TYPE ;

   -- Declare any pre-registered internal signals
   SIGNAL fe_data_cld : std_logic_vector (63 DOWNTO 0) ;

BEGIN

   ----------------------------------------------------------------------------
   clocked : PROCESS(
      clk2x,
      reset
   )
   ----------------------------------------------------------------------------
   BEGIN
      IF (reset = '1') THEN
         current_state <= rdout0;
         -- Reset Values
         fe_data_cld <= (others => '0');
      ELSIF (clk2x'EVENT AND clk2x = '1') THEN
         current_state <= next_state;
         -- Default Assignment To Internals
         fe_data_cld <= (others => '0');

         -- Combined Actions for internal signals only
         CASE current_state IS
         WHEN rdout0 =>
            fe_data_cld <= (others => '0') ;
            IF (dout_rdy = '1') THEN
               fe_data_cld <= dout1 
               after 1 ns;
            END IF;
         WHEN rdout1 =>
            fe_data_cld <= dout2 
            after 1 ns;
         WHEN rdout2 =>
            fe_data_cld <= dout3 
            after 1 ns;
         WHEN rdout3 =>
            fe_data_cld <= dout4
            after 1 ns ;
         WHEN rdout4 =>
            fe_data_cld <= dout5 
            after 1 ns;
         WHEN rdout5 =>
            fe_data_cld <= dout6 
            after 1 ns;
         WHEN rdout6 =>
            fe_data_cld <= dout7
            after 1 ns;
         WHEN rdout7 =>
            fe_data_cld <= dout8 
            after 1 ns;
         WHEN OTHERS =>
            NULL;
         END CASE;

      END IF;

   END PROCESS clocked;

   ----------------------------------------------------------------------------
   nextstate : PROCESS (
      current_state,
      dout_rdy
   )
   ----------------------------------------------------------------------------
   BEGIN
      CASE current_state IS
      WHEN rdout0 =>
         IF (dout_rdy = '1') THEN
            next_state <= rdout1;
         ELSE
            next_state <= rdout0;
         END IF;
      WHEN rdout1 =>
            next_state <= rdout2;
      WHEN rdout2 =>
            next_state <= rdout3;
      WHEN rdout3 =>
            next_state <= rdout4;
      WHEN rdout4 =>
            next_state <= rdout5;
      WHEN rdout5 =>
            next_state <= rdout6;
      WHEN rdout6 =>
            next_state <= rdout7;
      WHEN rdout7 =>
            next_state <= rdout0;
      WHEN OTHERS =>
         next_state <= rdout0;
      END CASE;

   END PROCESS nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   fe_data <= fe_data_cld;


END fsm;
