-- hds header_start
--
-- VHDL Entity back_end_fpga.serial_router.symbol
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:22 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


ENTITY serial_router IS
   PORT( 
      clk          : IN     std_logic;
      cmnd_in_a    : IN     std_logic;
      cmnd_in_b    : IN     std_logic;
      cmnd_in_c    : IN     std_logic;
      cmnd_in_d    : IN     std_logic;
      cmnd_in_e    : IN     std_logic;
      cmnd_in_f    : IN     std_logic;
      cmnd_in_g    : IN     std_logic;
      cmnd_in_h    : IN     std_logic;
      cmnd_in_i    : IN     std_logic;
      cmnd_in_j    : IN     std_logic;
      comnd_in     : IN     std_logic;
      rst          : IN     std_logic;
      cmnd_out_a   : OUT    std_logic;
      cmnd_out_b   : OUT    std_logic;
      cmnd_out_c   : OUT    std_logic;
      cmnd_out_d   : OUT    std_logic;
      cmnd_out_e   : OUT    std_logic;
      cmnd_out_f   : OUT    std_logic;
      cmnd_out_g   : OUT    std_logic;
      cmnd_out_h   : OUT    std_logic;
      cmnd_out_i   : OUT    std_logic;
      cmnd_out_j   : OUT    std_logic;
      data_from_FE : OUT    std_logic
   );

-- Declarations

END serial_router ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.serial_router.struct
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:41:23 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_arith.all;


LIBRARY back_end_fpga;

ARCHITECTURE struct OF serial_router IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL command_in_int : std_logic;
   SIGNAL command_to_FE  : std_logic;
   SIGNAL data_from_FE1  : std_logic;
   SIGNAL en_mux         : std_logic;
   SIGNAL en_mux_in      : std_logic;
   SIGNAL selt           : std_logic_vector(4 DOWNTO 0);
   SIGNAL selt_1         : std_logic_vector(4 DOWNTO 0);


   -- Component Declarations
   COMPONENT delay_24
   PORT (
      clk        : IN     std_logic ;
      en_mux_in  : IN     std_logic ;
      rst        : IN     std_logic ;
      en_mux_out : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT edd_ff
   PORT (
      CLK          : IN     std_logic ;
      en_write_out : IN     std_logic ;
      rst          : IN     std_logic ;
      write_out    : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT make_longer
   PORT (
      clk       : IN     std_logic ;
      en_mux    : IN     std_logic ;
      rst       : IN     std_logic ;
      en_mux_in : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT mux_1to9_and_back
   PORT (
      clk           : IN     std_logic ;
      cmnd_in_a     : IN     std_logic ;
      cmnd_in_b     : IN     std_logic ;
      cmnd_in_c     : IN     std_logic ;
      cmnd_in_d     : IN     std_logic ;
      cmnd_in_e     : IN     std_logic ;
      cmnd_in_f     : IN     std_logic ;
      cmnd_in_g     : IN     std_logic ;
      cmnd_in_h     : IN     std_logic ;
      cmnd_in_i     : IN     std_logic ;
      cmnd_in_j     : IN     std_logic ;
      command_to_FE : IN     std_logic ;
      en_mux_in     : IN     std_logic ;
      rst           : IN     std_logic ;
      selt          : IN     std_logic_vector (4 DOWNTO 0);
      cmnd_out_a    : OUT    std_logic ;
      cmnd_out_b    : OUT    std_logic ;
      cmnd_out_c    : OUT    std_logic ;
      cmnd_out_d    : OUT    std_logic ;
      cmnd_out_e    : OUT    std_logic ;
      cmnd_out_f    : OUT    std_logic ;
      cmnd_out_g    : OUT    std_logic ;
      cmnd_out_h    : OUT    std_logic ;
      cmnd_out_i    : OUT    std_logic ;
      cmnd_out_j    : OUT    std_logic ;
      data_from_FE1 : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT sel_decoder
   PORT (
      clk            : IN     std_logic ;
      command_in_int : IN     std_logic ;
      rst            : IN     std_logic ;
      en_mux         : OUT    std_logic ;
      selt_1         : OUT    std_logic_vector (4 DOWNTO 0)
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : delay_24 USE ENTITY back_end_fpga.delay_24;
   FOR ALL : edd_ff USE ENTITY back_end_fpga.edd_ff;
   FOR ALL : make_longer USE ENTITY back_end_fpga.make_longer;
   FOR ALL : mux_1to9_and_back USE ENTITY back_end_fpga.mux_1to9_and_back;
   FOR ALL : sel_decoder USE ENTITY back_end_fpga.sel_decoder;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   data_from_FE <= data_from_FE1 ;

   -- HDL Embedded Text Block 2 eb2
   selt <= selt_1 after 1 ns;

   -- Instance port mappings.
   I2 : delay_24
      PORT MAP (
         clk        => clk,
         en_mux_in  => command_in_int,
         rst        => rst,
         en_mux_out => command_to_FE
      );
   I7 : edd_ff
      PORT MAP (
         CLK          => clk,
         en_write_out => comnd_in,
         rst          => rst,
         write_out    => command_in_int
      );
   I3 : make_longer
      PORT MAP (
         clk       => clk,
         en_mux    => en_mux,
         rst       => rst,
         en_mux_in => en_mux_in
      );
   I0 : mux_1to9_and_back
      PORT MAP (
         clk           => clk,
         cmnd_in_a     => cmnd_in_a,
         cmnd_in_b     => cmnd_in_b,
         cmnd_in_c     => cmnd_in_c,
         cmnd_in_d     => cmnd_in_d,
         cmnd_in_e     => cmnd_in_e,
         cmnd_in_f     => cmnd_in_f,
         cmnd_in_g     => cmnd_in_g,
         cmnd_in_h     => cmnd_in_h,
         cmnd_in_i     => cmnd_in_i,
         cmnd_in_j     => cmnd_in_j,
         command_to_FE => command_to_FE,
         en_mux_in     => en_mux_in,
         rst           => rst,
         selt          => selt,
         cmnd_out_a    => cmnd_out_a,
         cmnd_out_b    => cmnd_out_b,
         cmnd_out_c    => cmnd_out_c,
         cmnd_out_d    => cmnd_out_d,
         cmnd_out_e    => cmnd_out_e,
         cmnd_out_f    => cmnd_out_f,
         cmnd_out_g    => cmnd_out_g,
         cmnd_out_h    => cmnd_out_h,
         cmnd_out_i    => cmnd_out_i,
         cmnd_out_j    => cmnd_out_j,
         data_from_FE1 => data_from_FE1
      );
   I1 : sel_decoder
      PORT MAP (
         clk            => clk,
         command_in_int => command_in_int,
         rst            => rst,
         en_mux         => en_mux,
         selt_1         => selt_1
      );

END struct;
