-- hds header_start
--
-- VHDL Entity back_end_fpga.SLINK_interface.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:38:22 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;

ENTITY SLINK_interface IS
   PORT( 
      clk2x                : IN     std_logic;
      ctrl                 : IN     std_logic;
      data_out             : IN     std_logic_vector (63 DOWNTO 0);
      data_out_en          : IN     std_logic;
      en_qdr_data_to_slink : IN     std_logic;
      ready                : IN     std_logic;
      reset                : IN     std_logic;
      slink_lrl            : IN     std_logic_vector (3 DOWNTO 0);
      slink_lsf            : IN     std_logic_vector (3 DOWNTO 0);
      slink_uclk           : OUT    std_logic;
      slink_ucntl_b        : OUT    std_logic;
      slink_ud             : OUT    std_logic_vector (63 DOWNTO 0);
      slink_udw            : OUT    std_logic_vector (1 DOWNTO 0);
      slink_ureset_b       : OUT    std_logic;
      slink_usf            : OUT    std_logic_vector (3 DOWNTO 0);
      slink_utest_b        : OUT    std_logic;
      slink_uwen_b         : OUT    std_logic
   );

-- Declarations

END SLINK_interface ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.SLINK_interface.struct
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:38:35 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY unisim;

ARCHITECTURE struct OF SLINK_interface IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL clk2x_slink_b : std_logic;
   SIGNAL ctrl_b        : std_logic;
   SIGNAL data_out_en_b : std_logic;
   SIGNAL high          : std_logic := '0';
   SIGNAL low           : std_logic := '0';
   SIGNAL slink_status  : std_logic_vector(7 DOWNTO 0);


   -- Component Declarations
   COMPONENT FDCE
   PORT (
      C   : IN     STD_ULOGIC;
      CE  : IN     STD_ULOGIC;
      CLR : IN     STD_ULOGIC;
      D   : IN     STD_ULOGIC;
      Q   : OUT    STD_ULOGIC
   );
   END COMPONENT;
   COMPONENT FDCPE
   PORT (
      C   : IN     STD_ULOGIC;
      CE  : IN     STD_ULOGIC;
      CLR : IN     STD_ULOGIC;
      D   : IN     STD_ULOGIC;
      PRE : IN     STD_ULOGIC;
      Q   : OUT    STD_ULOGIC
   );
   END COMPONENT;
   COMPONENT fddrcpe
   PORT (
      C0  : IN     STD_ULOGIC;
      C1  : IN     STD_ULOGIC;
      CE  : IN     STD_ULOGIC;
      CLR : IN     STD_ULOGIC;
      D0  : IN     STD_ULOGIC;
      D1  : IN     STD_ULOGIC;
      PRE : IN     STD_ULOGIC;
      Q   : OUT    STD_ULOGIC
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : FDCE USE ENTITY unisim.FDCE;
   FOR ALL : FDCPE USE ENTITY unisim.FDCPE;
   FOR ALL : fddrcpe USE ENTITY unisim.fddrcpe;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   -- for test only , keep zeros
   slink_usf <= "0000" AND slink_lsf AND slink_lrl;
   
   slink_udw <= "11";
   slink_utest_b <= '1';
   
   slink_status <= slink_lsf & slink_lrl;
   
   high <= '1';
   low <= '0';


   -- ModuleWare code for instance 'I4' of 'inv'
      data_out_en_b <= NOT(data_out_en);

   -- ModuleWare code for instance 'I2' of 'inv'
      clk2x_slink_b <= NOT(clk2x);

   -- ModuleWare code for instance 'I0' of 'inv'
      slink_ureset_b <= NOT(reset);

   -- ModuleWare code for instance 'I7' of 'inv'
      ctrl_b <= NOT(ctrl);
   -- Instance port mappings.
   I3 : FDCPE
      PORT MAP (
         Q   => slink_uwen_b,
         C   => clk2x,
         CE  => en_qdr_data_to_slink,
         CLR => low,
         D   => data_out_en_b,
         PRE => reset
      );
   I5 : FDCPE
      PORT MAP (
         Q   => slink_ucntl_b,
         C   => clk2x,
         CE  => en_qdr_data_to_slink,
         CLR => low,
         D   => ctrl_b,
         PRE => reset
      );
   I1 : fddrcpe
      PORT MAP (
         Q   => slink_uclk,
         C0  => clk2x,
         C1  => clk2x_slink_b,
         CE  => high,
         D0  => low,
         D1  => high,
         CLR => reset,
         PRE => low
      );

   g6: FOR i IN 0 TO 63 GENERATE
      I6 : FDCE
         PORT MAP (
            Q   => slink_ud(i),
            C   => clk2x,
            CE  => en_qdr_data_to_slink,
            CLR => reset,
            D   => data_out(i)
         );
   END GENERATE g6;

END struct;
