-- hds header_start
--
-- VHDL Entity back_end_fpga.tst_data_gen.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:35:48 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY tst_data_gen IS
   PORT( 
      clk2x            : IN     std_logic;
      qdr_test_data_en : IN     std_logic_vector (1 DOWNTO 0);
      qdr_wr_addr_en_1 : IN     std_logic;
      reset            : IN     std_logic;
      qdr_test_pattern : OUT    std_logic_vector (71 DOWNTO 0)
   );

-- Declarations

END tst_data_gen ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.tst_data_gen.fsm
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:35:48 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ARCHITECTURE fsm OF tst_data_gen IS

   -- Architecture Declarations
   signal count : integer := 0;

   TYPE STATE_TYPE IS (
      tst_data0,
      tst_data1,
      tst_data2
   );

   -- State vector declaration
   ATTRIBUTE state_vector : string;
   ATTRIBUTE state_vector OF fsm : ARCHITECTURE IS "current_state" ;


   -- Declare current and next state signals
   SIGNAL current_state : STATE_TYPE ;
   SIGNAL next_state : STATE_TYPE ;

   -- Declare any pre-registered internal signals
   SIGNAL qdr_test_pattern_cld : std_logic_vector (71 DOWNTO 0) ;

BEGIN

   ----------------------------------------------------------------------------
   clocked : PROCESS(
      clk2x,
      reset
   )
   ----------------------------------------------------------------------------
   BEGIN
      IF (reset = '1') THEN
         current_state <= tst_data0;
         -- Reset Values
         qdr_test_pattern_cld <= (others => '0');
         count <= 0;
      ELSIF (clk2x'EVENT AND clk2x = '1') THEN
         current_state <= next_state;
         -- Default Assignment To Internals
         count <= 0;

         -- Combined Actions for internal signals only
         CASE current_state IS
         WHEN tst_data0 =>
            qdr_test_pattern_cld <= (others => '0');
            count <= 0;
            IF (qdr_test_data_en = "10" 
            AND qdr_wr_addr_en_1 = '0') THEN
               qdr_test_pattern_cld <= "101010101010101010101010101010101010"
               & "101010101010101010101010101010101010"  after 1 ns;
               count <= (count + 1) after 1 ns;
            END IF;
         WHEN tst_data1 =>
            qdr_test_pattern_cld <= "101010101010101010101010101010101010"
            & "101010101010101010101010101010101010"  after 1 ns;
            count <= (count + 1) after 1 ns;
            IF (qdr_wr_addr_en_1 = '1') THEN
            ELSIF (count = 7) THEN
               count <= 0;
            END IF;
         WHEN tst_data2 =>
            qdr_test_pattern_cld <= "010101010101010101010101010101010101"
            & "010101010101010101010101010101010101"  after 1 ns;
            count <= (count + 1) after 1 ns;
            IF (qdr_wr_addr_en_1 = '1') THEN
            ELSIF (count = 7) THEN
               count <= 0;
            END IF;
         WHEN OTHERS =>
            NULL;
         END CASE;

      END IF;

   END PROCESS clocked;

   ----------------------------------------------------------------------------
   nextstate : PROCESS (
      count,
      current_state,
      qdr_test_data_en,
      qdr_wr_addr_en_1
   )
   ----------------------------------------------------------------------------
   BEGIN
      CASE current_state IS
      WHEN tst_data0 =>
         IF (qdr_test_data_en = "10" 
         AND qdr_wr_addr_en_1 = '0') THEN
            next_state <= tst_data1;
         ELSE
            next_state <= tst_data0;
         END IF;
      WHEN tst_data1 =>
         IF (qdr_wr_addr_en_1 = '1') THEN
            next_state <= tst_data0;
         ELSIF (count = 7) THEN
            next_state <= tst_data2;
         ELSE
            next_state <= tst_data1;
         END IF;
      WHEN tst_data2 =>
         IF (qdr_wr_addr_en_1 = '1') THEN
            next_state <= tst_data0;
         ELSIF (count = 7) THEN
            next_state <= tst_data1;
         ELSE
            next_state <= tst_data2;
         END IF;
      WHEN OTHERS =>
         next_state <= tst_data0;
      END CASE;

   END PROCESS nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   qdr_test_pattern <= qdr_test_pattern_cld;


END fsm;
