-- hds header_start
--
-- VHDL Entity back_end_fpga.TTC_ser_B_decode.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:42:30 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.ALL;
USE ieee.std_logic_unsigned.all;
use ieee.std_logic_arith.ALL;

ENTITY TTC_ser_B_decode IS
   PORT( 
      clk1x                : IN     std_logic;
      reset                : IN     std_logic;
      ttc_serial_b         : IN     std_logic;
      brdcst_cmnd_valid    : OUT    std_logic;
      single_cmnd_valid    : OUT    std_logic;
      ttc_brdcst_cmnd_data : OUT    std_logic_vector (12 DOWNTO 0);
      ttc_single_cmnd_data : OUT    std_logic_vector (38 DOWNTO 0)
   );

-- Declarations

END TTC_ser_B_decode ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.TTC_ser_B_decode.fsm
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:42:30 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.numeric_std.ALL;

ARCHITECTURE fsm OF TTC_ser_B_decode IS

   -- Architecture Declarations
   signal count : integer range 0 to 44 := 0;
   signal tmp_single : std_logic_vector(40 downto 0);
   signal tmp_brdcst : std_logic_vector(14 downto 0);

   TYPE STATE_TYPE IS (
      ttc_cmnd0,
      ttc_cmnd2,
      ttc_cmnd3,
      ttc_cmnd4,
      ttc_cmnd5,
      ttc_cmnd6,
      ttc_cmnd1
   );

   -- State vector declaration
   ATTRIBUTE state_vector : string;
   ATTRIBUTE state_vector OF fsm : ARCHITECTURE IS "current_state" ;


   -- Declare current and next state signals
   SIGNAL current_state : STATE_TYPE ;
   SIGNAL next_state : STATE_TYPE ;

   -- Declare any pre-registered internal signals
   SIGNAL brdcst_cmnd_valid_cld : std_logic  ;
   SIGNAL single_cmnd_valid_cld : std_logic  ;
   SIGNAL ttc_brdcst_cmnd_data_cld : std_logic_vector (12 DOWNTO 0) ;
   SIGNAL ttc_single_cmnd_data_cld : std_logic_vector (38 DOWNTO 0) ;

BEGIN

   ----------------------------------------------------------------------------
   clocked : PROCESS(
      clk1x,
      reset
   )
   ----------------------------------------------------------------------------
   BEGIN
      IF (reset = '1') THEN
         current_state <= ttc_cmnd0;
         -- Reset Values
         brdcst_cmnd_valid_cld <= '0';
         single_cmnd_valid_cld <= '0';
         ttc_brdcst_cmnd_data_cld <= (others => '0');
         ttc_single_cmnd_data_cld <= (others => '0');
         count <= 0;
         tmp_brdcst <= (others => '0');
         tmp_single <= (others => '0');
      ELSIF (clk1x'EVENT AND clk1x = '1') THEN
         current_state <= next_state;
         -- Default Assignment To Internals

         -- Combined Actions for internal signals only
         CASE current_state IS
         WHEN ttc_cmnd0 =>
            brdcst_cmnd_valid_cld <= '0' after 1 ns;
            single_cmnd_valid_cld <= '0'  after 1 ns;
            count <= 0 after 1 ns;
            tmp_brdcst <= (others => '0')   after 1 ns;
            tmp_single <= (others => '0')   after 1 ns;
            ttc_brdcst_cmnd_data_cld <= (others => '0')   after 1 ns;
            ttc_single_cmnd_data_cld <= (others => '0')   after 1 ns;
         WHEN ttc_cmnd2 =>
            IF (ttc_serial_b = '1') THEN
               count <= 40 after 1 ns;
            ELSIF (ttc_serial_b = '0') THEN
               count <= 14 after 1 ns;
            END IF;
         WHEN ttc_cmnd3 =>
            tmp_single(count) <= ttc_serial_b after 1 ns;
            count <= count -1 after 1 ns;
         WHEN ttc_cmnd4 =>
            ttc_single_cmnd_data_cld <= 
            tmp_single ( 40 downto 2 ) after 1 ns;
            count <= 0 after 1 ns;
            single_cmnd_valid_cld 
            <= '1' after 1 ns;
         WHEN ttc_cmnd5 =>
            tmp_brdcst (count) <= ttc_serial_b after 1 ns;
            count <= count -1 after 1 ns;
         WHEN ttc_cmnd6 =>
            ttc_brdcst_cmnd_data_cld <= 
            tmp_brdcst ( 14 downto 2) after 1 ns;
            brdcst_cmnd_valid_cld 
            <= '1' after 1 ns;
            count <= 0 after 1 ns;
         WHEN OTHERS =>
            NULL;
         END CASE;

      END IF;

   END PROCESS clocked;

   ----------------------------------------------------------------------------
   nextstate : PROCESS (
      count,
      current_state,
      ttc_serial_b
   )
   ----------------------------------------------------------------------------
   BEGIN
      CASE current_state IS
      WHEN ttc_cmnd0 =>
         IF (ttc_serial_b = '1') THEN
            next_state <= ttc_cmnd1;
         ELSE
            next_state <= ttc_cmnd0;
         END IF;
      WHEN ttc_cmnd2 =>
         IF (ttc_serial_b = '1') THEN
            next_state <= ttc_cmnd3;
         ELSIF (ttc_serial_b = '0') THEN
            next_state <= ttc_cmnd5;
         ELSE
            next_state <= ttc_cmnd2;
         END IF;
      WHEN ttc_cmnd3 =>
         IF (count = 2) THEN
            next_state <= ttc_cmnd4;
         ELSE
            next_state <= ttc_cmnd3;
         END IF;
      WHEN ttc_cmnd4 =>
            next_state <= ttc_cmnd0;
      WHEN ttc_cmnd5 =>
         IF (count = 2) THEN
            next_state <= ttc_cmnd6;
         ELSE
            next_state <= ttc_cmnd5;
         END IF;
      WHEN ttc_cmnd6 =>
            next_state <= ttc_cmnd0;
      WHEN ttc_cmnd1 =>
         IF (ttc_serial_b = '0') THEN
            next_state <= ttc_cmnd2;
         ELSE
            next_state <= ttc_cmnd1;
         END IF;
      WHEN OTHERS =>
         next_state <= ttc_cmnd0;
      END CASE;

   END PROCESS nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   brdcst_cmnd_valid <= brdcst_cmnd_valid_cld;
   single_cmnd_valid <= single_cmnd_valid_cld;
   ttc_brdcst_cmnd_data <= ttc_brdcst_cmnd_data_cld;
   ttc_single_cmnd_data <= ttc_single_cmnd_data_cld;


END fsm;
