-- hds header_start
--
-- VHDL Entity back_end_fpga.vme_qdr_rd.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:39:23 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
use ieee.std_logic_arith.ALL;

ENTITY vme_qdr_rd IS
   PORT( 
      clk2x              : IN     std_logic;
      clk2x_n            : IN     STD_ULOGIC;
      ctrl               : IN     std_logic;
      data_out           : IN     std_logic_vector (63 DOWNTO 0);
      data_out_en        : IN     std_logic;
      en_qdr_data_to_vme : IN     std_logic;
      reset              : IN     std_logic;
      vme_link_clk       : IN     std_logic;
      vme_link_clk_n     : IN     std_logic;
      cntl_to_vme        : OUT    std_logic;
      data_out_to_vme    : OUT    std_logic_vector (31 DOWNTO 0);
      data_to_vme_valid  : OUT    std_logic
   );

-- Declarations

END vme_qdr_rd ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.vme_qdr_rd.struct_clk_inv
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:39:34 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY unisim;

ARCHITECTURE struct_clk_inv OF vme_qdr_rd IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL data_out_lsb : std_logic_vector(31 DOWNTO 0);
   SIGNAL data_out_msb : std_logic_vector(31 DOWNTO 0);
   SIGNAL low          : STD_ULOGIC;


   -- ModuleWare signal declarations for instance 'I10' of 'split'
   SIGNAL MW_I10dinl : std_logic_vector(63 DOWNTO 0);

   -- Component Declarations
   COMPONENT FDDRCPE
   PORT (
      C0  : IN     STD_ULOGIC;
      C1  : IN     STD_ULOGIC;
      CE  : IN     STD_ULOGIC;
      CLR : IN     STD_ULOGIC;
      D0  : IN     STD_ULOGIC;
      D1  : IN     STD_ULOGIC;
      PRE : IN     STD_ULOGIC;
      Q   : OUT    STD_ULOGIC
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : FDDRCPE USE ENTITY unisim.FDDRCPE;
   -- pragma synthesis_on


BEGIN

   -- ModuleWare code for instance 'I10' of 'split'
   MW_I10dinl <= data_out;
   data_out_lsb <= MW_I10dinl(31 DOWNTO 0);
   data_out_msb <= MW_I10dinl(63 DOWNTO 32);

   -- ModuleWare code for instance 'I12' of 'gnd'
      low <= '0';
   -- Instance port mappings.
   I2 : FDDRCPE
      PORT MAP (
         Q   => data_to_vme_valid,
         C0  => clk2x_n,
         C1  => clk2x,
         CE  => en_qdr_data_to_vme,
         D0  => data_out_en,
         D1  => data_out_en,
         CLR => reset,
         PRE => low
      );
   I1 : FDDRCPE
      PORT MAP (
         Q   => cntl_to_vme,
         C0  => vme_link_clk_n,
         C1  => vme_link_clk,
         CE  => en_qdr_data_to_vme,
         D0  => ctrl,
         D1  => ctrl,
         CLR => reset,
         PRE => low
      );

   g2: FOR i IN 0 TO 31 GENERATE
      I3 : FDDRCPE
         PORT MAP (
            Q   => data_out_to_vme(i),
            C0  => clk2x_n,
            C1  => clk2x,
            CE  => en_qdr_data_to_vme,
            D0  => data_out_msb(i),
            D1  => data_out_lsb(i),
            CLR => reset,
            PRE => low
         );
   END GENERATE g2;

END struct_clk_inv;
