-- hds header_start
--
-- VHDL Entity back_end_fpga.word64_lengths.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:34:37 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY word64_lengths IS
   PORT( 
      byte_length1       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length2       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length3       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length4       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length5       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length6       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length7       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length8       : IN     std_logic_vector (14 DOWNTO 0);
      clk1x              : IN     std_logic;
      clk2x              : IN     std_logic;
      done               : IN     std_logic;
      en_fe_data_capture : IN     std_logic;
      rd_trckr_hdr_en    : IN     std_logic;
      reset              : IN     std_logic;
      rst_registers      : IN     std_logic;
      done_1             : OUT    std_logic;
      fe_len_25_flag     : OUT    std_logic;
      fe_len_50_flag     : OUT    std_logic;
      fe_len_87_flag     : OUT    std_logic;
      fe_len_empty       : OUT    std_logic;
      fe_len_full        : OUT    std_logic;
      length1            : OUT    std_logic_vector (17 DOWNTO 0);
      length2            : OUT    std_logic_vector (17 DOWNTO 0);
      length3            : OUT    std_logic_vector (17 DOWNTO 0);
      length4            : OUT    std_logic_vector (17 DOWNTO 0);
      length5            : OUT    std_logic_vector (17 DOWNTO 0);
      length6            : OUT    std_logic_vector (17 DOWNTO 0);
      length7            : OUT    std_logic_vector (17 DOWNTO 0);
      length8            : OUT    std_logic_vector (17 DOWNTO 0);
      rd_fe_lengths      : OUT    std_logic_vector (17 DOWNTO 0)
   );

-- Declarations

END word64_lengths ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.word64_lengths.struct
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:34:39 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

LIBRARY back_end_fpga;

ARCHITECTURE struct OF word64_lengths IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL rd_fe_len_flags  : std_logic_vector(2 DOWNTO 0);
   SIGNAL wr_fe_lenghts_en : std_logic;
   SIGNAL wr_fe_lengths    : std_logic_vector(17 DOWNTO 0);


   -- Component Declarations
   COMPONENT fifo_4k_18bits
   PORT (
      din      : IN     std_logic_VECTOR (17 DOWNTO 0);
      wr_en    : IN     std_logic ;
      wr_clk   : IN     std_logic ;
      rd_en    : IN     std_logic ;
      rd_clk   : IN     std_logic ;
      ainit    : IN     std_logic ;
      dout     : OUT    std_logic_VECTOR (17 DOWNTO 0);
      full     : OUT    std_logic ;
      empty    : OUT    std_logic ;
      wr_count : OUT    std_logic_VECTOR (2 DOWNTO 0)
   );
   END COMPONENT;
   COMPONENT length_decrement
   GENERIC (
      denom : integer := 8
   );
   PORT (
      d_length : IN     std_logic_vector (14 DOWNTO 0); -- number of data byte
      a_length : OUT    std_logic_vector (17 DOWNTO 0); -- number of 64-bit words of data
      clk      : IN     std_logic ;
      en       : IN     std_logic ;
      reset    : IN     std_logic 
   );
   END COMPONENT;
   COMPONENT rd_fe_len_flag_gen
   PORT (
      clk2x           : IN     std_logic ;
      rd_fe_len_flags : IN     std_logic_vector (2 DOWNTO 0);
      reset           : IN     std_logic ;
      fe_len_25_flag  : OUT    std_logic ;
      fe_len_50_flag  : OUT    std_logic ;
      fe_len_87_flag  : OUT    std_logic 
   );
   END COMPONENT;
   COMPONENT wr_all_lengths
   PORT (
      byte_length1       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length2       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length3       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length4       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length5       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length6       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length7       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length8       : IN     std_logic_vector (14 DOWNTO 0);
      clk1x              : IN     std_logic ;
      done               : IN     std_logic ;
      en_fe_data_capture : IN     std_logic ;
      reset              : IN     std_logic ;
      wr_fe_lenghts_en   : OUT    std_logic ;
      wr_fe_lengths      : OUT    std_logic_vector (17 DOWNTO 0)
   );
   END COMPONENT;

   -- ModuleWare Component Declarations
   COMPONENT adff_614B7010
   PORT (
      Clk : IN     std_logic;
      D   : IN     std_logic;
      Rst : IN     std_logic;
      Q   : OUT    std_logic;
      Qb  : OUT    std_logic
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : fifo_4k_18bits USE ENTITY back_end_fpga.fifo_4k_18bits;
   FOR ALL : length_decrement USE ENTITY back_end_fpga.length_decrement;
   FOR ALL : rd_fe_len_flag_gen USE ENTITY back_end_fpga.rd_fe_len_flag_gen;
   FOR ALL : wr_all_lengths USE ENTITY back_end_fpga.wr_all_lengths;
   -- pragma synthesis_on

   -- ModuleWare embedded configurations
   -- pragma synthesis_off
   FOR ALL : adff_614B7010 USE ENTITY back_end_fpga.adff_614B7010;
   -- pragma synthesis_on


BEGIN
   -- Instance port mappings.
   FE_length_FIFO : fifo_4k_18bits
      PORT MAP (
         din      => wr_fe_lengths,
         wr_en    => wr_fe_lenghts_en,
         wr_clk   => clk1x,
         rd_en    => rd_trckr_hdr_en,
         rd_clk   => clk1x,
         ainit    => reset,
         dout     => rd_fe_lengths,
         full     => fe_len_full,
         empty    => fe_len_empty,
         wr_count => rd_fe_len_flags
      );
   I7 : length_decrement
      GENERIC MAP (
         denom => 8
      )
      PORT MAP (
         d_length => byte_length8,
         a_length => length8,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I1 : length_decrement
      GENERIC MAP (
         denom => 8
      )
      PORT MAP (
         d_length => byte_length2,
         a_length => length2,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I3 : length_decrement
      GENERIC MAP (
         denom => 8
      )
      PORT MAP (
         d_length => byte_length4,
         a_length => length4,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I5 : length_decrement
      GENERIC MAP (
         denom => 8
      )
      PORT MAP (
         d_length => byte_length6,
         a_length => length6,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I0 : length_decrement
      GENERIC MAP (
         denom => 8
      )
      PORT MAP (
         d_length => byte_length1,
         a_length => length1,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I6 : length_decrement
      GENERIC MAP (
         denom => 8
      )
      PORT MAP (
         d_length => byte_length7,
         a_length => length7,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I4 : length_decrement
      GENERIC MAP (
         denom => 8
      )
      PORT MAP (
         d_length => byte_length5,
         a_length => length5,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I2 : length_decrement
      GENERIC MAP (
         denom => 8
      )
      PORT MAP (
         d_length => byte_length3,
         a_length => length3,
         clk      => clk1x,
         en       => done,
         reset    => rst_registers
      );
   I8 : rd_fe_len_flag_gen
      PORT MAP (
         clk2x           => clk2x,
         rd_fe_len_flags => rd_fe_len_flags,
         reset           => reset,
         fe_len_25_flag  => fe_len_25_flag,
         fe_len_50_flag  => fe_len_50_flag,
         fe_len_87_flag  => fe_len_87_flag
      );
   I10 : wr_all_lengths
      PORT MAP (
         byte_length1       => byte_length1,
         byte_length2       => byte_length2,
         byte_length3       => byte_length3,
         byte_length4       => byte_length4,
         byte_length5       => byte_length5,
         byte_length6       => byte_length6,
         byte_length7       => byte_length7,
         byte_length8       => byte_length8,
         clk1x              => clk1x,
         done               => done,
         en_fe_data_capture => en_fe_data_capture,
         reset              => reset,
         wr_fe_lenghts_en   => wr_fe_lenghts_en,
         wr_fe_lengths      => wr_fe_lengths
      );

   -- ModuleWare instance port mappings.
   I9 : adff_614B7010
      PORT MAP (
         Clk => clk1x,
         D   => done,
         Rst => reset,
         Q   => done_1,
         Qb  => OPEN
      );


END struct;
