-- hds header_start
--
-- VHDL Entity back_end_fpga.wr_all_lengths.interface
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:34:36 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;
USE ieee.std_logic_unsigned.all;

ENTITY wr_all_lengths IS
   PORT( 
      byte_length1       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length2       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length3       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length4       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length5       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length6       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length7       : IN     std_logic_vector (14 DOWNTO 0);
      byte_length8       : IN     std_logic_vector (14 DOWNTO 0);
      clk1x              : IN     std_logic;
      done               : IN     std_logic;
      en_fe_data_capture : IN     std_logic;
      reset              : IN     std_logic;
      wr_fe_lenghts_en   : OUT    std_logic;
      wr_fe_lengths      : OUT    std_logic_vector (17 DOWNTO 0)
   );

-- Declarations

END wr_all_lengths ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.wr_all_lengths.fsm
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:34:36 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ARCHITECTURE fsm OF wr_all_lengths IS

   -- Architecture Declarations
   TYPE STATE_TYPE IS (
      wr_fe_L_0,
      wr_fe_L_1,
      wr_fe_L_2,
      wr_fe_L_3,
      wr_fe_L_4,
      wr_fe_L_5,
      wr_fe_L_6,
      wr_fe_L_7,
      wr_fe_L_8,
      wr_fe_L_9
   );

   -- State vector declaration
   ATTRIBUTE state_vector : string;
   ATTRIBUTE state_vector OF fsm : ARCHITECTURE IS "current_state" ;


   -- Declare current and next state signals
   SIGNAL current_state : STATE_TYPE ;
   SIGNAL next_state : STATE_TYPE ;

   -- Declare any pre-registered internal signals
   SIGNAL wr_fe_lenghts_en_cld : std_logic  ;
   SIGNAL wr_fe_lengths_cld : std_logic_vector (17 DOWNTO 0) ;

BEGIN

   ----------------------------------------------------------------------------
   clocked : PROCESS(
      clk1x,
      reset
   )
   ----------------------------------------------------------------------------
   BEGIN
      IF (reset = '1') THEN
         current_state <= wr_fe_L_0;
         -- Reset Values
         wr_fe_lenghts_en_cld <= '0';
         wr_fe_lengths_cld <= (others => '0') ;
      ELSIF (clk1x'EVENT AND clk1x = '1') THEN
         IF (en_fe_data_capture = '1') THEN
            current_state <= next_state;
            -- Default Assignment To Internals
            wr_fe_lenghts_en_cld <= '0';
            wr_fe_lengths_cld <= (others => '0') ;

            -- Combined Actions for internal signals only
            CASE current_state IS
            WHEN wr_fe_L_0 =>
               wr_fe_lengths_cld <= (others => '0') after 1 ns;
               wr_fe_lenghts_en_cld <= '0' after 1 ns;
            WHEN wr_fe_L_1 =>
               wr_fe_lengths_cld <=( "000" & byte_length1(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            WHEN wr_fe_L_2 =>
               wr_fe_lengths_cld <= ("000" & byte_length2(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            WHEN wr_fe_L_3 =>
               wr_fe_lengths_cld <= ("000" & byte_length3(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            WHEN wr_fe_L_4 =>
               wr_fe_lengths_cld <= ("000" & byte_length4(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            WHEN wr_fe_L_5 =>
               wr_fe_lengths_cld <=( "000" & byte_length5(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            WHEN wr_fe_L_6 =>
               wr_fe_lengths_cld <= ("000" & byte_length6(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            WHEN wr_fe_L_7 =>
               wr_fe_lengths_cld <=( "000" & byte_length7(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            WHEN wr_fe_L_8 =>
               wr_fe_lengths_cld <= ("000" & byte_length8(14 downto 0) )
               after 1 ns;
               wr_fe_lenghts_en_cld <= '1' after 1 ns;
            WHEN wr_fe_L_9 =>
               wr_fe_lengths_cld <= (others => '0') after 1 ns;
               wr_fe_lenghts_en_cld <= '0' after 1 ns;
            WHEN OTHERS =>
               NULL;
            END CASE;

         END IF;
      END IF;

   END PROCESS clocked;

   ----------------------------------------------------------------------------
   nextstate : PROCESS (
      current_state,
      done,
      en_fe_data_capture
   )
   ----------------------------------------------------------------------------
   BEGIN
      CASE current_state IS
      WHEN wr_fe_L_0 =>
         IF (done = '1' AND 
         en_fe_data_capture = '1') THEN
            next_state <= wr_fe_L_1;
         ELSE
            next_state <= wr_fe_L_0;
         END IF;
      WHEN wr_fe_L_1 =>
            next_state <= wr_fe_L_2;
      WHEN wr_fe_L_2 =>
            next_state <= wr_fe_L_3;
      WHEN wr_fe_L_3 =>
            next_state <= wr_fe_L_4;
      WHEN wr_fe_L_4 =>
            next_state <= wr_fe_L_5;
      WHEN wr_fe_L_5 =>
            next_state <= wr_fe_L_6;
      WHEN wr_fe_L_6 =>
            next_state <= wr_fe_L_7;
      WHEN wr_fe_L_7 =>
            next_state <= wr_fe_L_8;
      WHEN wr_fe_L_8 =>
            next_state <= wr_fe_L_9;
      WHEN wr_fe_L_9 =>
            next_state <= wr_fe_L_0;
      WHEN OTHERS =>
         next_state <= wr_fe_L_0;
      END CASE;

   END PROCESS nextstate;

   -- Concurrent Statements
   -- Clocked output assignments
   wr_fe_lenghts_en <= wr_fe_lenghts_en_cld;
   wr_fe_lengths <= wr_fe_lengths_cld;


END fsm;
