-- hds header_start
--
-- VHDL Entity back_end_fpga.wr_burst_2.symbol
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:35:48 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY wr_burst_2 IS
   PORT( 
      D0         : IN     std_logic;
      D1         : IN     std_logic;
      DCM_locked : IN     std_ulogic;
      clk        : IN     std_logic;
      rst        : IN     std_logic;
      wr         : IN     std_logic;
      Q          : OUT    std_logic
   );

-- Declarations

END wr_burst_2 ;

-- hds interface_end
--
-- VHDL Architecture back_end_fpga.wr_burst_2.struct
--
-- Created:
--          by - phmpk.UNKNOWN (VMWARE-TEST)
--          at - 09:36:11 09/30/05
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
LIBRARY ieee;
USE ieee.std_logic_1164.all;

LIBRARY unisim;

ARCHITECTURE struct OF wr_burst_2 IS

   -- Architecture declarations

   -- Internal signal declarations
   SIGNAL CE      : STD_ULOGIC;
   SIGNAL D1_fdc  : std_logic;
   SIGNAL ENVOI_1 : STD_ULOGIC;
   SIGNAL Q1      : STD_ULOGIC;
   SIGNAL ce_fddr : std_logic;
   SIGNAL clk_b_1 : std_logic;
   SIGNAL clk_b_2 : std_logic;
   SIGNAL high    : std_ulogic := '0';
   SIGNAL low     : std_ulogic := '0';


   -- Component Declarations
   COMPONENT fdc
   PORT (
      C   : IN     STD_ULOGIC;
      CLR : IN     STD_ULOGIC;
      D   : IN     STD_ULOGIC;
      Q   : OUT    STD_ULOGIC
   );
   END COMPONENT;
   COMPONENT fdc_1
   PORT (
      C   : IN     STD_ULOGIC;
      CLR : IN     STD_ULOGIC;
      D   : IN     STD_ULOGIC;
      Q   : OUT    STD_ULOGIC
   );
   END COMPONENT;
   COMPONENT fddrcpe
   PORT (
      C0  : IN     STD_ULOGIC;
      C1  : IN     STD_ULOGIC;
      CE  : IN     STD_ULOGIC;
      CLR : IN     STD_ULOGIC;
      D0  : IN     STD_ULOGIC;
      D1  : IN     STD_ULOGIC;
      PRE : IN     STD_ULOGIC;
      Q   : OUT    STD_ULOGIC
   );
   END COMPONENT;
   COMPONENT inv
   PORT (
      I : IN     STD_ULOGIC;
      O : OUT    STD_ULOGIC
   );
   END COMPONENT;
   COMPONENT obuft_hstl_i
   PORT (
      I : IN     STD_ULOGIC;
      T : IN     STD_ULOGIC;
      O : OUT    STD_ULOGIC
   );
   END COMPONENT;

   -- Optional embedded configurations
   -- pragma synthesis_off
   FOR ALL : fdc USE ENTITY unisim.fdc;
   FOR ALL : fdc_1 USE ENTITY unisim.fdc_1;
   FOR ALL : fddrcpe USE ENTITY unisim.fddrcpe;
   FOR ALL : inv USE ENTITY unisim.inv;
   FOR ALL : obuft_hstl_i USE ENTITY unisim.obuft_hstl_i;
   -- pragma synthesis_on


BEGIN
   -- Architecture concurrent statements
   -- HDL Embedded Text Block 1 eb1
   ce_fddr <= wr AND DCM_locked after 1 ns;
   low <= '0';
   high <= '1';

   -- Instance port mappings.
   I2 : fdc
      PORT MAP (
         Q   => CE,
         C   => clk,
         CLR => rst,
         D   => ce_fddr
      );
   I3 : fdc_1
      PORT MAP (
         Q   => D1_fdc,
         C   => clk,
         CLR => rst,
         D   => D1
      );
   I1 : fddrcpe
      PORT MAP (
         Q   => Q1,
         C0  => clk_b_1,
         C1  => clk,
         CE  => high,
         D0  => D0,
         D1  => D1_fdc,
         CLR => rst,
         PRE => low
      );
   I6 : fddrcpe
      PORT MAP (
         Q   => ENVOI_1,
         C0  => clk_b_2,
         C1  => clk,
         CE  => high,
         D0  => wr,
         D1  => wr,
         CLR => low,
         PRE => rst
      );
   I5 : inv
      PORT MAP (
         O => clk_b_1,
         I => clk
      );
   I7 : inv
      PORT MAP (
         O => clk_b_2,
         I => clk
      );
   I4 : obuft_hstl_i
      PORT MAP (
         O => Q,
         I => Q1,
         T => ENVOI_1
      );

END struct;
