-- hds header_start
--
-- VHDL Architecture back_end_fpga.data_mux.rtl_no_clk
--
-- Created:
--          by - st79.UNKNOWN (TE2MALDIVES)
--          at - 14:16:37 01/26/04
--
-- Generated by Mentor Graphics' HDL Designer(TM) 2002.1b (Build 7)
--
-- hds header_end
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY data_mux IS
   PORT( 
      clk2x            : IN     std_logic;
      qdr_FE_data      : IN     std_logic_vector (71 DOWNTO 0);
      qdr_count_data   : IN     std_logic_vector (71 DOWNTO 0);
      qdr_test_data_en : IN     std_logic_vector (1 DOWNTO 0);
      qdr_test_pattern : IN     std_logic_vector (71 DOWNTO 0);
      reset            : IN     std_logic;
      qdr_wr_data      : OUT    std_logic_vector (71 DOWNTO 0)
   );

-- Declarations

END data_mux ;

-- hds interface_end
ARCHITECTURE rtl_no_clk OF data_mux IS
BEGIN

process (reset, clk2x)
	begin
	if reset = '1' then
		qdr_wr_data <= (others => '0') after 1 ns;
	elsif qdr_test_data_en = "01" then				-- select counting data to qdr
		qdr_wr_data <= qdr_count_data after 1 ns;
	elsif qdr_test_data_en = "10" then			-- select 5's and A's pattern data to qdr
		qdr_wr_data <= qdr_test_pattern after 1 ns;	
	else										
		qdr_wr_data <= qdr_FE_data after 1 ns;			-- any other condition use front end data
	end if;
end process;

END rtl_no_clk;
