//  STIM 2  for test
//
// Module chan_twelve.stimulus1.functional
//
// Created:
//          by - wjfg72.UNKNOWN (TE2MANAGUA)
//          at - 11:32:20 11/04/01
//
// Generated by Mentor Graphics' Renoir(TM) 2000.3 (Build 2)
//
// renoir header_end

`resetall
`timescale 1ns/1ps
`include "D:/Xilinx/verilog/src/glbl.v"
// clock 40 MHz
`define per 25	    
`define high 12.5
`define low 12.5

`define load_skew 1
`define load_tick 2
`define load_thresh 4
`define spy_arm 7
`define spy_fire 8
`define load_median 10
`define set_median_enable 11
//`define soft_rst 12
`define load_peddata 13
`define load_pedaddr 14
`define load_numval 15
`define load_mode_reg 16
`define load_scope_length 17
`define monitor 20
`define cdc_thru 21
`define opto_control 22
`define adc_control 23
`define vref_control 24
//`define lm82_control 25
`define load_complement 26


//these are designator values in decimal
`define trigger_select	1	// trigger select reg
`define mode_reg		2	// mode select register
`define ttc_rx_cntl		3	// TTCrx control
`define test_reg		4 	// test Register
`define fe_enable_reg	5	// FE enable register
`define be_rdout_cntl	6	// back end read out control
`define be_run_cntl		7	// back end run control
`define sw_trigger		8	// software trigger
`define soft_rst		9   // software reset
`define fed_id_reg		10	// FED ID register set by software
`define ttc_rx_rst		11	// TTC rx Reset signal
`define lm82_cntl		12	// LM82 control register

`define be_status_reg		16	// Back end status register
`define rd_L1A_count		17	// read L1A counter
`define rd_bx_count			18	// read bunch crossing counter
`define qdr_frame_count		19	// read QDR frame counter
`define TTC_ready			20	// read TTC status register 
`define firmware_id_reg		21	// read firmware ID reg read only = UserCode
`define qdr_data_count		22	// read QDR data counter
`define total_frame_count	23	// read total frame counter
`define ttc_status			24	// TTCrx I2C data in
`define lm82_status			25	// LM82 I2C data in



module toplevel_twelve_stim2( 
   c1_fault, c2_fault, c3_fault, c4_fault, c5_fault, c6_fault, c7_fault, c8_fault, c9_fault, c10_fault, c11_fault, c12_fault, 
   clk, clkB, rstB, serial_in, readout_synch_out, frame_synch_out, enable_apvmux);

parameter DESIGNATOR = 5; // Number of bits in Command Designator
parameter LENGTH_FIELD = 16; // Number of bits in Command Length

// Internal Declarations

output [3:0]  c10_fault;
output [3:0]  c11_fault;
output [3:0]  c12_fault;
output [3:0]  c1_fault;
output [3:0]  c2_fault;
output [3:0]  c3_fault;
output [3:0]  c4_fault;
output [3:0]  c5_fault;
output [3:0]  c6_fault;
output [3:0]  c7_fault;
output [3:0]  c8_fault;
output [3:0]  c9_fault;
output        clk;
output        clkB;
output        rstB;
output        serial_in;
output        readout_synch_out;
output frame_synch_out;
output enable_apvmux;

reg [3:0]  c10_fault;
reg [3:0]  c11_fault;
reg [3:0]  c12_fault;
reg [3:0]  c1_fault;
reg [3:0]  c2_fault;
reg [3:0]  c3_fault;
reg [3:0]  c4_fault;
reg [3:0]  c5_fault;
reg [3:0]  c6_fault;
reg [3:0]  c7_fault;
reg [3:0]  c8_fault;
reg [3:0]  c9_fault;
reg        clk;
reg        rstB;
reg        serial_in;
reg        readout_synch_out;
reg			frame_synch_out;
reg 		enable_apvmux;
integer 	a, b;

always
begin
	#`high	clk = 0;
	#`low	clk = 1;
end

assign clkB = !clk;

/////////////////////////////////////////////////
//    THIS IS THE BEGINNING OF THE STIMULUS    //
/////////////////////////////////////////////////
initial
begin
	set_defaults;
	stimulus2;
end
/////////////////////////////////////////////////

task set_defaults;
begin
	clk = 1;
	rstB = 0;
	c1_fault = 0; c2_fault = 0; c3_fault = 0; c4_fault = 0;
	c5_fault = 0; c6_fault = 0; c7_fault = 0; c8_fault = 0;
	c9_fault = 0; c10_fault = 0; c11_fault = 0; c12_fault = 0;
	serial_in = 0; readout_synch_out = 0;
	frame_synch_out = 0; enable_apvmux = 0;
end
endtask


task stimulus2;
// This one side-steps the autocal procedure (saves time).
// Thereafter anything you like.
begin
	#2 ;
	#`per	;
	#(125*`per)	rstB = 1; // Long reset to allow time for DCM to settle
 	#(2 * `per);

//	#(20 * `per);
	serial_out(1, 1); // set to 1
	serial_out(1, 0); // 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			  // set header bit to 1
	serial_out(1, 0); 			  // set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `fe_enable_reg);	 // wr FE enable registers

	serial_out(1, 1); 		     // set header bit to 1
	serial_out(LENGTH_FIELD, 8);			// Length of argumaent 8 bits
//	serial_out(8, 0);						// = 11111111   all enabled
	serial_out(8, 20);						// send 8 bits followed by the value to be sent all 1's
	serial_out(10, 0);					    // Set serial_in low

	#(20 * `per);
	serial_out(1, 1); 	// set header bit to 1
	serial_out(1, 0); 	// 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set header bit to 1
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `test_reg);	// wr to test_reg	 

	serial_out(1, 1); 		   // set header bit to 1
	serial_out(LENGTH_FIELD, 32);	// Length of argumaent
	serial_out(32, 0);			// 	0x00000000		
	serial_out(10, 0);			// Set serial_in low


	#(30 * `per);
	serial_out(1, 1); 	// set header bit to 1
	serial_out(1, 0); 	// 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set header bit to 1
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `be_rdout_cntl);	// wr to back end read out register	 

	serial_out(1, 1); 		   // set header bit to 1
	serial_out(LENGTH_FIELD, 2);	// Length of argumaent
	serial_out(2, 1);			// 1 = slink, 2 = vlink	0 = disabled		
	serial_out(10, 0);			// Set serial_in low


 	#(20 * `per);
   	serial_out(1, 1); // set header bit to 1
	serial_out(1, 0); // 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set header bit to 1
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `trigger_select);	// wr trigger_select	 

	serial_out(1, 1); 			  // set header bit to 1 
	serial_out(LENGTH_FIELD, 3);	// Length of argumaent
	serial_out(1, 0);	// sw trigger (bit 2)					
	serial_out(1, 1);	// Backplane trigger (bit 1)					
	serial_out(1, 0);	// TTC trigger (bit 0)
	serial_out(10, 0);			// Set serial_in low

	#(30 * `per);	   //wait 
	serial_out(1, 1); 	// set header bit to 1
	serial_out(1, 0); 	// 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set 1st bit to 1 = header
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `sw_trigger);	// wr sw_trigger	 

	serial_out(1, 1); 		     	// set header bit to 1
	serial_out(LENGTH_FIELD, 1);	// Length of argumaent
	serial_out(1, 0);				// write 0			
	serial_out(10, 0);			// Set serial_in low

	#(150 * `per);	   //wait 
	serial_out(1, 1); 	// set header bit to 1
	serial_out(1, 0); 	// 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set 1st bit to 1 = header
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `sw_trigger);	// wr 2nd sw_trigger	 

	serial_out(1, 1); 		     	// set header bit to 1
	serial_out(LENGTH_FIELD, 1);	// Length of argumaent
	serial_out(1, 0);				// write 0			
	serial_out(10, 0);			// Set serial_in low

	#(250 * `per);	   //wait 
	serial_out(1, 1); 	// set header bit to 1
	serial_out(1, 0); 	// 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set 1st bit to 1 = header
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `sw_trigger);	// wr 2nd sw_trigger	 

	serial_out(1, 1); 		     	// set header bit to 1
	serial_out(LENGTH_FIELD, 1);	// Length of argumaent
	serial_out(1, 0);				// write 0			
	serial_out(10, 0);			// Set serial_in low

	#(250 * `per);	   //wait 
	serial_out(1, 1); 	// set header bit to 1
	serial_out(1, 0); 	// 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set 1st bit to 1 = header
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `sw_trigger);	// wr 2nd sw_trigger	 

	serial_out(1, 1); 		     	// set header bit to 1
	serial_out(LENGTH_FIELD, 1);	// Length of argumaent
	serial_out(1, 0);				// write 0			
	serial_out(10, 0);			// Set serial_in low

	#(250 * `per);	   //wait 
	serial_out(1, 1); 	// set header bit to 1
	serial_out(1, 0); 	// 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set 1st bit to 1 = header
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `sw_trigger);	// wr 2nd sw_trigger	 

	serial_out(1, 1); 		     	// set header bit to 1
	serial_out(LENGTH_FIELD, 1);	// Length of argumaent
	serial_out(1, 0);				// write 0			
	serial_out(10, 0);			// Set serial_in low

	#(250 * `per);	   //wait 
	serial_out(1, 1); 	// set header bit to 1
	serial_out(1, 0); 	// 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set 1st bit to 1 = header
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `sw_trigger);	// wr 2nd sw_trigger	 

	serial_out(1, 1); 		     	// set header bit to 1
	serial_out(LENGTH_FIELD, 1);	// Length of argumaent
	serial_out(1, 0);				// write 0			
	serial_out(10, 0);			// Set serial_in low

	#(250 * `per);	   //wait 
	serial_out(1, 1); 	// set header bit to 1
	serial_out(1, 0); 	// 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set 1st bit to 1 = header
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `sw_trigger);	// wr 2nd sw_trigger	 

	serial_out(1, 1); 		     	// set header bit to 1
	serial_out(LENGTH_FIELD, 1);	// Length of argumaent
	serial_out(1, 0);				// write 0			
	serial_out(10, 0);			// Set serial_in low

	#(250 * `per);	   //wait 
	serial_out(1, 1); 	// set header bit to 1
	serial_out(1, 0); 	// 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set 1st bit to 1 = header
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `sw_trigger);	// wr 2nd sw_trigger	 

	serial_out(1, 1); 		     	// set header bit to 1
	serial_out(LENGTH_FIELD, 1);	// Length of argumaent
	serial_out(1, 0);				// write 0			
	serial_out(10, 0);			// Set serial_in low

	#(12 * `per)	enable_apvmux = 1;


end
endtask

task stimulus3;
// This one side-steps the autocal procedure (saves time).
// Thereafter anything you like.
begin
	#2 ;
	#`per	;
	#(125*`per)	rstB = 1; // Long reset to allow time for DCM to settle
 	#(2 * `per);

   	serial_out(1, 1); // set header bit to 1
	serial_out(1, 0); // 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set header bit to 1
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `trigger_select);	// wr trigger_select	 

	serial_out(1, 1); 			  // set header bit to 1 
	serial_out(LENGTH_FIELD, 3);	// Length of argumaent
	serial_out(1, 1);						
	serial_out(1, 0);						
	serial_out(1, 0);						
	serial_out(10, 0);			// Set serial_in low

	#(20 * `per);
	serial_out(1, 1); // set to 1
	serial_out(1, 0); // 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set 1st bit to 1 = header
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `mode_reg);	// wr mode_reg	 

	serial_out(1, 1); 			    // set header bit to 1
	serial_out(LENGTH_FIELD, 4);	// Length of argumaent
	serial_out(1, 0);			// zero suppressed mode
	serial_out(1, 0);			// processed raw mode			
	serial_out(1, 0);			// Set to frame finding mode (virgin)						
	serial_out(1, 1);			// set to scope mode
	serial_out(10, 0);			// Set serial_in low

	#(20 * `per);
	serial_out(1, 1); // set header bit to 1
	serial_out(1, 0); // 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set 1st bit to 1 = header
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `ttc_rx_cntl);	// wr ttc_rx_cntl	 

	serial_out(1, 1); 		     // set header bit to 1
	serial_out(LENGTH_FIELD, 16);	// Length of argumaent
	serial_out(1, 0);			// write 0x06BB			
	serial_out(1, 0);						
	serial_out(1, 0);						
	serial_out(1, 0);						
	serial_out(1, 0);						
	serial_out(1, 1);						
	serial_out(1, 1);						
	serial_out(1, 0);						
	serial_out(1, 1);						
	serial_out(1, 1);						
	serial_out(1, 0);						
	serial_out(1, 1);						
	serial_out(1, 1);						
	serial_out(1, 1);						
	serial_out(1, 0);						
	serial_out(1, 1);						
	serial_out(10, 0);			// Set serial_in low

	#(20 * `per);
	serial_out(1, 1); // set header bit to 1
	serial_out(1, 0); // 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set 1st bit to 1 = header
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `lm82_cntl);	// wr lm82_cntl	 

	serial_out(1, 1); 		     // set header bit to 1
	serial_out(LENGTH_FIELD, 17);	// Length of argumaent
	serial_out(1, 0);			// write 0x00755			
	serial_out(1, 0);						
	serial_out(1, 0);						
	serial_out(1, 0);						
	serial_out(1, 0);						
	serial_out(1, 0);						
	serial_out(1, 1);						
	serial_out(1, 1);						
	serial_out(1, 1);						
	serial_out(1, 0);						
	serial_out(1, 1);						
	serial_out(1, 0);						
	serial_out(1, 1);						
	serial_out(1, 0);						
	serial_out(1, 1);						
	serial_out(1, 0);						
	serial_out(1, 1);						
	serial_out(10, 0);			// Set serial_in low

	#(20 * `per);
	serial_out(1, 1); // set to 1
	serial_out(1, 0); // 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			  // set header bit to 1
	serial_out(1, 0); 			  // set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `fe_enable_reg);	 // wr FE enable registers

	serial_out(1, 1); 		     // set header bit to 1
	serial_out(LENGTH_FIELD, 8);			// Length of argumaent 8 bits
	serial_out(1, 1);						// = 11111111   all enabled
	serial_out(1, 1);						
	serial_out(1, 1);						
	serial_out(1, 1);					
	serial_out(1, 1);		
	serial_out(1, 1);					
	serial_out(1, 1);					
	serial_out(1, 1);				
	serial_out(10, 0);					    // Set serial_in low

	#(20 * `per);
	serial_out(1, 1); // set header bit to 1
	serial_out(1, 0); // 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set header bit to 1
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `be_rdout_cntl);	// wr be_rdout_cntl	 

	serial_out(1, 1); 		   // set header bit to 1
	serial_out(LENGTH_FIELD, 2);	// Length of argumaent
	serial_out(1, 1);			// S-LINK			
	serial_out(1, 0);			// V-LINK			
	serial_out(10, 0);			// Set serial_in low

	#(20 * `per);
	serial_out(1, 1); // set header bit to 1
	serial_out(1, 0); // 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set header bit to 1
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `be_run_cntl);	// wr be_run_cntl	 

	serial_out(1, 1); 		   // set header bit to 1
	serial_out(LENGTH_FIELD, 2);	// Length of argumaent
	serial_out(1, 1);			// 			
	serial_out(1, 1);			// 			
	serial_out(10, 0);			// Set serial_in low

	#(20 * `per);
	serial_out(1, 1); // set header bit to 1
	serial_out(1, 0); // 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set header bit to 1
	serial_out(1, 0); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `test_reg);	// wr to test_reg	 

	serial_out(1, 1); 		   // set header bit to 1
	serial_out(LENGTH_FIELD, 32);	// Length of argumaent
	serial_out(32, 3);			// 	thirty ZEROs & two ONEs		
	serial_out(10, 0);			// Set serial_in low

	#(20 * `per);
	serial_out(1, 1); // set header bit to 1
	serial_out(1, 0); // 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set header bit to 1
	serial_out(1, 1); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `TTC_ready);	// rd TTC_ready	 

	serial_out(1, 1); 		   		// set header bit to 1
	serial_out(LENGTH_FIELD, 1);	// Length of argumaent
	serial_out(1, 0);				
	serial_out(10, 0);				// Set serial_in low

	#(20 * `per);
	serial_out(1, 1); // set header bit to 1
	serial_out(1, 0); // 5 bits to indicate back end fpga (10)
	serial_out(1, 1); 
	serial_out(1, 0); 
	serial_out(1, 1); 
	serial_out(1, 0); 

	serial_out(1, 1); 			// set header bit to 1
	serial_out(1, 1); 			// set rd/wr ie: 1 is read and 0 is write
	serial_out(DESIGNATOR, `firmware_id_reg);	// rd firmware_id_reg	 

	serial_out(1, 1); 		   		// set header bit to 1
	serial_out(LENGTH_FIELD, 32);	// Length of argumaent
	serial_out(1, 0);				
	serial_out(10, 0);				// Set serial_in low

//	#(20 * `per);
	#(12 * `per)	enable_apvmux = 1;

end
endtask



task serial_out;
input [15:0] length;
input [65535:0] value;
integer a;
begin
	for (a = length; a > 0; a = a - 1)
	begin
		serial_in = value[a-1];
		#`per;
	end
end
endtask

endmodule
